#!/usr/bin/perl
########################################################
#                                                      #
# Virtual Visions :: Database Manager v7.0             #
# Released under the GPL on July 30, 2000              #
# Written by Barracuda with portions by Glen Stewart   #
# Email - baracuda@feartech.com                        #
#                                                      #
########################################################

$BASE = "/home/classweb"; # main classweb programs directory
require "$BASE/customize.pl";  # important vars set here

# got http://classweb.ucla.edu/classes/01W/engser100-1/
# want classes/01W/apprentice1-1/private
$relative_dir = "http://classweb.ucla.edu/classes/01W/hist101-1/";
$relative_dir =~ s#.*$ENTRY#$ENTRY#; # /classes/01W/engser100-1/
$relative_dir =~ s/^\///; # classes/01W/engser100-1/
$sdir = "$relative_dir".admin;
$relative_dir =~ s/$/private/; # classes/01W/apprentice1-1/private

# absolute path to the server root
$absolute_dir = "$DOCUMENT_ROOT";


# base path of the whole web server
$base_url = "http://$SERVER_NAME";

# this is the url of this script
$script_url = "$base_url/$sdir/fedit-priv.pl";

# this is the url of the directory that holds your icons
$icon_url = "$base_url$IMAGES";

# how much space (Kb) for this class directory?
$space = 100000;

# allow user to execute their own CGI's?
# see the reference to php, php3,phps,cgi,pl,shtml below to assure that it contains all file types you want to block
$exec_cgi = 'no';

# show file permissions?  (usually only yes if $exec_cgi = 'yes')
$show_chmod = 'no';

# show password tools, control error docs, and allow view/upload2 of files starting with . (eg. .htaccess)?
# - used when the server admin doesn't want users messing with invisible files
$invisibles = 'no';

# unacceptable upload suffixes - retain leading and trailing spaces in this string!
$badsuffixes = " cgi pl php php3 shtml phps ";

########################################################
# Do not change these variables

# this is the path to the root directory; this is where
# the main index.html page is
$root_dir = "$absolute_dir/$relative_dir";

# this is the url equivalent to $root_dir
$root_url = "$base_url/$relative_dir";

#
########################################################

use CGI qw(:standard);
$database = new CGI;
$CGI::POST_MAX=1024 * 5120;

foreach $key ($database->param) {
$value = $database->param($key);
if ($key =~ /new|old|contents|unauthorized|forbidden|notfound|ierror|file[1-5]/) { $binary=1; }
elsif ($value =~ /\~|\`|\!|\#|\$|\%|\^|\&|\*|\(|\)|\+|\=|\{|\}|\[|\]|\<|\>|\;|\,|\|/) { &cgiError ("Bad Characters in Request:", "Please enter only alphanumeric characters."); }
}

$action = $database->param('action');
$subaction = $database->param('subaction');

&check_space;
&free_space unless $action eq "delete" || $action eq "";
&new_file2 unless $action ne "new_file2";
&edit_file unless $action ne "edit_file";
&rename unless $action ne "rename";
&delete_file unless $action ne "delete_file";
&remove_dir unless $action ne "remove_dir";
&make_dir unless $action ne "make_dir";
&upload2 unless $action ne "upload2";
&add_newuser unless $action ne "add_newuser";
&remove_user unless $action ne "remove_user";
&change_userpass unless $action ne "change_userpass";
&modify_pass unless $action ne "modify_pass";
&protect unless $action ne "protect";
&search_replace unless $action ne "search_replace";
&setup_error_docs unless $action ne "setup_error_docs";
&write_error_docs unless $action ne "write_error_docs";
&get_files;

########################################################

&print_header;

print "<table border=\"0\" width=\"100%\"><tr valign=\"top\"><td width=\"75%\"><h4>Location: $dir<br>Last Action: $last_action</h4></td>\n";
print "<td width=\"25%\"><b>Used Space: $used KB<br>Free Space: $free KB</b></td></tr></table>\n";
print "<table width=\"100%\" border=\"0\" cellspacing=\"3\" cellpadding=\"4\" valign=\"top\">\n";
print "<tr valign=\"center\">\n";
print "<td width=\"35%\" bgcolor=\"#000080\"><tt><b><font color=\"White\" size=\"+1\">FILE NAME</font></b></tt></td>\n";
print "<td width=\"15%\" bgcolor=\"#000080\"><tt><b><font color=\"White\" size=\"+1\">SIZE</font></b></tt></td>\n";
print "<td width=\"20%\" bgcolor=\"#000080\"><tt><center><b><font color=\"White\" size=\"+1\">LAST MODIFIED</font></b></center></tt></td>\n";
if ($show_chmod eq 'yes') {
  print "<td width=\"10%\" bgcolor=\"#000080\"><tt><center><b><font color=\"White\" size=\"+1\">CHMOD</font></b></center></tt></td>\n";
}
print "<td width=\"20%\" bgcolor=\"#000080\"><tt><b><font color=\"White\" size=\"+1\">ACTION</font></b></tt></td>\n";
print "</tr>\n\n";

for($i=1; $i<$totalnum; $i++) {

$temp_file = $directories[$i];
if ($temp_file =~ /^\./ && $invisibles eq 'no' && $temp_file ne '..') {next;}
($filesize, $filedate, $fileperm) = (stat($temp_file))[7,9,2];
$fileperm = sprintf "%lo", ($fileperm & 07777);
&getdate2;
	 
  if (-d $temp_file) {
  
	 print "<tr><td><img src=\"$icon_url/folder.gif\"> \n";
	 
		if ($temp_file eq '..') {
		  print "<a href=\"$script_url$back_one\"><b>$temp_file</b></a></td>\n";
		  print "<td>$filesize bytes</td><td><center>$filedate</center></td>";
		  if ($show_chmod eq 'yes') {
		    print "<td><center>$fileperm</center></td>\n";
		  } else {
		    print "\n";
		  }
		  print "<td><a href=\"$script_url$back_one\">Enter</a> Rename Delete</td>\n";
		  }

		else {
		  print "<a href=\"$full_url/$temp_file\">$temp_file</a></td>\n";
		  print "<td>$filesize bytes</td><td><center>$filedate</center></td>";
		  if ($show_chmod eq 'yes') {
		    print "<td><center>$fileperm</center></td>\n";
		  } else {
		    print "\n";
		  }
		  print "<td><a href=\"$script_url?dir=$dir/$temp_file\">Enter</a> <a href=\"javascript:renameFile('$dir/$temp_file')\">Rename</a> <a href=\"javascript:removeDir('$dir/$temp_file')\">Remove</a></td>\n";
		  }

	 print "</tr>\n\n";
  }
  
  else {
  
	 	 ($filename,$ext) = split(/\./,$temp_file);
	 	 
	 	 $icon = "file.gif";
	 	 if ($ext eq 'htm' || $ext eq 'html' || $ext eq 'shtml') { $icon = "html.gif"; }
	 	 if ($ext eq 'txt') { $icon = "txt.gif"; }
	 	 if ($ext eq 'pl' || $ext eq 'cgi' || $ext eq 'php' || $ext eq 'php3' || $ext eq 'phps') { $icon = "cgi.gif"; }
	 	 if ($ext eq 'zip') { $icon = "zip.gif"; }
	 	 if ($ext eq 'exe') { $icon = "exe.gif"; }
		 if ($ext eq 'gif') { $icon = "gif.gif"; }
	 	 if ($ext eq 'jpg') { $icon = "jpg.gif"; }
	 	 if ($ext eq 'png') { $icon = "png.gif"; }
	 
	 print "<tr><td><img src=\"$icon_url/$icon\"> <a href=\"$full_url/$temp_file\">$temp_file</a></td>\n";
	 print "<td>$filesize bytes</td><td><center>$filedate</center></td>";
	 if ($show_chmod eq 'yes') {
	   print "<td><center>$fileperm</center></td>\n";
	 } else {
	   print "\n";
	 }
	 print "<td><a href=\"$script_url?action=edit_file&edit_file=$dir/$temp_file\">Edit</a> <a href=\"javascript:renameFile('$dir/$temp_file')\">Rename</a> <a href=\"javascript:deleteFile('$dir/$temp_file')\">Delete</a></td></tr>\n\n";
	 }
  }

print "</table><br>\n\n";

&print_footer;

################
# sub routines #
################

sub get_files {
	$full_path = $root_dir;
        $full_url = $root_url;

	if ($dir eq "") { $dir = $database->param('dir'); $check_dir = $database->param('dir');}
	else { $check_dir = $dir; }

        if ($dir =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }
	
	if ($check_dir) {
	  $full_path = $absolute_dir . $dir; $full_url = $base_url . $dir; $check_dir =~ s/\/\w*$//;
	  if ($dir eq "$check_dir") { $back_one = "";}
	  else { $back_one = "?dir=$check_dir"; }
	}

        if ($full_path !~ /$root_dir/) {&cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back");}

	if (!$dir) { $dir = "/$relative_dir"; }
	if ($last_action eq '') { $last_action = "Directory Listing: $dir";}
	chdir($full_path);
	opendir (DIR, $full_path) || &cgiError ("Error Reading Directory:", "$!");
	@allfiles = readdir(DIR);
	closedir (DIR);

	for ($x=0; $x<=$#allfiles; $x++) {	
		if (-d $allfiles[$x]) { push(@directories,"$allfiles[$x]"); }
		else { push(@dfiles,"$allfiles[$x]"); }
	}

	@directories = sort { lc($a) cmp lc($b) } @directories;
	@dfiles = sort { lc($a) cmp lc($b) } @dfiles;
	push(@directories,@dfiles);
	
	$totalnum = $#directories; $totalnum++;
}

sub print_header {
print "Content-type: text/html\n\n";

if ($invisibles eq 'no') {
  $pw1="";
  $pw2="";
  $pw3="";
} else {
  $pw1=' | <a href="#passwd">Pass Protect</a>';
  $pw2=' | <a href="javascript:modifyPass()">Modify Pass</a>';
  $pw3=' | <a href="$script_url?action=setup_error_docs">Error Docs</a>';
}

print <<END_PRINT_HEADER;
<html><head><title>Web Manager @ $base_url/$relative_dir</title>
<SCRIPT LANGUAGE="JavaScript">
function deleteFile (filename) { if (window.confirm("Are you sure you want to Delete this File?\\r\\r '" + filename + "'")) { window.location.href = "$script_url?action=delete_file&delete_file=" + filename + "" } }
function removeDir (dirname) { if (window.confirm("Are you sure you want to Remove this Directory?\\r\\r '" + dirname + "'")) { window.location.href = "$script_url?action=remove_dir&remove_dir=" + dirname + "" } }
function renameFile (filename) { var newname = window.prompt("Rename " + filename + " to: ",'' + filename + ''); if (newname != null) { window.location.href = "$script_url?action=rename&rename=" + filename + "&new_name=" + newname +"" } }
function newFile () { var newfile = window.prompt("Create New File:\\r",'$dir/'); if (newfile != null) { window.location.href = "$script_url?action=new_file2&new_file=" + newfile + "" } }
function newDir () { var newdir = window.prompt("Create New Directory:\\r",'$dir/'); if (newdir != null) { window.location.href = "$script_url?action=make_dir&make_dir=" + newdir + "" } }
function changeDir () { var changedir = window.prompt("Go To a Different Directory:",'$dir/'); if (changedir != null) { window.location.href = "$script_url?dir=" + changedir + "" } }
function modifyPass () { var pass = window.prompt("Modify Password In:\\r",'$dir'); if (pass != null) { window.location.href = "$script_url?action=modify_pass&modify_pass=" + pass + "" } }
function deleteUser(userdir) { if (window.confirm("Are you sure you want to Remove this User?\\r\\r" + userdir + "")) { window.location.href = "$script_url?action=remove_hosted&remove_hosted=" + userdir + "" } }
</SCRIPT></head><body bgcolor="#FFFFFF" text="#000000" link="blue" alink="red" vlink="blue">
<center><table border="2" cellpadding="4" cellspacing="0" width="95%">
<tr valign="top"><td width="100%" bgcolor="#000080"><b><font color="white" face="arial">Web Manager @ $base_url/$relative_dir</font></b></td></tr>
<tr><td bgcolor="#999999"><center><a href="$script_url">Home</a>
 | <a href="javascript:changeDir()">Change Dir</a>
 | <a href="javascript:newFile()">New File</a>
 | <a href="javascript:newDir()">New Dir</a>
 | <a href="#upload">Upload</a>
 | <a href="#rep">Find & Replace</a>
$pw1
$pw2
$pw3
 </center></td></tr>
<tr><td bgcolor="#999999">
END_PRINT_HEADER
}

sub print_footer {

if ($invisibles eq 'no') {
  $pw="&nbsp;";
} else {
  $pw="<b>Password Protection</b><br><br><form action=\"$script_url\" method=POST><input type=hidden name=\"action\" value=\"protect\"><b>Directory:</b><br><input type=text size=\"35\" name=\"directory\" value=\"$dir\"><br><br><b>Username:</b><br><input type=text size=\"35\" name=\"username\"><br><br><b>Password:</b><br><input type=text size=\"35\" name=\"password\"><br><br><input type=submit value=\"Protect Directory\"></form>";
}

print <<END_PRINT_FOOTER;
</td></tr><tr><td bgcolor="#999999"><center>
<table border="0" cellspacing="0" cellpadding="15"><tr valign="top"><td nowrap width="100%" colspan="2"><a name="upload"></a><b>File Upload</b><br><br><FORM ENCTYPE="multipart/form-data" ACTION="$script_url" METHOD="POST"><b>File 1: </b><INPUT TYPE="FILE" NAME="file1" SIZE="25">&nbsp;&nbsp;<b>Save As: </b><INPUT TYPE="TEXT" NAME="save_as_1" SIZE="35" VALUE="$dir/"><br><br><b>File 2: </b><INPUT TYPE="FILE" NAME="file2" SIZE="25">&nbsp;&nbsp;<b>Save As: </b><INPUT TYPE="TEXT" NAME="save_as_2" SIZE="35" VALUE="$dir/"><br><br><b>File 3: </b><INPUT TYPE="FILE" NAME="file3" SIZE="25">&nbsp;&nbsp;<b>Save As: </b><INPUT TYPE="TEXT" NAME="save_as_3" SIZE="35" VALUE="$dir/"><br><br><b>File 4: </b><INPUT TYPE="FILE" NAME="file4" SIZE="25">&nbsp;&nbsp;<b>Save As: </b><INPUT TYPE="TEXT" NAME="save_as_4" SIZE="35" VALUE="$dir/"><br><br><b>File 5: </b><INPUT TYPE="FILE" NAME="file5" SIZE="25">&nbsp;&nbsp;<b>Save As: </b><INPUT TYPE="TEXT" NAME="save_as_5" SIZE="35" VALUE="$dir/"><br><br><input type=hidden name="action" value="upload2"><INPUT TYPE="SUBMIT" VALUE="Upload File(s)!"></FORM></td></tr>
<tr valign="top"><td width="50%"><a name="passwd"></a><b>Find & Replace in Matching Files</b><br><br><form action="$script_url" method=POST><b>Directory:</b><br><input type=text name="dir" value="$dir" size="35"><br><br><b>Find:</b><br><input type=text name="old" size="35"><br><br><b>Replace With:</b><br><input type=text name="new" size="35"><br><br><b>File Type:</b><br><input type=text name="type" value="htm html txt" size="35"><input type=hidden name="action" value="search_replace"><br><br><input type=submit value="Find & Replace"></form></td>
<td width="50%"><a name="rep"></a>$pw</td></tr></table></center></td></tr>
</table></center><br></body></html>
END_PRINT_FOOTER
}

sub getdate2 {
@months = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
($min, $hr, $day, $mon, $yr) = (localtime($filedate))[1,2,3,4,5]; 

if ($min < 10) { $min = "0$min"; }
if ($hr < 10) { $hr = "0$hr"; }
if ($day < 10) { $day = "0$day"; }

if ($yr > 99) {
$yr-=100;

if ($yr < 10) { $yr = "200$yr"; }
elsif ($yr >= 10 && $yr < 100) { $yr = "20$yr"; }
else { $yr = "2$yr"; }
}

else {
if ($yr < 10) { $yr = "190$yr"; }
else { $yr = "19$yr"; }
}

$filedate = "$day-$months[$mon]-$yr ($hr\:$min)";
}

sub edit_file {
	if ($subaction eq "edit_file") {
	  $file = $absolute_dir . $database->param('edit_file');
	  $contents = $database->param('contents');
	
	  if ($database->param('rename_file') ) {
	  $file = $absolute_dir . $database->param('rename_file');
	  }
	 
	  if ($file =~ /cgi|pl$/i) { $contents =~ s/\r//g; }

	  open (FILE,">$file") || &cgiError ("Error Saving " . $database->param('edit_file'), "$!");
	  print FILE $contents;
	  close(FILE);
	  
	  if (($file =~ /cgi|pl$/i) && ($exec_cgi eq "yes")) { `chmod 755 $file`; }

	  $last_action = "Wrote: " . $database->param('edit_file');
	  $dir = "$file"."?"; &find_dir;
	  
	}

	else {
	  if ($new_file ne "") {
	    $file = $absolute_dir . $new_file;
	    $filedate = time;
	    &getdate2;
	    if (($new_file =~ ".htm\$") || ($new_file =~ ".html\$")) { 
	      $HTML = "<HTML>\n<HEAD><TITLE>A New Web Page</TITLE></HEAD>\n<BODY BGCOLOR=#FFFFFF>\n<H2>This web page is under construction.</H2>\n<P>\nCreated: $filedate\n<P>\n<HR>\n</BODY>\n</HTML>";
	    }
	    else {
	      $HTML = "";
	    }
	  }
	  else { 
	    $file = $absolute_dir . $database->param('edit_file'); 
	    $new_file = $database->param('edit_file'); 
	    $HTML = "";
	  }
	  
	  $dir = $new_file;
	  $dir =~ s#/[^/]+$##;

	  if (!($file =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	  if ($file =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	  open (FILEC,"$file") || &cgiError ("Error Opening $new_file:", "$!");
	  @datac = <FILEC>;
	  close(FILEC);

	  &print_header;

	  print "<font color=\"black\"><b>Editing: $new_file</b><br><br>\n";
	  print "<blockquote><form action=\"$script_url\" method=POST>\n";
	  print "<textarea cols=\"100\" rows=\"20\" name=\"contents\">$HTML";

	  foreach $line (@datac) {
	  	chomp($line);
	  	$line =~ s/<\/textarea>/&lt;\/textarea&gt;/ig;
	  	print "$line\n";
	  }

	  print "</textarea><br><br>\n";
	  print "By clicking Save File, you will overwrite this file. You can enter a New File Name (with full virtual path) below to save this file as instead of overwriting it.<br><br>\n";
	  print "<b>New File Name:</b> <input type=text size=\"50\" name=\"rename_file\" value=\"$new_file\"><br><br>\n";
	  print "<input type=hidden name=\"edit_file\" value=\"$new_file\">\n";
	  print "<input type=hidden name=\"action\" value=\"edit_file\">\n";
	  print "<input type=hidden name=\"subaction\" value=\"edit_file\">\n";
	  print "<input type=submit name=\"submit\" value=\"Save File\">\n";
	  print "</form></font></blockquote>\n";

	  &print_footer;

	  exit;
	}
}

sub rename {
	$oldname = "$absolute_dir" . $database->param('rename');
	$newname = "$absolute_dir" . $database->param('new_name');

	# why would someone want to rename to anything else?
	$nftype = "htm html txt";
	($nffilename,$nfext) = split(/\./, $newname);
	if ($nftype !~ /$nfext/i) {
	  &cgiError ("You may only rename files to the $nftype extensions.");
	}

	if (!($oldname =~ /$root_dir/)) { &cgiError ($database->param('rename') . "," . $database->param('new_name')  . "Access to File Denied", "You don't have permission to touch my files!"); }
	if ($oldname =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	if (-e $newname) { &cgiError ("Error Renaming " . $database->param('rename') . " to " . $database->param('new_name') . ":", $database->param('new_name') . "already exists"); }

	rename ($oldname, $newname) || &cgiError ("Error Renaming " . $database->param('rename') . " to " . $database->param('new_name') . ":", "$!");

	$last_action = "Renamed: " . $database->param('rename') . " to " . $database->param('new_name');
	$dir = "$newname"."?"; &find_dir;
}

sub delete_file {
	$file_to_delete = "$absolute_dir" . $database->param('delete_file');

	if (!($file_to_delete =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($file_to_delete =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	if (-e $file_to_delete) { unlink ($file_to_delete) || &cgiError ("Error Deleting " . $database->param('delete_file') . ":", "$!"); }
	else { &cgiError ("Error Deleting " . $database->param('delete_file') . ":", $database->param('delete_file') . "does not exist"); }

	$last_action = "Deleted: " . $database->param('delete_file');
	$dir = "$file_to_delete"."?"; &find_dir;
}

sub remove_dir {
	$dir = "$absolute_dir" . $database->param('remove_dir');
	
	if (!($dir =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($dir =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	if (-e $dir) { rmdir ($dir) || &cgiError ("Error Removing " . $database->param('remove_dir') . ":", "$!"); }
	else { &cgiError ("Error Removing " . $database->param('remove_dir') . ":", $database->param('remove_dir') . "does not exist"); }

	$last_action = "Removed: " . $database->param('remove_dir');
	$dir = "$dir"."?"; &find_dir;
}

sub make_dir {
	$dir = "$absolute_dir" . $database->param('make_dir');

	if (!($dir =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($dir =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	if (-e $dir) { &cgiError ("Error Creating " . $database->param('make_dir') . ":", $database->param('make_dir') . "already exists"); }

	mkdir ($dir,0755) || &cgiError ("Error Creating " . $database->param('make_dir') . ":", "$!");
	`chmod 755 $dir`;

	$last_action = "Created: " . $database->param('make_dir'); $dir =~ s/$absolute_dir//g;

}

sub new_file2 {
	$new_file = $database->param('new_file');
	
	# why would someone want to create and edit anything else?
	$nftype = "htm html txt";
	($nffilename,$nfext) = split(/\./, $new_file);
	if ($nftype !~ /$nfext/i) {
	  &cgiError ("You may only make new files with the $nftype extensions.");
	}
	
	$fullNew_file = $absolute_dir . $new_file;

	$action = "edit_file";

	if (!($fullNew_file =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($fullNew_file =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	if (-e $fullNew_file) { &cgiError ("Error Creating $new_file: already exists"); }

	open (FILE,">$fullNew_file") || &cgiError ("Error Creating $new_file:", "$!");
	close(FILE);

	`chmod 644 $fullNew_file`;

	$last_action = "Created: $new_file";
	$dir = "$fullNew_file"."?"; &find_dir;
}

sub upload2 {
	$save_as_1 = $database->param('save_as_1'); $filename = $database->param('file1'); if ((length($save_as_1) > length($root_dir)) && ($filename)) { $save_as = $save_as_1; &do_upload; }
	$save_as_2 = $database->param('save_as_2'); $filename = $database->param('file2'); if ((length($save_as_2) > length($root_dir)) && ($filename)) { $save_as = $save_as_2; &do_upload; }
	$save_as_3 = $database->param('save_as_3'); $filename = $database->param('file3'); if ((length($save_as_3) > length($root_dir)) && ($filename)) { $save_as = $save_as_3; &do_upload; }
	$save_as_4 = $database->param('save_as_4'); $filename = $database->param('file4'); if ((length($save_as_4) > length($root_dir)) && ($filename)) { $save_as = $save_as_4; &do_upload; }
	$save_as_5 = $database->param('save_as_5'); $filename = $database->param('file5'); if ((length($save_as_5) > length($root_dir)) && ($filename)) { $save_as = $save_as_5; &do_upload; }

	$last_action = "Syllabus Upload Was Successful";
	$dir = $absolute_dir . $save_as . "?"; &find_dir;
}

sub do_upload {
	# why would someone want to upload these?
	($nffilename,$nfext) = split(/\./, $save_as);
	if ($badsuffixes =~ / $nfext /i) {
	  &cgiError ("You may not upload files with the $nfext extension.");
	}
	
	$fullSave_as = $absolute_dir . $save_as;

	if (!($fullSave_as =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($fullSave_as =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	open(NEWFILE,">$fullSave_as") || &cgiError ("Error Uploading $save_as:", "$!");
	while(read($filename,$data,1024)) { if ($fullSave_as =~ /cgi|pl$/i) { $data =~ s/\r//g; } print NEWFILE $data; }
	close(NEWFILE);
	close($filename);

	if (($fullSave_as =~ /cgi|pl$/i) && ($exec_cgi eq "yes")) { `chmod 755 $fullSave_as`; }
}

sub search_replace {
	$dir = $absolute_dir . $database->param('dir');
	$new = $database->param('new');
	$old = $database->param('old');
	$type = $database->param('type');

	if (!($dir =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($dir =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	chdir($dir);
	opendir (DIR, $dir) || &cgiError ("Error Searching Directory:", "$!");
	@files = readdir(DIR);
	closedir (DIR);
	
	for ($i=0; $i<=$#files; $i++) {
		$file = "$dir/$files[$i]"; $count=0;

		if (-T $file) {

		($filename,$ext) = split(/\./, $file);

			if ($type =~ /$ext/i) {
			open(READ,"$file") || &cgiError ("Error Reading $file:", "$!");
			@data = <READ>;
			close(READ);

			for ($x=0; $x<=$#data; $x++) {
			if (!($data[$x] =~ /$old/i)) { $touch = 'no'; } 
			else { $data[$x] =~ s/$old/$new/ig; $count++; }
			}

				if ($count != 0) {
				`chmod 644 $file`;
				open (TOFILE,">$file") || &cgiError ("Error Writing File:", "$!");
				flock(TOFILE,2);
				foreach $line (@data) { chomp($line); print TOFILE "$line\n"; }
				flock(TOFILE,8);
				close (TOFILE);
				}
			}
		}
	}
	
	$last_action = "Search and Replace Successful";
	$dir =~ s/$absolute_dir//g;
}

sub find_dir {
	$dir =~ s/\/([^\/]|\n)*\?//g;
	$dir =~ s/$absolute_dir//g;
}

sub cgiError {
	my ($error_cause,$error) = @_;

	if ($error_cause eq "") { $error_cause = "Error:"; }
	if ($error eq "") { $error = "The script encountered problems and terminated"; }

	# default to a safe, known path in header/footer operations
	$dir = "/$relative_dir";
	
	&print_header;
	print "<font color=\"black\"><h3>$error_cause</h3>$error</font><br><br>";
	&print_footer;

exit;
}

sub protect {
	$username = $database->param('username');
	$password = $database->param('password');
	$directory = $absolute_dir . $database->param('directory');

	if (!($directory =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($directory =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	open (HTACCESS,">$directory/.htaccess") || &cgiError ("Error Writing " . $database->param('directory') . "/.htpasswd:", "$!");
	print HTACCESS "AuthUserFile $directory/.htpasswd\n";
	print HTACCESS "AuthGroupFile $directory/.htgroup\n";
	print HTACCESS "AuthName $directory\n";
	print HTACCESS "AuthType Basic\n\n";
	print HTACCESS "<Limit GET>\n";
	print HTACCESS "require group $username\n";
	print HTACCESS "</Limit>\n";
	close(HTACCESS);
	
	open (HTGROUP,">$directory/.htgroup") || &cgiError ("Error Writing " . $database->param('directory') . "/.htgroup:", "$!");
	print HTGROUP "$username: $username";
	close(HTGROUP);

	@salt_chars = ('A' .. 'Z', 0 .. 9, 'a' .. 'z', '.', '/');
	$salt = join '', @salt_chars[rand 64, rand 64];
	$encrypted = crypt($password, $salt);

	open (HTPASSWD,">$directory/.htpasswd") || &cgiError ("Error Writing " . $database->param('directory') . "/.htpasswd:", "$!");
	print HTPASSWD "$username:$encrypted";
	close(HTPASSWD);

	$last_action = "Password Protected: " . $database->param('directory');
	$dir = $database->param('directory'); $dir =~ s/$root_dir\///g;

}

sub modify_pass {
	$dir = $database->param('modify_pass');
	$dir =~ s/\/$//g;
	$modify_pass = "$absolute_dir" . $dir;
	$htpasswd = "$modify_pass/.htpasswd";
	$htgroup = "$modify_pass/.htgroup";

	if (!($modify_pass =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($modify_pass =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }

	if (-e $htpasswd) {
		open (HTPASSWD,"$htpasswd") || &cgiError ("Error Reading " . $database->param('modify_pass') . ".htpasswd:", "$!");
		@htpasswd = <HTPASSWD>;
		close(HTPASSWD);

		&print_header;

		print "<h4>Modify Password: " . $database->param('modify_pass') . ".htpasswd:</h4>\n";
		print "<fieldset><legend> Add User </legend><font color=\"black\"><form action=\"$script_url\" method=POST>\n";
		print "<blockquote><b>Username:</b> <input type=text size=\"35\" name=\"username\"><br><br>\n";
		print "<b>Password:</b> <input type=text size=\"36\" name=\"password\"><br><br><input type=\"hidden\" name=\"action\" value=\"add_newuser\">\n";
		print "<input type=hidden name=\"modify_pass\" value=\"" . $database->param('modify_pass') . "\"><input type=submit value=\"Add User\"></blockquote>\n";
		print "</form></font></fieldset><br>\n\n";
		print "<fieldset><legend> Change Password </legend><font color=\"black\"><form action=\"$script_url\" method=POST><blockquote>\n";
		print "<b>Username:</b> <select name=\"username\">\n";

			foreach $pass (@htpasswd) { chomp($pass); ($user,$password) = split(/\:/,$pass); print "<option value=\"$user\">$user</option>\n"; }

		print "</select><br><br><b>Password:</b> <input type=text size=\"36\" name=\"password\"><br><br>\n";
		print "<input type=hidden name=\"action\" value=\"change_userpass\"><input type=hidden name=\"modify_pass\" value=\"" . $database->param('modify_pass') . "\">\n";
		print "<input type=submit value=\"Change Password\">\n";
		print "</blockquote></form></font></fieldset><br>\n\n";
		print "<fieldset><legend> Remove User </legend><font color=\"black\"><form action=\"$script_url\" method=POST><blockquote>\n";
		print "<b>Username:</b> <select name=\"username\">\n";

			foreach $pass (@htpasswd) { chomp($pass); ($user,$password) = split(/\:/,$pass); print "<option value=\"$user\">$user</option>\n"; }

		print "</select> <input type=hidden name=\"action\" value=\"remove_user\"><input type=hidden name=\"modify_pass\" value=\"" . $database->param('modify_pass') . "\"><input type=submit value=\"Remove User\">\n";
		print "</blockquote></form></font></fieldset><br>\n";

		&print_footer;

	exit;
	}

	else { &cgiError ($database->param('modify_pass') . ".htpasswd Does not Exist:", "Please verify you entered the correct directory"); }
}

sub add_newuser {
	&encrypt;
	
	if (-e ($htpasswd)) {

	open (HTPASSWD,">>$htpasswd") || &cgiError ("Error Adding New User to " . $database->param('modify_pass') . ".htpasswd:", "$!");
	print HTPASSWD "\n";
	print HTPASSWD "$username:$encrypted";
	close(HTPASSWD);
	
	open (HTGROUP,">>$htgroup") || &cgiError ("Error Adding New User to " . $database->param('modify_pass') . ".htgroup:", "$!");
	print HTGROUP " $username";
	close(HTGROUP);

	$last_action = "New User: <i>$username</i> Was Added Successfully";
	}
	
	else { &cgiError ($database->param('modify_pass') . ".htpasswd Does not Exist:", "Please verify you entered the correct directory"); }
}

sub change_userpass {
	&encrypt;
	
	if (-e ($htpasswd)) {
		open(HTPASSWD,"$htpasswd") || &cgiError ("Error Reading " . $database->param('modify_pass') . ".htpasswd:", "$!");
		@data = <HTPASSWD>;
		close(HTPASSWD);
		
		open(HTPASSWD,">$htpasswd") || &cgiError ("Error Writing " . $database->param('modify_pass') . ".htpasswd:", "$!");
		flock(HTPASSWD,2);
		for ($i=0; $i<=$#data; $i++) { if ($data[$i] =~ /$username/) { $data[$i] = "$username:$encrypted"; } }
		foreach $line (@data) { print HTPASSWD "$line"; }
		flock(HTPASSWD,8);
		close(HTPASSWD);

		$last_action = "Password For: <i>$username</i> Was Changed Successfully";
	}
	
	else { &cgiError ($database->param('modify_pass') . ".htpasswd Does not Exist:", "Please verify you entered the correct directory"); }
}

sub remove_user {
	&encrypt;
	
	if (-e ($htpasswd)) {		
		open(HTPASSWD,"$htpasswd") || &cgiError ("Error Reading $htpasswd:", "$!");
		@data = <HTPASSWD>;
		close(HTPASSWD);

		open(HTPASSWD,">$htpasswd") || &cgiError ("Error Writing $htpasswd:", "$!");
		flock(HTPASSWD,2);
		for ($i=0; $i<=$#data; $i++) { if ($data[$i] =~ /$username/) { $data[$i] = ""; } }
		foreach $line (@data) { if (length($line) > 6) { print HTPASSWD "$line"; } }
		flock(HTPASSWD,8);
		close(HTPASSWD);
		
		$data = join("",@data);
		if (length($data) < 6) {
		unlink($htpasswd) || &cgiError ("Error Removing $htpasswd:", "$!");
		unlink($htgroup) || &cgiError ("Error Removing $htgroup:", "$!");
		unlink($htaccess) || &cgiError ("Error Removing $htaccess:", "$!");
		}

		else {
		open(HTGROUP,"$htgroup") || &cgiError ("Error Reading $htgroup:", "$!");
		@data = <HTGROUP>;
		close(HTGROUP);

		open(HTGROUP,">$htgroup") || &cgiError ("Error Writing $htgroup:", "$!");
		flock(HTGROUP,2);
		if ($data[0] =~ /$username/) { $data[0] =~ s/$username //g || $data[0] =~ s/ $username//g; }
		print HTGROUP "$data[0]";
		flock(HTGROUP,8);
		close(HTGROUP);
		}
		
		$last_action = "User: <i>$username</i> Was Removed Successfully";
	}

	else { &cgiError ("$htpasswd Does not Exist:", "Please verify you entered the correct directory"); }
}

sub encrypt {
	$dir = $database->param('modify_pass');
	$dir =~ s/\/$//g;
	$modify_pass = "$absolute_dir" . $dir;
	$username = $database->param('username');
	$password = $database->param('password');
	$htpasswd = "$modify_pass/.htpasswd";
	$htgroup = "$modify_pass/.htgroup";
	$htaccess = "$modify_pass/.htaccess";
	
	@salt_chars = ('A' .. 'Z', 0 .. 9, 'a' .. 'z', '.', '/');
	$salt = join '', @salt_chars[rand 64, rand 64];
	$encrypted = crypt($password, $salt);

	if (!($modify_pass =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($modify_pass =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }
}

sub free_space {
	if ($free <= 0) { &cgiError ("You have used all $space KB of your space", "Please delete a few files to make more space"); }
}

sub check_space {
	use File::Find;
    	&find ( sub { $bytes += -s }, $root_dir );
    	$used = int ($bytes / 1024);
    	$free = ($space - $used);
	
	#foreach $key (sort(keys %ENV)) { $ENV{$key} =~ s/\\/\\\\/g; push(@env_vars,"$key: $ENV{$key}"); }
	#$env_vars = join("\n",@env_vars);
	#$site_info = "Disk Space: $space KB\nUsed Space: $used KB\n--------------------------------------\nFree Space: $free KB";
	#$env = "Home Directory: /$relative_dir\nBase Url: $root_url\n\nEnvironment:\n$env_vars";
	#warn "$site_info\n\n$env";
}

sub setup_error_docs {
	$dir = "/$relative_dir/error_docs";
	$auth_file = "$root_dir/error_docs/unauthorized.htm";
	$forb_file = "$root_dir/error_docs/forbidden.htm";
	$notf_file = "$root_dir/error_docs/notfound.htm";
	$ierr_file = "$root_dir/error_docs/ierror.htm";
	
	if (!($auth_file =~ /$root_dir/ || $forb_file =~ /$root_dir/ || $notf_file =~ /$root_dir/ || $ierr_file =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($auth_file =~ /\.\./ || $forb_file =~ /\.\./ || $notf_file =~ /\.\./ || $ierr_file =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }
	
	if (-e $auth_file) {
	open (AUTH,"$auth_file") || &cgiError ("Opening unauthorized.htm Failed:", "$!");
	@unauthorized = <AUTH>;
	close(AUTH);
	}

	if (-e $forb_file) {
	open (FORBIDDEN,"$forb_file") || &cgiError ("Opening forbidden.htm Failed:", "$!");
	@forbidden = <FORBIDDEN>;
	close(FORBIDDEN);
	}

	if (-e $notf_file) {
	open (NOTFOUND,"$notf_file") || &cgiError ("Opening notfound.htm Failed:", "$!");
	@notfound = <NOTFOUND>;
	close(NOTFOUND);
	}

	if (-e $ierr_file) {
	open (IERROR,"$ierr_file") || &cgiError ("Opening ierror.htm Failed:", "$!");
	@ierror = <IERROR>;
	close(IERROR);
	}

	&print_header;
	print "<h4>Error Document Setup</h4>\n\n";
	print "<blockquote><form action=\"$script_url\" method=POST><input type=hidden name=\"action\" value=\"write_error_docs\">\n";
	print "<b>401 - Unauthorized</b><br><textarea cols=\"85\" rows=\"7\" name=\"unauthorized\">";
		foreach $line (@unauthorized) { chomp($line); print "$line\n"; }
	print "</textarea><br><br><b>403 - Forbidden</b><br><textarea cols=\"85\" rows=\"7\" name=\"forbidden\">";
		foreach $line (@forbidden) { chomp($line); print "$line\n"; }
	print "</textarea><br><br><b>404 - Not Found</b><br><textarea cols=\"85\" rows=\"7\" name=\"notfound\">";
		foreach $line (@notfound) { chomp($line); print "$line\n"; }
	print "</textarea><br><br>\n";
	print "<b>500 - Internal Server Error</b><br><textarea cols=\"85\" rows=\"7\" name=\"ierror\">";
		foreach $line (@ierror) { chomp($line); print "$line\n"; }
	print "</textarea><br><br><input type=submit value=\"Save Error Docs\"></form></blockquote>\n\n";
	&print_footer;

exit;
}

sub write_error_docs {
	$unauthorized = $database->param('unauthorized');
	$forbidden = $database->param('forbidden');
	$notfound = $database->param('notfound');
	$ierror = $database->param('ierror');
	$auth_file = "$root_dir/error_docs/unauthorized.htm";
	$forb_file = "$root_dir/error_docs/forbidden.htm";
	$notf_file = "$root_dir/error_docs/notfound.htm";
	$ierr_file = "$root_dir/error_docs/ierror.htm";
	$htaccess = "$root_dir/.htaccess";
	$error_dir = "$root_dir/error_docs";

	if (!(-e $error_dir)) {
	mkdir ($error_dir,0755) || &cgiError ("Error Creating /$relative_dir/error_docs:", "$!");
	}
	
	if (!($htaccess =~ /$root_dir/ || $error_dir =~ /$root_dir/ || $auth_file =~ /$root_dir/ || $forb_file =~ /$root_dir/ || $notf_file =~ /$root_dir/ || $ierr_file =~ /$root_dir/)) { &cgiError ("Access to File Denied", "You don't have permission to touch my files!"); }
	if ($htaccess =~ /\.\./ || $error_dir =~ /\.\./ || $auth_file =~ /\.\./ || $forb_file =~ /\.\./ || $notf_file =~ /\.\./ || $ierr_file =~ /\.\./) { &cgiError ("You are not allowed to use <b>../</b> as a directory", "Use your browser back button to go back"); }
	
	`chmod 755 $error_dir`;

	open (HTACCESS,">$htaccess") || &cgiError ("Error Creating .htaccess:", "$!");
	if ($unauthorized ne "") { print HTACCESS "ErrorDocument 401 /$relative_dir/error_docs/unauthorized.htm\n"; }
	if ($forbidden ne "") { print HTACCESS "ErrorDocument 403 $root_url/error_docs/forbidden.htm\n"; }
	if ($notfound ne "") { print HTACCESS "ErrorDocument 404 $root_url/error_docs/notfound.htm\n"; }
	if ($ierror ne "") { print HTACCESS "ErrorDocument 500 $root_url/error_docs/ierror.htm"; }
	close(HTACCESS);
	
	open (AUTH,">$auth_file") || &cgiError ("Error Creating unauthorized.htm:", "$!");
	print AUTH "$unauthorized";
	close(AUTH);
	
	open (FORBIDDEN,">$forb_file") || &cgiError ("Error Creating forbidden.htm:", "$!");
	print FORBIDDEN "$forbidden";
	close(FORBIDDEN);
	
	open (NOTFOUND,">$notf_file") || &cgiError ("Error Creating notfound.htm:", "$!");
	print NOTFOUND "$notfound";
	close(NOTFOUND);
	
	open (IERROR,">$ierr_file") || &cgiError ("Error Creating ierror.htm:", "$!");
	print IERROR "$ierror";
	close(IERROR);
	
	$dir = "/$relative_dir/error_docs";
	$last_action = "Error Docs Were Created Successfully";
}
