<?
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
############################################################################
# Name: addadmin.php  
# Usage: called from web; asks for password if one not found 
# Steps: +addadmin.php 
#          -addadmin.php (backend)
#          +makesection.php (creates TA site)
#            -ta_setup.pl (backend)   
#
# Update 08-23-02 Jerome - replaced text with variables for multilingual
# Update 07-20-00 kenny: replaced hardcoded references with customize vars
# Update 04-02-99 mike and Yelena: adding check for admin_uid and other vars
# Update 01-25-99 jason: wrote this but didn't comment it
#
# Status: production
# Purpose: adds designated UID as admin for specified class. $BASE/admin.log is updated, changes and/or errors are noted here.  database is also updated with the new information. 


# initialize global variables, load functions and connect to database
  $BASE="/home/classweb";      # get program directory from Apache Environment  
  
  require "$BASE/customize.inc"; # load in customization info
  require "$BASE/functions.php"; # load in library of functions
  require "$BASE/dbopen.inc";    # connect to database
  require "$BASE/language.php";  # multilingual support
 
  # Check if new admin UID has been passed to script
  if (!$admin_uid) {     #if not, then ask for one
    echo "<form method='post' action='$CLASSES/admin/addadmin.php'>\n";
    echo "<input type='hidden' name='srs' value='$srs'>\n";
    echo "<input type='hidden' name='term' value='$term'>\n";
    echo "<center>\n";
    echo "<font face=\"Arial\">\n";
    echo "<br>\n";
    echo "<big><big>$_ADDCLASSADMINISTRATOR</big></big><p>\n";
    echo "<p><strong>$_UID</strong><br>\n";
    echo "      <input name=\"admin_uid\" value='$admin_uid' size=\"9\"></p>\n";
    echo "<p><strong>$_PASSWORD <font color=\"red\">($_WILLBEIGNORED)</font><br></strong>\n";
    echo "      <input name=\"password\" type=\"password\" size=\"30\"></p>\n";
    echo "<input type='submit' value='$_SUBMIT'> <input type='reset' value='$_RESET'>\n";
    echo "</form>\n</center>\n";
    exit;
  }

  # location of security/password information
  #Check if the ta already has a password in $PASSDIR/classweb
  if(!$password){     # password wasn't passed to script
    # location of security/password information
    $file = file("$PASSFILE");
    $found = 0;
    while ($contents = each($file) ) {
      if(ereg("^$admin_uid", $contents[1])){
        $password = "__PASSWORD__";     # password found in file, set marker
        break;
      }
    }
    if(!$password){     # no password passed or found in file, so ask for one
      echo "<form method='post' action='$CLASSES/admin/addadmin.php'>\n";
      echo "<input type='hidden' name='srs' value='$srs'>\n";
      echo "<input type='hidden' name='term' value='$term'>\n";
      echo "<center>\n";
      echo "<font face=\"Arial\">\n";
      echo "<br>\n";
      echo "<big><big>$_ADDTAASADMIN</big></big><p>\n";
      echo "<form action=\"$CLASSES/admin/makesection.php\" method=\"post\">\n";
      echo "<p><strong>$_TA</strong><br>\n";
      echo "      <input name=\"admin_uid\" value='$admin_uid' size=\"30\"></p>\n";
      echo "<p><strong>$_PASSWORD<br></strong>\n";
      echo "      <input name=\"password\" type=\"password\" size=\"30\"></p>\n";
      echo "<input type='submit' value='$_SUBMIT'> <input type='reset' value='$_RESET'>\n";
      echo "</form>\n</center>\n";
      exit;
    }
  }

  echo "$_USINGTAEXISTINGPASSWORD<p>\n";
 
  # location of classweb 
  system("$BASE/addadmin.pl $term $srs $admin_uid $password WWW", $result);
  # location of log file 
  $fp = fopen("$BASE/admin.log", "a");
  if($result != 0){
    echo "<p>$_RESULT --> $result<p>\n";
  # classweb administrator 
    echo "$_ADDADMINFAILED $CONTACT_ADMIN ";
  # classweb administrator's email 
    echo "<a href=\"mailto:$EMAIL_OF_CLASSWEB_ADMIN\">$EMAIL_OF_CLASSWEB_ADMIN</a>\n";
    echo " $_TELLHIMWHATHAPPENED\n";
    fwrite($fp, "Addadmin($term, $srs, $admin_uid) failed[$result] for $uid at ");
  } else {
    echo "$admin_uid $_GIVENADMINPRIVILEGES ";
    echo "$srs $_FORTHE $term term.\n";
    fwrite($fp, "Addadmin($term, $srs, $admin_uid) succeeded for $uid at ");
  } 

  fwrite($fp, date( "M d, Y H:i:s" ) . "\n");
  fclose($fp);
  system("chmod 0660 $BASE/admin.log");
?>
