<?
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
#######################################################################
# Name:  classadmin.php
# Usage:  called from the web
# Steps:  +classadmin.php
#           +check for valid entered term
#             -display dept. & class listings for selected term
#
# Update 08-23-02 Jerome - replaced text with variables for multilingual
# Update 08-10-00 mike:   commented out links to hand-check syllabi existence &
#                         TAsite creation for now
# Update 04-13-00 kenny:  displays error page if invalid term is given
#                         fixed bug, syllabus icon now displays correctly
# Update 04-11-00 kenny:  merged menu.php and valid.php into classlist.php
# Update 02-11-00 Yelena: can expect term=current, next, previous, 99F (or any
#                         other current term).  will print error message if 
#                         next term not set up yet
# Update 02-01-00 Yelena: will now check current table and set current term if
#                         one was not given in the URL
# Update 11-17-99 mike: single quotes around href's weren't working
#                       for Netscape 1.1
# Update 11-05-99 mike: dropped (term) display in header because it was redundant
# Update 07-28-99 mike: cleaned up display for depts with no class web sites
# Update Yelena: fixed  non-summer classes to sort by crsidx, secidx instead of
#                crsidx alone
# Update 07-12-99 mike & yelena: fixed bad order in non-summer make=1 classlist
# Update 06-21-99 mike: added require function.php and do text Quarter / Year at top
#                       of list for Summer Sessions.
# Update 01-29-99 mike: added "Previous" or "Archive" now in Syllabus column
# Update 09-26-98 Mike: altering to show syllabi.
#                       doesn't show activity and section number if = 1, for 
#                       shorter display
# Update Han Duong: wrote 1st version
#
# Status:  rewriting, merged with menu.php and valid.php
# Purpose: Allows you to create class websites, as well as dump, link, add TA sections and mark syllabus as hand-checked.

# initialize global variables, load functions and connect to database
  $BASE="/home/classweb";      # get program directory from Apache Environment
  require "$BASE/customize.inc"; # load in customization info
  require "$BASE/functions.php"; # load in library of functions
  require "$BASE/dbopen.inc";    # connect to database
  require "$BASE/language.php";  # multilingual support
  $make=1;   # turns on admin functions
?>

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>
<head>
<!--file contains server side includes and commented fields-->
<title>
<?

  # get information from current table
  $qcurrent = mysql_query ("select * from current");
  $current = mysql_fetch_array($qcurrent);
  if(!$term || $term=="current"){
    $term=$current[term];
  } else if ($term=="previous"){
    $term=$current[previous];
  } else if ($term=="next"){
    $term=$current[next];
    if(!$term){
      print"$_CLASSESNOTSETUP\n<br>";
    }
  }
  # check for summer session classes designated by 981, 991, 001, etc.
  if ((substr($term, 2, 1)) == "1"){
    $dterm = substr($term,0,2) . " $_SUMMER";
  } else {
    $dterm = $term;
  }
  $dept = strtoupper($dept);
  echo "$dept $dterm $_CLASSWEBSITEADMINISTRATION"; 
?>
</title>
</head>

<body bgcolor="#FFFFFF" vlink="#000066">
<? 
  # get information from current table
  $qcurrent = mysql_query ("select * from current");
  $current = mysql_fetch_array($qcurrent);

  # check if input term is valid (e.g. 981, 982, 98F, 98W, 98S are valid terms)
  $term = trim($term);
  $length = strlen($term);
  if ($length == 3) {
    $valid = strstr($current[valid], $term);
  } 

  if ($valid) {     #term entered is a valid term      
    ## get info from REGdept table
    $qlookup = query ("select * from REGdept where dept='$dept'");
    $lookup = walk($qlookup);
    
    ?>
    
    <? # display table headers ?>
    <table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="#6699CC"
      <tr>
        <td align="right" valign="top" bgcolor="#000066" width="75">
<a href="<? echo $LOGO_URL; ?>"><img src="<? echo $LOGO; ?>" 
alt="<? echo $LOGO_ALT; ?>" border="0" 
WIDTH="<? echo $LOGO_WIDTH; ?>" 
HEIGHT="<? echo $LOGO_HEIGHT; ?>"></a></td>
    
<td bgcolor="<? echo $SCHOOL_COLOR1; ?>" width="100%" valign="top" align="center">
    <?
            list($qtrname,$fullyear) = expandterm($term);
            echo "<font color=\"$SCHOOL_COLOR2\" size='3' face='Arial,Helvetica'>";
            echo "$qtrname $fullyear";
            echo "</font><br>\n";
    ?>
        <font color="<? echo $SCHOOL_COLOR2; ?>" size="6" face="Arial,Helvetica">
        <b><? echo $MAIN_TITLE; ?></b><br>
        <b><? echo $_CLASSWEBSITEADMINISTRATION; ?></b></font>
    
    <br>
        <font color="<? echo $SCHOOL_COLOR2; ?>" size="5" face="Arial,Helvetica">
        <b><? echo $lookup[lname] ?></b></font><br></td>
      </tr>
    </table>
    <BR><BR><BR>
    <center>
    
    
    <?
    ## if no dept info, retrieve from REGclasses table
      if (!$dept) {
        $qdepart = query ("select distinct dept from REGclasses where term='$term' && 
          dept <> 'ENVIRON' && dept <> 'DEMO'");
        $depart = walk($qdepart);  # $depart array holds class info
        echo "<TABLE BORDER=0 ALIGN=CENTER Width=80% Cellpadding='2'>";
        while ($depart) {
          echo "<tr>";
          $c = 1;
            while ($c < 4){
              $newdept = ereg_replace(" ", "%20", $depart[dept]);
              $qlookup = query ("select * from REGdept where dept='$depart[dept]'");
              $lookup = walk($qlookup);
              if ($lookup) {
                echo "<td align=center><font face=\"Arial,Helvetica\"><a href=\"$PHP_SELF?dept=$newdept&term=$term\"> $lookup[lname]</a></font></td>";
              } else {
                echo "<td align=center><font face=\"Arial,Helvetica\"><a href=\"$PHP_SELF?dept=$newdept&term=$term\"> $depart[dept]</a></font></td>";
              }
              $depart= walk($qdepart);
              if (!$depart) {
                break;
              }
              $c++;
            }
          echo "</tr>";
        }
      } else {   # dept listing
    
        # check if summer session
        if ((substr($term, 2, 3)) == "1"){
          $summer="$_SUMMER_LC/";
          if ($make) {  # special "make" version shows all classes
            $qclass = query ("select a.*,session from REGclasses a left join REGsummer b using (term,srs) where a.term='$term' && dept='$dept' && status <> 'Cancelled' order by session, crsidx");
          } else {   # plain version only shows classes with URLs
            $qclass = query ("select a.*,session from REGclasses a,REGsummer c where a.term='$term' && dept='$dept' && status <> 'Cancelled' && a.term=c.term && a.srs=c.srs && url like '%$term%' order by c.session,a.crsidx");
            #$qclass = query ("select a.*,url,session from REGclasses a,REGurl b,REGsummer c where a.term='$term' && dept='$dept' && status <> 'Cancelled' && a.term=b.term && a.srs=b.srs && a.term=c.term && a.srs=c.srs order by c.session,a.crsidx");
          }
        } else {
          if ($make) {  # special "make" version shows all classes
            $qclass = query ("select * from REGclasses where term='$term' && dept='$dept' && status <> 'Cancelled' order by crsidx");
          } else {   # plain version only shows classes with URLs
            $qclass = query ("select * from REGclasses where term='$term' && dept='$dept' && status <> 'Cancelled' && url like '%$term%' order by crsidx, secidx");
            #$qclass = query ("select * from REGclasses,REGurl where REGclasses.term='$term' && dept='$dept' && status <> 'Cancelled' && REGclasses.term=REGurl.term
    #&& REGclasses.srs=REGurl.srs order by REGclasses.crsidx, REGclasses.secidx");
          }
        }
        $class=walk($qclass);
        if (!$class) {
          $noclass = 1;
          $class[]="";
          echo "<h1>$_NOCLASSSITESFORTHISTERM</h1>\n";
        } else {
          echo "<TABLE VALIGN=TOP BORDER=0 ALIGN=CENTER Width=100%><TR>";
        }
        if ($make) echo "<TABLE VALIGN=TOP BORDER=0 ALIGN=CENTER Width=100%><TR>";
## these two deferred for now
#       if ($make) echo "<TD><B>Syllabus</B></TD>"; # only with permission
#       if ($make) echo "<TD><B>TAsite</B></TD>"; # only with permission
        if ($make) echo "<TD><B>$_WEBSITE</B></TD>"; # only with permission
        if ($make) echo "<TD><B>$_LINK</B></TD>"; # only with permission
        if ($noclass) {
        } else {
          if ($summer) echo "<TD><B>$_SESSION</B></TD>"; # Summer Session only
          echo "<TD><B>$_COURSE</B></TD><TD><B>$_SYLLABUS</B></TD><TD><B>$_INSTRUCTOR_S</B></TD><TD><B>$_COURSETITLE</B></TD></TR>\n";
        }
    
        while ($class) {
          echo "<tr>";
          $qurl = query ("select term,srs,url from REGclasses where term='$class[term]' && srs='$class[srs]' && url like '%$class[term]%'");
          #$qurl = query ("select * from REGurl where term='$class[term]' && srs='$class[srs]'");
          $url=walk ($qurl);
          if ($make) {
## these two deferred for now
#           echo "<TD valign=\"top\"><a href=\"nonclassweb.php?srs=$class[srs]&term=$term\">Syllabus</A></TD>";
#           echo "<TD valign=\"top\"><a href=\"makesection.php?srs=$class[srs]&term=$term\">TA</A></TD>";
            if ($url) {  # only with permission
              echo "<TD valign=\"top\"><a href=\"dump.php?srs=$class[srs]&term=$term\">$_DUMP</A></TD>";
            } else {
              echo "<TD valign=\"top\"><a href=\"make.php?srs=$class[srs]&term=$term\">$_MAKE</A></TD>";
            }
            echo "<TD valign=\"top\"><a href=\"linksite.php?srs=$class[srs]&term=$term\">$_LINK</A></TD>"; # only with permission
          }
    
          if ($summer) echo "<TD align=center valign=top><b>$class[session]</b></TD>"; # Summer Session only
    
          ## Attempt to make shorter coursenum display, in most cases
          echo "<TD valign=\"top\">";
          if ($class[section] == 1) { # don't display activity & section number
            $sectnum = "";
          } else {  # do display activity & section number if not 1
            $sectnum = "-$class[section]";
          }
    
          if ($url) {
            echo "<a href=\"http://$url[url]\">$class[dept] $class[coursenum]$sectnum</a></td>";
          } else {
            echo "$class[dept] $class[coursenum]$sectnum</td>";
          }
    
    ## check for syllabus
          $qsyll = query ("select syllabus from stats where term='$class[term]' && srs='$class[srs]'");
          $syll=walk($qsyll);
          echo '<TD align="center" valign="top">';
          if ($syll) {
            $syllabus = $syll[syllabus];
            if ($syllabus == "YesPrev") {  #  Previous Syllabus
              echo "<b>Previous</b></td>";
            } elseif ((substr($syllabus,0,3) == "Yes")) {
              $syllabus="Yes";
              echo "<img src=\"$IMAGES/syllabus.gif\" width='18' height='18' alt='Syllabus'>";
            } elseif ($syllabus == "Archive") {  #  Syllabus refused
              echo "<b>Archive</b></td>";
            } elseif ($syllabus == "Refuse") {  #  Syllabus refused
              echo "-</td>";
            } else {  # no syllabus present
              echo "&nbsp;</td>";
            }
          } else {  # no stats record found for this class
            echo "&nbsp;</td>\n";
          }
    
    
    ## check for all profs for this class
    # none of the other pages restrict profcode, nor does Artin's setpass
    #     $qmix = query ("select uid, reg_name from REGprof where term='$class[term]' && srs='$class[srs]' && profcode='01'");
          $qmix = query ("select uid, reg_name from REGprof where term='$class[term]' && srs='$class[srs]' && profcode < 3");
          $rows = numrows ($qmix);
          $mix = walk($qmix);
          $c = 1;
          if (!$mix) {
            $mix[]="$_TBA";
          }
          echo "<td valign='top'>";
          while ($mix) {
            $qprofinfo = query ("select * from profsloc where uid='$mix[uid]'");
            $profinfo = walk($qprofinfo);
            if (!$profinfo) {
              $qprofinfo = query ("select * from REGfaculty where uid='$mix[uid]'");
              $profinfo = walk($qprofinfo);
              if (!$profinfo) {
                $profinfo[fullname]=$mix[reg_name];
              }
            }
            echo "$profinfo[fullname]";
            if ( $c < $rows ) {
              echo " / ";
            }
            $c++;
            $mix = walk($qmix);
          }
        echo "</td>";
    
    ## check for changed course title
          $qtitle = query ("select title from classloc where term='$class[term]' &&
            srs='$class[srs]'");
          $title=walk($qtitle);
          if ($title && ($title[title] <> "")) {  # changed title found & not empty
            echo "<td valign='top'><i>$title[title] *</i></td>\n";
            $needasterisk = 1;  # need to show asterisk message at bottom
          } else {       # changed title not found
            echo "<td valign='top'><i>$class[coursetitle] $class[sectitle]</i></td>\n";
          }
        echo "</tr>";
        $class = walk($qclass);
        }
      }
    ?>
    
    
    
    </table>
    </center>
    <?
     if (file_exists("$DOCUMENT_ROOT$CLASSES/$term/$dept.htm")) {
       include("$DOCUMENT_ROOT$CLASSES/$term/$dept.htm");
     }
     if ($needasterisk) { ?>
    <br>
    * <? echo $_COURSETITLECHANGED_FROMOFFICIAL; ?>
    <? } ?>
    
    <font size="2" face="Arial,Helvetica"><p align="center">
    <p><hr width="50%"><p align="center">
    
    <?
      # display lists of all courses in Social Science taught in current quarter
      if ($dept) {
        $newdept = ereg_replace(" ", "%20", $dept);
        echo "<a href=\"$ENTRY/stats.php?term=$term&dept=$newdept\"> $dept $_STATS
    </a> /";
        echo "<a href=\"$PHP_SELF?term=$term\"> $term $_CLASSWEBSITEADMINISTRATION</a> / ";
      }
    ?>
    <a href="../feedback_classweb.php"><? echo $_CLASSWEB_FEEDBACK; ?></a> /
    <a href="<?echo"$ENTRY";?>/"><? echo $_CLASSWEBSITES; ?></a> /

    <!-- <a href="<?echo $DEPT_URL; ?>"><?echo"$DEPT_NAME";?></a> / -->
    <!-- <a href="<?echo"$DIVISION_URL";?>"><?echo"$DIVISION_NAME";?></a> / -->

    <a href="<?echo"$SCHOOL_URL";?>"><?echo"$SCHOOL_NAME";?></a><br>

    </font>
    
    <p align="center">
    <small><small><font face="arial, helvetica">
    <?
    # echo "Updated ";
    # echo date("D M d H:i:s Y", filemtime("valid.php"));
    ?>
    </font></small></small></p>
    
    </body>
    </body></html>
    <?

  } else {     #term entered is an invalid term; display error page
    echo "<body bgcolor=white><H1 align=c$>";
    echo "<p>$_THETERM \"$term\" $_ISANINVALIDTERM </p><br><br>";
    echo "<p>$_ENTERVALIDTERM";
    echo "</body></html>";
  }
?>

