<? 
# joined.php - mike 

# Usage:  joined.php?term=00F
# Update: 08-26-02 Jerome - replaced text with variables for multilingual
# Update: 6-19-00 mike - working including Summer Sessions
#         blank URLs no longer say SAME URL
# Update: 6-16-00 mike and Ben Nicolas starting this program
# Purpose: display potential "joined" classes in a quarter and show which ones
#          already share the same URL
# Steps:
# + Query joined classes with dept, coursenum for a quarter (no URL lookup)
#   building on query in report # 72 
#   http://www.sscnet.ucla.edu/classweb/reports.php?squery=72 
# + loop through class pairs
#   + look up URL for course1 and course2 (might not have URLs)   
#   + display each class with link to URL if it exists
#   + if URLs match, write SAME URL else nothing
#   + check if this pair is in REGxref table (either a,b or b,a)
#     + if they show up, are they joined or not?
#       + if joined column = "Yes" then display JOINED 
#       + if not joined, then display CROSSLISTED 
#  - end
# Status: production

  # initialize global variables, load functions and connect to database
  $BASE="/home/classweb";      # get program directory from Apache Environment  
  
  require "$BASE/customize.inc"; # load in customization info
  require "$BASE/functions.php"; # load in library of functions
  require "$BASE/dbopen.inc";    # connect to database
  require "$BASE/language.php";  # multilingual support

function findurl($term,$srs) {
##  check if given term and srs have a url in REGurl table
  $query2 = mysql_query ("
    select term,srs,url from REGclasses
    where term='$term' && srs='$srs'");
  if ($query2) {
    if ($q2row = mysql_fetch_array($query2)) {
#     echo "term1=$q2row[term] srs=$q2row[srs] url1=$q2row[url]<br>\n";
      return $q2row[url];
    } else {
#     echo "No URL found for $row[term] $row[srs1] <br>\n";
      return "";
    }
  } else {
#   echo "Query Failure!<br>\n";
    return "";
  }
}

if (!$term) $term="00F"; 
if ((substr($term, 2, 1)) == "1"){
  $summer="1";  # Summer Session
} else {
  $summer="0";  # Not Summer Session
}
?>
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>
<head>
<title><? echo $term; ?> <? echo $_POTENTIALJOINEDCLASSES; ?></title>
<BODY BGCOLOR=#FFFFFF>
<center>
<h1><? echo $term; ?> <? echo $_POTENTIALJOINEDCLASSES; ?></h1>
<?
if ($summer) { 
  $query1 = mysql_query ("
  select distinct 
    a.term,
    e.session,
    concat(c.dept,' ',c.coursenum,'-',c.section) as class1,
    c.srs as srs1,
    concat(d.dept,' ',d.coursenum,'-',d.section) as class2, 
    d.srs as srs2
  from REGmeetings a, REGmeetings b, REGclasses c, REGclasses d,
       REGsummer e, REGsummer f 
  where
    a.term='$term' && 
    a.days <> 'UNSCH' && 
    a.bldg <> '' && 
    a.term=b.term && 
    a.days=b.days &&
    a.start=b.start && 
    a.stop=b.stop && 
    a.bldg=b.bldg && 
    a.room=b.room && 
    a.srs<b.srs && 
    a.term=c.term && 
    a.srs=c.srs && 
    b.term=d.term && 
    b.srs=d.srs &&
    a.term=e.term && 
    b.term=f.term &&
    a.srs=e.srs &&
    b.srs=f.srs &&
    e.session=f.session
  order by c.dept,c.coursenum,c.section");
} else {
  $query1 = mysql_query ("
  select distinct 
    a.term,
    concat(c.dept,' ',c.coursenum,'-',c.section) as class1,
    c.srs as srs1,
    concat(d.dept,' ',d.coursenum,'-',d.section) as class2, 
    d.srs as srs2
  from REGmeetings a, REGmeetings b, REGclasses c, REGclasses d 
  where
    a.term='$term' && 
    a.days <> 'UNSCH' && 
    a.bldg <> '' && 
    a.term=b.term && 
    a.days=b.days &&
    a.start=b.start && 
    a.stop=b.stop && 
    a.bldg=b.bldg && 
    a.room=b.room && 
    a.srs<b.srs && 
    a.term=c.term && 
    a.srs=c.srs && 
    b.term=d.term && 
    b.srs=d.srs
  order by c.dept,c.coursenum,c.section");
}

if (!$query1) { ?>
  <H1><? echo $_LOOKUPFAILED; ?></H1>
<?
} else {
  echo "<table>\n";
  $counter = 1;
  while ($row = mysql_fetch_array($query1)) {
## This code fragment will display all the fields retrieved in query
#   while ( list( $key, $val ) = each( $row ) ) {
#     echo "$key => $val<br>";
#    }
#  exit;

##  checking if class1 has a URL
    $url1 = findurl($term,$row[srs1]);

##  checking if class2 has a URL
    $url2 = findurl($term,$row[srs2]);

    echo "<tr>\n";
    echo "<td>",$counter++,"</td>\n";
#   echo "<td><a href=\"/classweb/admin/linksite.php?srs=$row[srs]&term=$row[term]\"><font size=-1>RELINK</font></A></td>\n";
    echo "<td>$row[term]</td>\n";

## display Summer Session if it's a Summer term
    if ($summer) {
      echo "<td>$row[session]</td>\n";
    }

##  display class 1 in column 2 
    if ($url1) {
      echo "<td><a href=\"http://$url1\">$row[class1]</A></td>\n";
    } else {
      echo "<td>$row[class1]</td>\n";
    }
  
##  display class 2 in column 3 
    if ($url2) {
      echo "<td><a href=\"http://$url2\">$row[class2]</A></td>\n";
    } else {
      echo "<td>$row[class2]</td>\n";
    }
  
##  display SAME in column 4 if URLs match
    if ($url1 && ($url1 == $url2)) {
      echo "<td><font color=green>$_SAMEURL</font></td>\n";
    } else {
      echo "<td>&nbsp;</td>\n";
    }
  

## lookup this pair in REGxref
    echo "<td>\n";
    $query3 = mysql_query ("
      select * from REGxref
      where term='$term' && (
        (srs='$row[srs1]' && xsrs='$row[srs2]') or
        (srs='$row[srs2]' && xsrs='$row[srs1]') 
      )");
    if ($query3 && mysql_num_rows($query3) > 0) {
      if ($row3 = mysql_fetch_array($query3)) {
        if ($row3[joinedclass] == "Yes") {
          echo "<font color=red>$_JOINED</font>";
        } else {
          echo "$_CROSSLISTED";
        }
        
      }
    } else {
      echo "&nbsp;";
    }
  
    echo "</td></tr>\n";
  }
  echo "</tr>\n";
}
echo "</table>\n";
?>
</center>
</body>
</html>
