#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: pmailweb.pl
# Purpose: mails letters to TAs or profs in a set of departments

# Update: 09-04-02 Jerome - added require for contenttype.inc
# Update: 08-26-02 Jerome - replaced text with variables for multilingual
# Update: 2-11-00 Cindy Hou- everything seems to be working well.  I think it's # ready.       
# Update: 2-9-00 Cindy Hou got multiple dept checkboxes working
#  Needs testing and cleanup
# Update: 2-4-2000 mike - fixed bug 245 in email, needed quotes around name if
# it had a comma in it, e.g. Franks, Mike <franks@ssc.ucla.edu) was trying to
# send to ID Franks and franks@ssc.ucla.edu. Need quotes around "Franks, Mike"
# Also changed report formatting and info presented to parallel logm

# for 4-27  * check all required fields (message and title)
#           * make sure it works!   -Adam

# 4-26-99 - Adam creates this new script (pmailweb.pl)
#           to provide a way for WebTechs to mass email profs/TAs
#########
### IMPORTANT: Don't expect much of this script to make sense
###	there is a lot of code left over from old scripts that doesn't
###	work and (frankly) isn't called.   -Adam
##
#
# program also uses a log file "pmailweb.log", but it overwrites every time
# and doesn't log date or title of message

## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
$BASE = "/home/classweb"; # main classweb programs directory
require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here
require "$BASE/dbopen.pl";
require "$BASE/dbfuncs.pm";
require "$BASE/language.pl";   # multilingual support

# print "Content-type: text/html\n\n";
require "$BASE/contenttype.inc"; # enable charset

####################################################
#  handle form parameters
read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split('&', $buffer);
foreach $pair(@pairs) {
  $pair =~ tr/+/ /;
  $pair =~ s/%(..)/pack("c",hex($1))/ge;

  ($key, $value) = split('=', $pair);
  if ($key =~ /uid/) { 
    $given_uid = $value;}
   if($key =~ /pass/)
         { $given_pass = $value;}
   if($key =~ /extracc/)
         { $extracc = $value;}   
   if($key =~ /msgtitle/)
         { $msgtitle = $value;}
   if($key =~ /msgbody/)
         { $msgbody = $value;}
   if($key =~ /type/)
         { if ($value eq "TAs") 
            { $targetpop = "mail_TAs_by_dept"; }
           elsif ($value eq "Professors")
            { $targetpop = "mail_profs_by_dept"; }
         }
   if($key =~ /term/)
         {  $given_term = $value; }
   if($key =~ /dept/) { 
     if (defined($given_dept{$key}))  {
       $given_dept{$key} = join (",", $given_dept{$key}, "'$value'");
     } else { 
       $given_dept{$key} = "'$value'"; } # store with single quotes around
     } 
  if($key =~ /name/)
         {  $given_name = $value; }
   if($key =~ /mode/)
         {
	    if($value eq "Give a list of email recipients w/o sending")
	       {  
                  $DEBUG = 1;
	          $test = 1;
                  $no_body = 1;
               }
            elsif ($value eq "Show all emails w/o sending")
	      {
                  $DEBUG = 1;
                  $test = 1;
                  $no_body = 0;
              }
            elsif ($value eq "Send emails")
             {
                  $DEBUG = 0;
                  $test = 0;
                  $no_body = 0;
             } #end if value eq ""
         }  #end of mode testing            

} #end of query string parsing

if ( $ENV{HTTP_REFERER} !~ /pmail.php/ )
{
    print <<ENDHTML;

<HTML><HEAD><TITLE> $_ERROR_ILLEGALACCESS </TITLE></HEAD>
<BODY BGCOLOR="LIGHTGREY"> <H1 ALIGN=CENTER> $_ERROR! </H1>
<P> $_NOPRIVILEGESTOUSE 
$_PLEASESTART <A HREF="pmail.php">$_HERE</A>. </P>
</BODY></HTML>

ENDHTML

 exit(1);

} #end if not from right referer



$cnt = 0;   # Will be used to count messages sent
$|++;    # force immediate output
$DEBUG = 0;
$DEBUG_MAIL = $EMAIL_OF_CLASSWEB_ADMIN;


@letter= split("\n", $msgbody);

# Adam Kaplan throws in functionality to test the validity of
#    all entered information 4/26/99

  # first make sure the user is a WebTech
$cmd = "select type from REGcontacts where uid='$given_uid' && type='WebTech'";
$sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
$rv = $sth->execute || die "Can't execute query: $sth->errstr\n";
$ident = $sth->fetchrow_hashref; 

if ($ident->{type} ne "WebTech")
  {  #we've got an error
    print <<ENDHTML;

<HTML><HEAD><TITLE> $_ERROR_NOTAWEBTECH </TITLE></HEAD>
<BODY BGCOLOR="LIGHTGREY"> <H1 ALIGN=CENTER> $_ERROR! </H1>
<P> $_NOPRIVILEGE_NOTWEBTECH </P>
</BODY></HTML>

ENDHTML

  exit(1);
  } #end of if not WebTech

# check for required fields

if (!($msgtitle) || !($msgbody) )
  {  #user didn't enter all the required fields
    print <<ENDHTML;

<HTML><HEAD><TITLE> $_ERROR_INCOMPLETEFORM </TITLE></HEAD>
<BODY BGCOLOR="LIGHTGREY"> <H1 ALIGN=CENTER> $_ERROR! </H1>
<P> $_REQUIREDFIELDS_NOTFILLED  </P>
</BODY></HTML>

ENDHTML

  exit(1);
  } #end of if incomplete form



# find current_term if necessary
if ( $given_term eq "Current" )
{
  $cmd = "select term from current";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $rv = $sth->execute || die "Can't execute query: $sth->errstr\n";
  $cur = $sth->fetchrow_hashref;
  $current_term = $cur->{term};

} #end of if "Current"


# now we must make sure the password is all good

# if (! system("/info-data/classweb3/authprof_wrap.pl $given_uid $given_pass") )
# {  
#   #they entered an incorrect password
#   
#   print <<ENDHTML;
# <HTML><HEAD><TITLE> Error! Incorrect password </TITLE></HEAD>
# <BODY BGCOLOR="LIGHTGREY"> <H1 ALIGN=CENTER> ERROR! </H1>
# <P> Sorry...You did not enter a correct password.  Please use the back
# button on your browser and re-enter this field. </P> 
# </BODY></HTML>
# 
# ENDHTML
# 
# 
# exit(1);
# } #end if no password match 
 
# finally we derive their email address from their uid
# NOTE only profsloc is used for this

$cmd = "select email from profsloc where uid='$given_uid'";
$sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
$rv = $sth->execute || die "Can't execute query: $sth->errstr\n";
$ident = $sth->fetchrow_hashref;
$given_email = $ident->{email};

if( $given_email !~ /.+@.+/  ) {
  # result was empty, so we try REGfaculty for the address...
  $cmd = "select email from REGfaculty where uid='$given_uid'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $rv = $sth->execute || die "Can't execute query: $sth->errstr\n";
  $ident = $sth->fetchrow_hashref;
  $given_email = $ident->{email};
}

if( $given_email !~ /.+@.+/  )
{  #if not in proper email format exit with error
  print <<ENDHTML;
<HTML><HEAD><TITLE> $_ERROR_INCORRECTEMAIL </TITLE></HEAD>
<BODY BGCOLOR="LIGHTGREY"> <H1 ALIGN=CENTER> $_ERROR! </H1>
<P> $_NOEMAILFOUND  </P>
</BODY></HTML>

ENDHTML

exit(1);

} # end of if invalid email address
if( ! &ccchecker($extracc)   )
{  #if not in proper CC email format exit with error
  print <<ENDHTML;
<HTML><HEAD><TITLE> $_ERROR_INCORRECTCCLIST </TITLE></HEAD>
<BODY BGCOLOR="LIGHTGREY"> <H1 ALIGN=CENTER> $_ERROR! </H1>
<P> $_ILLEGALCCLIST  </P>
</BODY></HTML>

ENDHTML

exit(1);

} # end of if invalid CC list 

print "<HTML><HEAD><TITLE> $_MAILSENT </TITLE></HEAD>\n";
print "<BODY BGCOLOR='LIGHTBLUE'> \n";
print "<p>From: $given_name  &lt;$given_email&gt;<BR> \n" if ($DEBUG);

if ($DEBUG)
{ 
 $out1 = &htmlready($extracc); 
 if ( $given_term eq "Current" )
      {  $out2 = &htmlready($current_term);   }
 else 
      {  $out2 = &htmlready($given_term);   } 
 $out3 = &htmlready($given_dept{dept});

print <<ENDHTML;
  CC LIST = $out1 <BR>
  GIVEN TERM = $out2 <BR>
  GIVEN DEPT = $out3 <BR>
ENDHTML
} #end if DEBUG


unless($test){
	open(LOG,">pmailweb.log") || die("Couldn't open $formletter.log");
}

### The action that used to be in this loop is all happening in sub getprof
###&getprofs;  # real loop now

#send e-mail to the appropriate group of professors
print "<p><B>$_START</B></p>\n "; 
&$targetpop;
print "<p><B>$_END</B></p>\n"; 

unless($test){ 
	close(LOG);
}
if (!$DEBUG)
{
 print <<ENDHTML;
 <H1 ALIGN=CENTER> $_YOUREMAILHASBEENSENT </H1>
 <P> $_THANKYOUFORUSINGSYSTEM  </P>
 </BODY></HTML>
 
ENDHTML
} #end if not DEBUG

exit(0);

###################################################
### Adam Kaplan 4/14/99 
### written for emailing TAs by dept and term 
###################################################
sub mail_TAs_by_dept
{
  #uses $given_term and $given_dept
  if($given_term eq "Current")
  { 
#   $cmd= "select distinct(uid) from REGta where dept='$given_dept' && term='$current_term' order by fullname";

    $cmd= "select distinct(uid) from REGta 
      where term='$current_term' 
      && dept in ($given_dept{dept}) 
      order by fullname";
  }
  elsif($given_term eq "All") {
#   $cmd= "select distinct (uid) from REGta where dept='$given_dept{$key}' order by fullname";
    $cmd= "select distinct(uid) from REGta 
      where dept in ($given_dept{dept}) 
      order by fullname";
  } #end if $given_term eq ""

  $sth = $dbh->prepare($cmd) or die "Can't prepare $cmd: $dbh->errstr\n";
  $rv = $sth->execute or die "Can't execute query: $sth->errstr\n";
  $cnt = 0;
  while($tas = $sth->fetchrow_hashref)
	{
	  $uid = $tas->{uid};
	  # why mandate a 9-digit UID?
	  # next unless $uid =~ /\d{9}/;
	  $cnt++;
          print "<p>#$cnt: \n " unless ($no_body);
	  &get_ta_email;
	}  #end of while 

} #end of sub mail_TAs_by_dept



###################################################
### Adam Kaplan 4/22/99 
### written for emailing profs by dept and term 
###################################################
sub mail_profs_by_dept
{
  #uses $given_term and $given_dept
  if ($given_term eq "Current")
  {
     $cmd= "select distinct(uid) from REGprof 
	     where term='$current_term' 
       && dept in ($given_dept{dept}) 
       order by reg_name";  
  }
  elsif ($given_term eq "All")
  {
     $cmd= "select distinct(uid) from REGprof 
        where dept in ($given_dept{dept})
        order by reg_name";  
  } #end if $given_term eq ""

  $sth = $dbh->prepare($cmd) or die "Can't prepare $cmd: $dbh->errstr\n";
  $rv = $sth->execute or die "Can't execute query: $sth->errstr\n";
  $cnt = 0;
  while($profs = $sth->fetchrow_hashref)
	{
	  $uid = $profs->{uid};
	  # why mandate a 9-digit UID?
	  #next unless $uid =~ /\d{9}/;
	  $cnt++;
	  print "<p> #$cnt: " unless ($no_body);
	  &getemail;
	}  #end of while 

} #end of sub mail_profs_by_dept



####################################################
# mailout subroutine
sub mailout {
      #### process formletter file ####
      $buf = "";

     ### changed 4/16/99 by Adam Kaplan

      if ($targetpop eq "mail_TAs_by_dept" || $targetpop eq "mail_profs_by_dept") {
	$buf = "From: \"$given_name\" <$given_email> \n";
	if ($DEBUG) {
	  $buf .= "Bcc: \"$given_name\" <$given_email>, $extracc\n";
	} else {
	  if ($extracc) {
	    $buf .= "Bcc: $extracc\n";
	  }
	}
      } else {
        $buf = "From: $DEFAULT_SENDER\n";
	if ($DEBUG) {
          $buf .= "Bcc: $DEFAULT_SENDER\n";
	}
      }
      $buf .= "To: \"$name\" <$email>\n"; # 2-4-00 added quotes to fix bug 245
      $buf .= "Subject: $msgtitle\n\n";

#  changed by Adam Kaplan 4/16/99 

      foreach $lline (@letter) {
        $buf .= $lline . "\n";
      }

     # $no_body changes made by Adam Kaplan 4/8/99

	$outbuf = &htmlready($buf);	
      if ($test) {
        print "$outbuf\n" unless $no_body;
        print "<p>**************************************************</p>\n" 
			unless $no_body;
	if($no_body)
	  { 
	 	print "$lastname, $email <br> \n";
	  } # end if no body
      } else {
        # should send email form letter now
          
	  open(MAIL,"|$SEND_MAIL_CMD") || &error("Couldn't open mail program (!$)\n");
          print MAIL $buf;
          close(MAIL);
      }
}

###################
sub getemail {
##  get names & email from both profs and profsloc and pick best
 # assumes $uid variable exists
    $cmdp = "select fullname, email from REGfaculty where uid='$uid'";
    $cmdl = "select fullname, email from profsloc where uid='$uid'";
    $sthp = $dbh->prepare($cmdp) or die "Can't prepare $cmdp: $dbh->errstr\n";
    $sthl = $dbh->prepare($cmdl) or die "Can't prepare $cmdl: $dbh->errstr\n";
    $rvp = $sthp->execute or die "Can't execute query: $sthp->errstr\n";
    $rvl = $sthl->execute or die "Can't execute query: $sthl->errstr\n";

    $name = $email = $pname = $lname = $pemail = $lemail = "";
    if (@data = $sthp->fetchrow_array) {
      $pname  = $data[0] if (!$data[0] =~ /^\s*$/) ;
      $pemail = lc($data[1]) if ($data[1] =~ /.?@.?/);
    }
    if (@datb = $sthl->fetchrow_array) {
      $lname  = $datb[0] if (!$datb[0] =~ /^\s*$/) ;
      $lemail = lc($datb[1]) if ($datb[1] =~ /.?@.?/);
    }
    $name  = ($lname ? $lname : $pname);
    $email = ($lemail ? $lemail : $pemail);

    if ($email =~ /@/) { 
      $lastname = $name;
      $lastname =~ s/^(.*?),.*$/$1/;

# Adam Kaplan 4/22/99

      unless ($test) {
        print     "$_TEST_UC $given_dept{dept} $name ($email) $_SENT_LC $msgtitle\n"; 
        print LOG "$given_dept{dept} $name ($email) sent $msgtitle\n";
      }
      &mailout;
    } else {
      # READY TO LOG AS ERROR
      $cmd3 = "select reg_name from REGprof where uid='$uid'";
      $sth3 = $dbh->prepare($cmd3) or die "Can't prepare $cmd3: $dbh->errstr\n";
      $rv3 = $sth3->execute or die "Can't execute query: $sth3->errstr\n";
    	$name = ($sth3->fetchrow_array)[0];
      print "$name $email $_HASNOEMAIL_UC<br>\n";
      print "<p>**************************************************</p>\n" unless $no_body; 
      
      unless ($test) {
        print     "$name $_HASNOEMAIL_UC\n";
        print LOG "$name HAS NO EMAIL\n";
      }
    }

}

####################################################
# 4/7/99 Created by Adam Kaplan from previous sub
# --to be used for TAs  (ready to test 4/8/99)
####################################################
sub get_ta_email {
##  get names & email from both REGta and profsloc and pick best
 # assumes $uid variable exists
    $cmdp = "select fullname, email from REGta where uid='$uid'";
    $cmdl = "select fullname, email from profsloc where uid='$uid'";
    $sthp = $dbh->prepare($cmdp) or die "Can't prepare $cmdp: $dbh->errstr\n";
    $sthl = $dbh->prepare($cmdl) or die "Can't prepare $cmdl: $dbh->errstr\n";
    $rvp = $sthp->execute or die "Can't execute query: $sthp->errstr\n";
    $rvl = $sthl->execute or die "Can't execute query: $sthl->errstr\n";

    $name = $email = $pname = $lname = $pemail = $lemail = "";
    if (@data = $sthp->fetchrow_array) {
      $pname  = $data[0] if (!$data[0] =~ /^\s*$/) ;
      $pemail = lc($data[1]) if ($data[1] =~ /.?@.?/);
    }
    if (@datb = $sthl->fetchrow_array) {
      $lname  = $datb[0] if (!$datb[0] =~ /^\s*$/) ;
      $lemail = lc($datb[1]) if ($datb[1] =~ /.?@.?/);
    }
    $name  = ($lname ? $lname : $pname);
    $email = ($lemail ? $lemail : $pemail);

    if ($email =~ /@/) { 
      $lastname = $name;
      $lastname =~ s/^(.*?),.*$/$1/;
      # READY TO EMAIL AND LOG

      unless ($test) {
        print     "$given_dept{dept} $name ($email) $_SENT_LC $formletter\n";
        print LOG "$given_dept{dept} $name ($email) sent $formletter\n";
      }
      &mailout;
    } else {
      # READY TO LOG AS ERROR
      $cmd3 = "select fullname from REGta where uid='$uid'";
      $sth3 = $dbh->prepare($cmd3) or die "Can't prepare $cmd3: $dbh->errstr\n";
      $rv3 = $sth3->execute or die "Can't execute query: $sth3->errstr\n";
    	$name = ($sth3->fetchrow_array)[0];
      print "$name $email $_HASNOEMAIL_UC<br>\n";
      print "<p>**************************************************</p>\n" unless $no_body; 
      unless ($test) {
        print     "$name $_HASNOEMAIL_UC\n";
        print LOG "$name HAS NO EMAIL\n";
      }
    }

}

######## HTML conversion bookkeeping subroutine
sub htmlready
{
  my($var) = @_;
  $var =~s/</&lt\;/gm;
  $var =~s/>/&gt\;/gm;
  $var =~s/\n/\n<BR>/gm;
  $var =~s/ /&nbsp\;/gm;
  $var =~s/\t/&nbsp\;&nbsp\;&nbsp\;&nbsp\;&nbsp\;&nbsp\;/gm; 
  return $var; 
}

######### checks that $extracc is ok
sub ccchecker
{
 my($cclist) = @_;
 @ccs = split (',' , $cclist);
 foreach $cc (@ccs)
 { 
   $cc =~ s/^.*<(.+@.+)>\s*$/$1/;
   if ( ($cc !~ /^[^<]+@[^>]+$/) 
       && ($cc ne "")  ) 
    {return 0;} # not in correct format
 } #end foreach
 return 1; #everything is ok
} #end sub ccchecker
