#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
##############################################################################
# Name: compare2dates.pl 
# Usage: compare2dates.pl date1 date2 || compare2dates.pl finaldate
#        Where date1 and date2 are in month/day/year format (ex. 01/02/1999)
#        date1 is the beginning date, and date2 is the ending date
#        finaldate is same as date2
# Purpose: Subroutine that counts the number of days between date1 and date2.
# Notes: A COOL NEW FEATURE request of Mike's in Bug # 119
#        This is called in summary.php
#        It will return -1 if date2 is past date1 or erroneous dates were given
#        Note: Year must be absolute year (1999, not 99).
# Update: 9/22/99, Gavin Yeung created.
# Status: Production
##############################################################################

sub compare2dates {
#####local variables and a hash to convert months to number of days
local($temp, $inputerror, $debug, %month2days, $total, $fromdate, $todate, $frommonth, $tomonth, $fromday, $today, $fromyear, $toyear);
$inputerror = $total = 0;
%month2days = (1 => 31, 2 => 28, 3 => 31, 4 => 30, 5 => 31, 6 => 30,
           7 => 31, 8 => 31, 9 => 30, 10 => 31, 11 => 30, 12 => 31);

#####debug on at 1 off at 0#####
$debug = 1;
$debug = 0;
###########error checking###########
$temp = @_;
if($temp == 2){
  $fromdate = $_[0];
  $todate = $_[1];
} 
elsif($temp == 1){
  $todate = $_[0];
  $fromdate = `date +%m/%d/%Y`;
  chomp($fromdate);
  print "fromdate is $fromdate\n" if $debug;
}
else {
  print "Invalid number of arguments\n" if $debug;
  print "Usage: compare2dates date1 date2 (where date of type 01/02/1999)\n" if $debug;
  #print "-1";
  return (-1);
  #exit;
}
#####get inputs
($frommonth, $fromday, $fromyear) = ( split(/\//,$fromdate) )[0,1,2];
($tomonth, $today, $toyear) = ( split(/\//,$todate) )[0,1,2];
$frommonth =~ s/^0([1-9]+)$/$1/;
$tomonth =~ s/^0([1-9]+)$/$1/;
$fromday =~ s/^0([1-9]+)$/$1/;
$today =~ s/^0([1-9]+)$/$1/;

############################################
print "fromdate is $fromdate :$frommonth/$fromday/$fromyear, todate is $todate :$tomonth/$today/$toyear\n" if $debug;
#################Date Checking#################
if($frommonth < 1 || $frommonth > 12){ $inputerror = 1; }
if($tomonth < 1 || $tomonth > 12){ $inputerror = 1; }
if($fromday < 1 || $fromday > 31){ $inputerror = 1; }
if($today < 1 || $today > 31){ $inputerror = 1; }
if($fromyear < 0){ $inputerror = 1; }
if($toyear < 0){ $inputerror = 1; }
print "Inputerror is $inputerror\n" if $debug;
###year greater
if($toyear < $fromyear){
  $inputerror = 1;
}
###month greater
if($toyear == $fromyear){
  if($tomonth < $frommonth){
    $inputerror = 1;
  }
}
###day greater
if($toyear == $fromyear){
  if($tomonth == $frommonth){
    if($today < $fromday){
      $inputerror = 1;
    }
  }
} #end of outter most if
###output error
if($inputerror){
  print "Dates are in negative\n" if $debug;
  #print "-1";
  #exit;
  return (-1);
}
#####do year calculations#####
while($toyear > ($fromyear + 1) || (($toyear == ($fromyear + 1)) && ($frommonth < ($tomonth + 1))) || (($toyear == ($fromyear + 1)) && ($frommonth == $tomonth) && ($fromday <= $today)) ){
  if(($fromyear % 4) == 0){
    print "Adding 366 days to total, fromyear is $fromyear\n" if $debug;
    $total = $total + 366;
  }
  else{
    $total = $total + 365;
    print "Adding 365 days to total, fromyear is $fromyear\n" if $debug;
  } #end of ifels
  $fromyear++;
}
#####do month calculations#####
while($toyear > $fromyear || $tomonth > ($frommonth + 1) || (($tomonth == ($frommonth + 1)) && ($today >= $fromday)) ){
  $temp = $month2days{$frommonth};
  if((($fromyear % 4) == 0) && ($frommonth == 2) ){
    #leap month year
    $temp = 29;
  }
  print "The temp variable in the months calculations is $temp\n" if $debug;
  $total = $total + $temp;
  if($frommonth == 12){
    $frommonth = 1;
    $fromyear = $fromyear + 1;
  }
  else {
    $frommonth = $frommonth + 1;
  }
}
#####do days calculations#####
if($frommonth != $tomonth){
  $temp = $month2days{$frommonth} - $fromday;
  $temp = $today + $temp;
}
else {
  $temp = $today - $fromday;
}
  $total = $total + $temp;
######end of all calculations#####
  print "The total number of days is $total\n" if $debug;
  #print $total;
  #exit;
  return $total;
###################################################################
}
1
