#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################

##############################################################################
# Name: convert_date.pl
# Usage: convert_date.pl 
# Purpose: This program converts the rostermail.log's date format to the timestamp(14) format in the rostermail table.
#        If an argument is entered, it converts that (assuming that it is
#          in the format "Tue Feb  2 12:34:54 2000" to the timestamp(14)
#          format.  Otherwise, it parses the rostermail.log file
#        This program is writen for bug 194.
#        It returns the format to be put into the database.
# Update: 08/01/00, kenny fong removed hard coded variables
# Update: 01/13/00, Gavin Yeung created.
# Status: Production
##############################################################################

##############################################################################
# The rostermail logfile to parse from
$BASE = "/home/classweb"; # main classweb programs directory    
$LOG_FILE = "$BASE/rostermail.log";

%months = ("Jan" => "01", "Feb" => "02", "Mar" => "03", "Apr" => "04", 
  "May" => "05", "Jun" => "06", "Jul" => "07", "Aug" => "08", "Sep" => "09",
  "Oct" => "10", "Nov" => "11", "Dec" => "12");

open(LOG, "$LOG_FILE") || die "cannot open file, $LOG_FILE : $!";

$numinput = @ARGV;

if($numinput == 1){
  $data = &convert_date($ARGV[0]);
  print $data;
}
else{
  while(<LOG>) {
    $data = &convert_date($_);
    print $data . "\n";
  }
}
close(LOG);
##############################################################################
sub convert_date {
  $arg = $_[0];
  #split it by "|" first, then split it by " "
  @fields = split(/\|/, $arg);
  @dates = split(/ +/, $fields[0]);
 
  #now assign each file to their names
  $month = $dates [1];
  $day = $dates [2];
  ($hour, $minute, $second) = split(/:/, $dates[3]);
  $year = $dates[4];
  
  #day is a special case because be do not get leading zeros for less than ten
  $day = &lessThanTen($day);
  
  $toreturn = $year . $months{$month} . $day . $hour . $minute . $second;
  return $toreturn;
} # end of subroutine 
##############################################################################
# basically, if the parameter passed is less then 10, it will add a leading zero
# and return the parameter with the leading zero added
sub lessThanTen {
  if($_[0] < 10){
    $_[0] = "0" . $_[0];
  }
  return $_[0]
} # end of subroutine
##############################################################################

