#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################

###########################################################################
# Name: preparedate.pl
# Usage: preparedate is called by summary.php
# Purpose: Prepares the dates for compare2dates.pl. This script is created to provide a routine to interface between summary and summary.php and compare2dates.pl. This is so that compare2dates.pl can remain as general as possible.
# Update: 08-27-02 Jerome - replaced text with variables for multilingual
# Update: 9/23/99, Gavin Yeung created
# Status: Production
##########################################################################
$BASE = "/home/classweb"; # main classweb programs directory   
require "$BASE/customize.pl";  # important vars set here       
require "$BASE/language.pl";  # multilingual support
require("$DOCUMENT_ROOT$ENTRY/dates/compare2dates.pl");
local($debug, $term, $termA, $termB, $termC, $result);

###########
$debug = 0;
$summer = 0;

####Input####
$term = shift(@ARGV);

####summer sessions####
if ($term =~ /^([0-9][0-9])1$/){
   $termA = $1 . "1A";
   $termB = $1 . "1B";
   $termC = $1 . "1C";
   $summer = 1;
}

print "term is $term, $termA, $termB, $termC, $summer, $debug\n" if $debug;

############################################################################
###PLEASE add more dates below when the dates run out.######################
###These are the dates of the beginning of each quarter.#################### 
###These dates are taken from the ucla webpage.#############################
###These dates need to be manually updated when the data run out.###########
############################################################################
$reg{"00W"} = "1/10/2000";
$reg{"00S"} = "4/3/2000";
$reg{"001A"} = "6/26/2000";
$reg{"001B"} = "7/17/2000";
$reg{"001C"} = "8/7/2000";
$reg{"00F"} = "9/28/2000";
$reg{"01W"} = "1/8/2001";
$reg{"01S"} = "4/2/2001";
$reg{"011A"} = "6/25/2001";
$reg{"011B"} = "7/16/2001";
$reg{"011C"} = "8/6/2001";
$reg{"01F"} = "9/27/2001";
$reg{"02W"} = "1/7/2002";
$reg{"02S"} = "4/1/2002";
$reg{"99F"} = "9/30/1999";

##################################################
if ($reg{$term} || $summer) {
  if($summer != 1){
    $result = &compare2dates($reg{$term});
    if($result != -1){
      print "<b>$_THEREARE $result $_DAYSUNTIL $term $_BEGINS.</b><br>\n";
    } # end of inner if
  } 
  else {
    print "calculating summer session\n" if ($debug);
    $result = &compare2dates($reg{$termA});
      if($result != -1){
        print "<b>$_THEREARE $result $_DAYSUNTIL $term $_SESSION_A $_BEGINS.</b><br>\n";
      } # end of if
    $result = &compare2dates($reg{$termB});
      if($result != -1){
        print "<b>$_THEREARE $result $_DAYSUNTIL $term $_SESSION_B $_BEGINS.</b><br>\n";
      } # end of if
    $result = &compare2dates($reg{$termC});
      if($result != -1){
        print "<b>$_THEREARE $result $_DAYSUNTIL $term $_SESSION_C $_BEGINS.</b><br>\n";
      } # end of if
 } # end of else
   #print "<tr><td>99F</td><td>$result</td></tr>\n";
} # end of main if
