#!/usr/local/bin/perl
####################################################################
# forgot_pw.pl
# Purpose: sends new password to students/faculty who forgot them
# Update 09-04-02 Jerome - added require for contenttype.inc
# Update 08-21-02 Jon: substituted text with variables for Multilingual support

## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
$BASE = "/home/classweb"; # main classweb programs directory
require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here
require "$BASE/dbopen.pl";
require "$BASE/dbfuncs.pm";
require "$BASE/language.pl";   # multilingual support
use CGI qw(:standard);

# print "Content-type: text/html\n\n";
require "$BASE/contenttype.inc"; # enable charset
$email=param('email'); # what we look to change
$referer=param('referer'); # referer tracking for round-robin sites
$remote=param('remote'); # IP tracking for abuse
$classID=param('classID'); # just for tracking purposes and term
$term=substr($classID,0,3);
$student=param('student'); # whether we read from REGrosters or REGfaculty/profsloc/REGta

if($student eq "1"){
  $cmd = "select email,uid from REGrosters where email='$email' && term='$term'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  if(@data = $sth->fetchrow_array){
        &send_message;
  } else {
        print "<HTML><HEAD><TITLE>$_NEWPASSWORDSENT</TITLE></HEAD><BODY BGCOLOR=#FFFFFF>\n";
        print "<h3 align=center>$_EMAILNOTONFILE";
        print "<a href=\"$ENTRY/feedback_classweb.php\">$_CLASSWEB_FEEDBACK</a> $_TOREQUESTHELP.</h3>";
        print "</body></html>\n";
  }
} else {
  $cmd = "select email,uid from REGfaculty where email='$email'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  if(@data = $sth->fetchrow_array){
        &send_message;
  } else {
    $cmd = "select email,uid from profsloc where email='$email'";
    $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    if(@data = $sth->fetchrow_array){
        &send_message;
    } else {
      $cmd = "select email,uid from REGta where email='$email' && term='$term'";
      $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
      $sth->execute || die "Can't execute query: $sth->errstr\n";
      if(@data = $sth->fetchrow_array){
        &send_message;
      } else {
        print "<HTML><HEAD><TITLE>$_NEWPASSWORDSENT</TITLE></HEAD><BODY BGCOLOR=#FFFFFF>\n";
        print "<h3 align=center>$_EMAILNOTONFILE";
        print "<a href=\"$ENTRY/feedback_classweb.php\">$_CLASSWEB_FEEDBACK</a> $_TOREQUESTHELP.</h3>";
        print "</body></html>\n";
      }
    }
  }
}
exit;

sub send_message {
  local($msg);
    
  $passwd="cw" . int ((rand)*10000000);
  $uid=@data[1];
  if($student eq "1"){
    system"$HTPASSWD -b $PASSTUDENT $uid $passwd";
  } else {
    system"$HTPASSWD -b $PASSFILE $uid $passwd";
  }
  
  $body=" A web browser originating from $remote has visited the Classweb pages at
  $referer
and has requested that a new password be emailed to you.\n\n
Your User ID is \"$uid\"\n
Your Password has been changed to \"$passwd\" - please remember this.\n\n
If this request was not from you, please report this abuse immediately to
  $DEFAULT_SENDER\n\n
You should begin using the new password now.";

  $msg = "From: $DEFAULT_SENDER\n";
  $msg .= "To: $email\n";
  $msg .= "Subject: Classweb Password Change\n\n";
  $msg .= $body;

  open(MAIL,"| $SEND_MAIL_CMD");
  print MAIL "$msg";
  close(MAIL);

  print "<HTML><HEAD><TITLE>$_NEWPASSWORDSENT</TITLE></HEAD><BODY BGCOLOR=#FFFFFF>\n";
  print "<h3 align=center>$_NEWPASSWORDSENT_CHECKEMAIL</h3>";
  print "</body></html>\n";
}
