#!/usr/local/bin/perl
####################################################################
# pre-enroll.pl
# Purpose: sends pre-enrollment info to Class Registrar & to file
# Update 09-04-02 Jerome - added require for contenttype.inc
# Update 08-21-02 Jon: substituted text with variables for Multilingual support

$BASE = "/home/classweb"; # main classweb programs directory
require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here
require "$BASE/dbopen.pl";
require "$BASE/dbfuncs.pm";
require "$BASE/language.pl";   # multilingual support
use CGI qw(:standard);

# print "Content-type: text/html\n\n";
require "$BASE/contenttype.inc"; # enable charset
$email=param('email');
$lastname=param('lastname');
$firstname=param('firstname');
$middlename=param('middlename');
$suffix=param('suffix');
$remote=param('remote'); # IP tracking for abuse
$srs=param('srs');
$term=param('term');

$cmd = "select uid from REGprof where term='$term' && srs='$srs' && profcode='4'";
$sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
$sth->execute || die "Can't execute query: $sth->errstr\n";
@data = $sth->fetchrow_array;
$registraruid=@data[0];

$cmd = "select email from REGfaculty where uid='$registraruid'";
$sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
$sth->execute || die "Can't execute query: $sth->errstr\n";
@data = $sth->fetchrow_array;
$registraremail=@data[0];

$cmd = "select dept,coursenum,section from REGclasses where term='$term' && srs='$srs'";
$sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
$sth->execute || die "Can't execute query: $sth->errstr\n";
@data = $sth->fetchrow_array;
$dept=@data[0];
$coursenum=@data[1];
$section=@data[2];

$cmd = "select dirname from REGdept where dept='$dept'";
$sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
$sth->execute || die "Can't execute query: $sth->errstr\n";
@data = $sth->fetchrow_array;
$deptdir=@data[0];

$preenroll="$term/$deptdir$coursenum-$section/pre-enroll.txt";
$header=0;
if (!-e $preenroll){
  $header=1;
}

my ($sec,$min,$hour,$mday,$mon,$year) = (localtime(time))[0,1,2,3,4,5];
if ($hour < 10) { $hour = "0$hour"; }
if ($min < 10) { $min = "0$min"; }
if ($sec < 10) { $sec = "0$sec"; }
if ($year > 99) { $year = ($year-100); }
if ($year < 10) { $year = "0$year"; }
$mon++;  # to go from 0-11 to 1-12
$date = "$mon-$mday-$year $hour:$min";  # want shorter format for log

$date1=pack("A15", "Date");
$email1=pack("A51", "Email");
$lastname1=pack("A36", "Last name");
$firstname1=pack("A36", "First name");
$middlename1=pack("A36", "Middle name");
$suffix1=pack("A11", "Suffix");
$remote1=pack("A16", "IP");

$date2=pack("A15", "----");
$email2=pack("A51", "-----");
$lastname2=pack("A36", "---------");
$firstname2=pack("A36", "----------");
$middlename2=pack("A36", "-----------");
$suffix2=pack("A11", "------");
$remote2=pack("A16", "--");

$date3=pack("A15", "$date");
$email3=pack("A51", "$email");
$lastname3=pack("A36", "$lastname");
$firstname3=pack("A36", "$firstname");
$middlename3=pack("A36", "$middlename");
$suffix3=pack("A11", "$suffix");
$remote3=pack("A16", "$remote");


open(PE,">>$preenroll");
if ($header){
  print PE "The following people have requested enrollment in $term $deptdir$coursenum-$section:\n\n";
  print PE "$date1$email1$lastname1$firstname1$middlename1$suffix1$remote1\n";
  print PE "$date2$email2$lastname2$firstname2$middlename2$suffix2$remote2\n";
}
print PE "$date3$email3$lastname3$firstname3$middlename3$suffix3$remote3\n";
close(PE);

&send_message;

print "<HTML><HEAD><TITLE>$_PREENROLL_REQRECEIVED</TITLE></HEAD><BODY BGCOLOR=#FFFFFF>\n";
print "<h3 align=center>$_PREENROLL_REQHASBEENRECEIVED</h3><P><center>\n";
print "$_QUESTIONS_PREENROLL <a href=\"mailto:$registraremail\">$_CLASSREGISTRAR</a>\n";
print "</center></body></html>";

exit;

sub send_message {
  local($msg);
    
  $body=" A web browser originating from $remote has visited the ClassWeb
$term $deptdir$coursenum-$section Pre-Enrollment web page and has sent the following 
information to you.\n\nFormat:\n";
  $body .= "Date, Email, Last name, First name, Middle name, Suffix, IP\n";
  $body .= "$date, $email, $lastname, $firstname, $middlename, $suffix, $remote\n\n";
  $body .= "You can always see the complete list of Pre-Enrollment requests by visiting
http://$SERVER_NAME$ENTRY/$term/$deptdir$coursenum-$section/pre-enroll.txt\n\n";
  $body .= "If this message was sent to you in error, please forward it immediately to
  $DEFAULT_SENDER\n\n
Thank You!";

  $msg = "From: $DEFAULT_SENDER\n";
  $msg .= "To: $registraremail\n";
  $msg .= "Subject: Classweb Pre-Enrollment Request: $term $deptdir$coursenum-$section\n\n";
  $msg .= $body;

  open(MAIL,"| $SEND_MAIL_CMD");
  print MAIL "$msg";
  close(MAIL);
}
