#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# rostermail.pl
# Purpose: sends email to students on roster and adds notice in Announcements

# Update 09-04-02 Jerome - added require for contenttype.inc
# Update 08-21-02 Jon: substituted text with variables for Multilingual support
# 1-18-00 Gavin added support for database logging
# 1-18-00 Adam fix open announcement problem
# 10-12-99 Mike - got a call about "internal error" and it wouldn't compile
#   I think Gavin worked directly on this one by mistake and didn't finish
#   making changes
#   code fork was make to rostermail.ta.pl
# 10-4-99 Adam - fixes/adds checks for invalid email addresses
# 4-21-99 Mike & Adam - should work for profs and TAs, anyone in admin
#         - links at end work now
# 4-12-99 Adam - changing to allow special routines depending on whether
#  	user comes from TA page or normal page
# 4-9-99  Adam - changing to allow any authorized TA/prof/admin
#  	with valid email address to use this system
#
# 1-20-99 mike - fixed bug where commas in student emails were causing "Internal
#                Errors"
# 11-5-98
#  originally written by Jason Schroeder. 
#  Modified by Artin Rebekale to also add announcement to Announcements page.


## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
$BASE = "/home/classweb"; # main classweb programs directory
require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here
require "$BASE/dbopen.pl";
require "$BASE/dbfuncs.pm";
require "$BASE/language.pl";   # multilingual support


$LOG_FILE = "$BASE/rostermail.log";
$MAX_LINE_LEN = 512 - length("Bcc: ");
$eaddresses = "";
$hold = $waitlist = $ta = $addannounce = 0;
# $debug = 1;
$debug = 0;

# in order to use this program one must be logged in as
# (any one of) the instructor(s) for this class.

# print "Content-type: text/html\n\n";
require "$BASE/contenttype.inc"; # enable charset

#print "BASE= $BASE<br>";

if($ENV{'REQUEST_METHOD'} eq 'GET'){
  $buffer = $ENV{'QUERY_STRING'};
} else {
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}

@pairs = split(/&/,$buffer);
foreach (@pairs) {
  ($name,$value) = split(/=/,$_);
  $value =~ tr/+/ /;
  $name =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
  $form{$name} = $value;
  print "\$form{<i>$name</i>} = <b>$value</b><br>\n" if($debug);
}

if(defined($form{"ta_portal"})){
  $cmd = "select * from REGclasses 
          where srs='$form{'srs'}' && term='$form{'term'}'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  if(@data = $sth->fetchrow_array){
    # how do I make this so it does only one!
    # this is not done!
    $cmd2 = "select dirname from REGdept where dept = '$dept'";
    $sth2 = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth2->execute || die "Can't execute query: $sth2->errstr\n";
    if(@data2 = $sth2->fetchrow_array){
      $data[2] = 
      $referer = "http?:\/\/$SERVER_NAME\/";
      # $referer = $referer . $data[0] . $   # mike commented this out
    } # mike added this to get it to compile
  } # mike added this to get it to compile
} else {
  # Adam Kaplan adding REFERER vars 4/21/99
  $referer = $ENV{HTTP_REFERER};
  $referer =~ s/^(http?:\/\/$SERVER_NAME\/.*)\/admin\/.*$/$1/;
}

$ta = 1 if(defined($form{"ta"}) && $form{"ta"} eq "on");
$waitlist = 1 if(defined($form{"wait-list"}) && $form{"wait-list"} eq "on");
$hold = 1 if(defined($form{"hold"}) && $form{"hold"} eq "on");
$addannounce = 1 if(defined($form{"announce"}) && $form{"announce"} eq "on");

# added 4/12/99 Adam Kaplan
$profuid = $ta_uid = $form{"ta_uid"};

###########
## commented out 4/9/99 Adam Kaplan
###########
# $debug || &check_id();

# added 4/12/99 Adam Kaplan
if ($ta_uid){ 
  &get_eaddresses_tasecs();
} else { 
  &get_eaddresses(); 
}

&add_ta_addresses() if($ta);
&format_bcc_line();
&get_prof_info();
&get_course_info();
print "<p>referer = $referer\n" if ($debug);
exit(0) if ($debug);

&send_message();
&addannounce if ($addannounce == 1);

&log();
exit(0);

##############
######### 4/9/99  Adam Kaplan has disabled sub check_id
#########    because validation of prof identity no longer 
#########    required
#############
sub check_id {
  local($isprof) = 0;
  $cmd = "select * from addadmin 
          where srs='$form{'srs'}' && term='$form{'term'}'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  if(@data = $sth->fetchrow_array){
    $isprof = 1 if($data[0] eq $form{'profuid'});
  }
  $cmd = "select uid from REGprof 
          where srs='$form{'srs'}' && term='$form{'term'}'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";

  while(@data = $sth->fetchrow_array){
    $isprof = 1 if($data[0] eq $form{'profuid'});
  }

  if(!$isprof){
    print "$_SORRY_MUSTBEPROF\n";
    exit(0);
  }
}

sub format_bcc_line {
  local($buffer, $len, @addr);
  return if(length($eaddresses) <= $MAX_LINE_LEN);
  @addr = split(/,/, $eaddresses);
  $len = 0;
  foreach(@addr){
    if($len + length($_) > $MAX_LINE_LEN){
      $buffer .= "\n\t$_,";
      $len = 0;
    } else {
      $buffer .= "$_,";
    }
    $len += length($_);
  }
  # chop($buffer);
  $eaddresses = $buffer;
}

#### 4/9/99 Adam Kaplan notes:
##### now check is done here to make sure email addresses are in
##### correct format

sub add_ta_addresses {
  local($cmd, $sth, @data);
  local($sth2, $email, $srs, $q);
  local(%hash);#used to remove duplicate e-mail addresses

  $q = "select dept,coursenum,secidx from REGclasses 
        where term='$form{'term'}' && srs='$form{'srs'}'";
  $sth = $dbh->prepare($q) || die "Can't prepare $q: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
 
  while((@data = $sth->fetchrow_array)){ 
    $cmd = "select distinct(email), uid from REGta 
            where term='$form{'term'}' && dept='$data[0]' && 
                  coursenum='$data[1]' && relsecidx='$data[2]'";
    print "cmd --> $cmd<br>\n" if($debug);
    $sth2 = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth2->execute || die "Can't execute query: $sth->errstr\n";
    while (@tainfo =  $sth2->fetchrow_array) {
      $foundinprofsloc = 0;
      $cmdprfsloc = "select distinct(email), uid from profsloc 
                     where uid = '$tainfo[1]'";
      $sth3 = $dbh->prepare($cmdprfsloc) || die "Can't prepare $cmdprfsloc: $dbh->errstr\n";
      $sth3->execute || die "Can't execute query: $sth->errstr\n";
      while (@prfslocinfo = $sth3->fetchrow_array) {
        $hash{$prfslocinfo[0]} = 1;
        $foundinprofsloc = 1;
      } #endwhile
      print "Adding regular ta $email<br>\n"  if($debug);
      if ($foundinprofsloc == 0) {
        $hash{$tainfo[0]} = 1;
      }
    }
  }
  $cmd = "select xsrs from REGxref 
          where srs='$form{'srs'}' && term='$form{'term'}'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  while(($srs = ($sth->fetchrow_array)[0])) {
    $q = "select dept,coursenum,secidx from REGclasses 
          where term='$form{'term'}' && srs='$srs'";
    $sth = $dbh->prepare($q) || die "Can't prepare $q: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    $cmd = "select distinct(email), uid from REGta 
            where srs='$srs' && term='$form{'term'}'";
    $sth2 = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth2->execute || die "Can't execute query: $sth->errstr\n";
    while (@tainfo =  $sth2->fetchrow_array) { 
      $foundinprofsloc = 0;
      $cmdprfsloc = "select distinct(email), uid from profsloc where uid = '$tainfo[1]'";
      $sth3 = $dbh->prepare($cmdprfsloc) || die "Can't prepare $cmdprfsloc: $dbh->errstr\n";
      $sth3->execute || die "Can't execute query: $sth->errstr\n";
      while (@prfslocinfo = $sth3->fetchrow_array) {
        $hash{$prfslocinfo[0]} = 1;
        $foundinprofsloc = 1;
      } #endwhile
      print "Adding regular $_TA $email<br>\n"  if($debug);
      if ($foundinprofsloc == 0) {
        $hash{$tainfo[0]} = 1;
      }
    }
  }
  foreach $email (keys(%hash)){
    if ( ($email !~ /^$/ ) && (($email =~ /,/) || ($email !~ /^[^;]+@[^;\.][^;]+$/ ))) {
      print "<font color=red><b>TA - $email</b> $_INVALIDEMAIL_ASKTA<br></font>\n";
    } else{
      $eaddresses .= "$email,";
    }
  }
}
##### 
###### 4/9/99  Adam Kaplan notes
######    now check is done here to ensure email addresses
######   	are in correct format
sub get_eaddresses(){
  local($xsrs);
  $cmd = "select email, enroll_status, lastname, firstname from REGrosters 
          where srs='$form{srs}' && term='$form{term}'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";

  while((@data = $sth->fetchrow_array)) {
    next if(!$hold && $data[1] eq "H");
    next if(!$waitlist && $data[1] eq "W");
    next if($data[1] eq "D");

    # $eaddresses .= "$data[0]," if($data[0]);
    # I think commas in the email addresses are causing the Internal Error.
    if ($data[0] =~ /^$/) {
      $noemails .= "$data[3] $data[2], ";
    } elsif ( ($data[0] =~ /,/) || ($data[0] !~ /^[^;]+@[^;\.][^;]+$/ ) ) {
      print "<font color=red><b>$_STUDENT $data[3] $data[2] - $data[0]</b> $_INVALIDEMAIL_ASKSTUDT<br></font>\n";
    } else {
      $eaddresses .= "$data[0]," if($data[0]);
    }
  } # end of while

  $cmd = "select xsrs from REGxref 
          where srs='" . $form{'srs'} . "' && term='" . $form{'term'} . "'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";

  while(($xsrs = ($sth->fetchrow_array)[0])) {
    $cmd = "select email, enroll_status, lastname, firstname from REGrosters 
            where srs='$xsrs' && term='" . $form{'term'} . "'";
    $sth2 = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth2->execute || die "Can't execute query: $sth2->errstr\n";
    while((@data = $sth2->fetchrow_array)) {
      next if(!$hold && $data[1] eq "H");
      next if(!$waitlist && $data[1] eq "W");
      next if($data[1] eq "D");
      if ($data[0] =~ /^$/) {
        $noemails .= "$data[3] $data[2], ";
      } elsif ( ($data[0] =~ /,/) || ($data[0] !~ /^[^;]+@[^;\.][^;]+$/ ) ) {
        print "<font color=red><b>Student $data[3] $data[2] - $data[0]</b> has an invalid address. Please ask the student to update it in URSA.<br></font>\n";
      } else {
        $eaddresses .= "$data[0]," if($data[0]);
      }
    }
  }
  if(!$eaddresses){
    print "$_COULDNOTGETLISTOFEMAILS\n";
    exit(0);
  }
}

### added 4/12/99 Adam Kaplan
### modeled after sub get_eaddresses from tarostermail.pl
### in testing as of 4/13/99 
sub get_eaddresses_tasecs {
  local($xsrs, $seccnt, $loopcnt, @sections);

  # where $form{'total'} is the total number of sections the
  # TA wishes to mail        -Adam
  $seccnt = 0;
  $loopcnt = 0;

  do {
    $name = "section" . $loopcnt;
    if ( exists($form{$name}) ){
      $sections[$seccnt] = $form{$name};
      $seccnt++; 
    } #end if exists form{name}
    $loopcnt++;
  } until( $loopcnt >= $form{'total'} );

  foreach $srsnum (@sections) {
    $cmd = "select email, enroll_status, lastname, firstname from REGrosters
            where srs='" . $srsnum . "' && term ='" . $form{'term'}. "'";
    $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    while ((@data = $sth->fetchrow_array)) {
      next if(!$hold && $data[1] eq "H");
      next if(!$waitlist && $data[1] eq "W");
      next if($data[1] eq "D");
      if ($data[0] =~ /^$/) {
        $noemails .= "$data[3] $data[2], ";
      } elsif ( ($data[0] =~ /,/) || ($data[0] !~ /^[^;]+@[^;\.][^;]+$/ ) ) {
        print "<font color=red><b>$_STUDENT $data[3] $data[2] - $data[0]</b> $_INVALIDEMAIL_ASKSTUDT <br></font>\n";
      } else { 
        $eaddresses .= "$data[0]," if ($data[0]);
      } #end of if
    } #end of while looping thru query
 
    $cmd = "select xsrs from REGxref 
            where srs='" . $srsnum . "' && term ='" . $form{'term'} . "'";
    $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    while(($xsrs = ($sth->fetchrow_array)[0])) {
      $cmd = "select email, enroll_status, lastname, firstname from REGrosters 
              where srs ='$xsrs' && term='" . $form{'term'} . "'";
      $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
      $sth->execute || die "Can't execute query: $sth->errstr\n";
      while((@data = $sth->fetchrow_array)) {
        next if(!$hold && $data[1] eq "H");
        next if(!$waitlist && $data[1] eq "W");
        next if($data[1] eq "D");
        if ($data[0] =~ /^$/) {
          $noemails .= "$data[3] $data[2], ";
        } elsif ( ($data[0] =~ /,/) || ($data[0] !~ /^[^;]+@[^;\.][^;]+$/ )) {
        print "<b><font color=red> $_STUDENT $data[3] $data[2] - $data[0]</b> $_INVALIDEMAIL_ASKSTUDT <br></font>\n";
        } else { 
          $eaddresses .= "$data[0]," if ($data[0]);
        } #end of if
      } #end of while
      if(!$eaddresses) {
        print "$_COULDNOTGETLISTOFEMAILS\n";
        exit(0);
      } #end of if no eaddresses
    } #end of while looping thru query	
  }  # end of foreach looping through srs numbers
}


########
######## NOTE: 4/9/99  Adam Kaplan changed routine to 
########   apply to everyone, including non-profs
########   also, a check is done to ensure email
########   address is in correct format
########
sub get_prof_info {
  local ($notinprofsloc, $notinprofs, $notinREGta);
  $cmd = "select * from profsloc 
          where uid='$form{'profuid'}' && email like '_%\@_%' ";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  @data = $sth->fetchrow_array;
  if(@data){
    $prof = $data[1];
    if($data[4] =~ /^[^;]+@[^;\.][^;]+$/ ) {
      $profaddr = $data[4];
    } else {
      $profaddr = "$EMAIL_OF_CLASSWEB_ADMIN";
    }
  } else {
    $notinprofsloc = 1;  # Adam Kaplan 4/12/99
  }

  if ($notinprofsloc) {  
    $cmd = "select * from REGfaculty 
            where uid='$form{'profuid'}' && email like '_%\@_%' ";
    $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    @data = $sth->fetchrow_array;
    if(@data){
      $prof = $data[1];
      if($data[2] =~ /^[^;]+@[^;\.][^;]+$/ ) {
        $profaddr = $data[2];
      } else {
        $profaddr = "$EMAIL_OF_CLASSWEB_ADMIN";
      }
    } else {
      $notinprofs = 1;  # Adam Kaplan 4/12/99
    }
  }  # end if notinprofsloc

  if ($notinprofsloc && $notinprofs) {
    $cmd = "select * from REGta 
            where uid='$form{'profuid'}' && email like '_%\@_%' ";
    $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    @data = $sth->fetchrow_array;
    if(@data){
      $prof = $data[2];
      if($data[3] =~ /^[^;]+@[^;\.][^;]+$/ ) {
        $profaddr = $data[3];
      } else {
        $profaddr = "$EMAIL_OF_CLASSWEB_ADMIN";
      }
    } else {
      $notinREGta = 1;  # Adam Kaplan 4/12/99
    }
  }  # end if notinprofsloc and notinprofs

 ### if it can't be found...then we have an error

  if ($notinREGta && $notinprofs && $notinprofsloc) {
    print "<H1>Email not sent.  Couldn't get info for UID ". $form{'profuid'} . "!</H1>\n";
    exit(0);  
  }

  ### otherwise we'll assume we have the data...and move
  ### on
  print "<H1> This message is being sent from $profaddr </H1>" if ($debug);  
  if($debug) {
    print '<h1>Links: </h1>';
    print '<p><a href="'.$referer.'/admin/?type=other_rostermail">$_SENDMOREMAILTOCLASS</a>  ';
    print '<p><a href="'.$referer.'/admin/?type=other">$_OTHERADVANCED_OPTIONS</a>  ';
    print '<p><a href="'.$referer.'/admin/">$_ADMINISTRATION</a>  ';
    print '<p><a href="'.$referer.'/">$_CLASS_HOME_PAGE</a> ';
  }  
}

sub get_course_info {
  $cmd = "select dept, coursenum from REGclasses 
          where srs='" . $form{'srs'} . "' && term='" . $form{'term'} . "'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  ($dept, $coursenum) = $sth->fetchrow_array;
  if(!$dept || !$coursenum){
    print "$_COULDNOTGETCOURSEINFO" . $form{'srs'} . "!\n";
    exit(0);
  }
}

####### 4/9/99 Adam Kaplan wishes to note:
#########  $profaddr may no longer apply only to professors
#########  specifically
#########    (due to changes in sub get_prof_info)
#########  $prof (likewise) may no longer apply only to
#########    professors' names
sub send_message {
  local($msg);
  chop ($eaddresses);

  #Gavin fixed bug 125
  $displayeaddresses = $eaddresses;
  if($form{'extracc'}){
    $displayeaddresses = $eaddresses . "," . $form{'extracc'};
  }
  $eaddresses = $displayeaddresses;
  $displayeaddresses =~ s/,/, /gm;
  print "<p>eaddresses --> $displayeaddresses<p>\n" if($debug);

  #don't send messages with blank bodies
  if(!$form{'msgbody'}){
    print "$_ERROR_NOMSGTXT";
    exit(0);
  }
  $msg = "From: \"$prof\" <$profaddr>\n";
  $msg .= "To: \"$prof\" <$profaddr> (Group message to $dept $coursenum students)\n";
  $msg .= "Reply-To: $profaddr\n";
  $msg .= "Bcc: $eaddresses\n";

  ###Gavin commented out due to bug 125
  #$msg .= "Cc: " . $form{'extracc'} . "\n" if($form{'extracc'});
  $msg .= "Subject: " . $form{'msgtitle'} . "\n\n";
  $msg .= $form{'msgbody'};

  open(MAIL,"| $SEND_MAIL_CMD");
  print MAIL "$msg";
  close(MAIL);

  if($profaddr eq $EMAIL_OF_CLASSWEB_ADMIN){
    print "$_SSC_NOVALIDEMAIL_FORYOU <a href=\"mailto:$EMAIL_OF_CLASSWEB_ADMIN\">$DEFAULT_SENDER</a>. $_THANKYOU.\n\n";
  }

  $msg =~ s/&/&amp;/g;
  $msg =~ s/</&lt;/g;
  $msg =~ s/>/&gt;/g;

  print "<HTML><HEAD><TITLE>$_ROSTERMAILSENTMSG</TITLE></HEAD><BODY BGCOLOR=white>\n";
  print "$_YOURMSGSENTFROM <b>$profaddr</b>";
  if ($addannounce == 1) { 
    print "$_ADDEDTOANNOUNCE";
  }
  print "$_LOOKSLIKETHIS: <p>\n\n";
  print "<b>From:</b> \"$prof\" &lt;$profaddr&gt;<br>\n";
  print "<b>To:</b> \"$prof\" &lt;$profaddr&gt; (Group message to $dept $coursenum students)<br>\n";
  print "<b>Reply-To:</b> $profaddr<br>\n";
  print "<font color=blue><b>Bcc (won't show):</b> $displayeaddresses<br></font>\n";
  # print "<b>Cc:</b> " . $form{'extracc'} . "<br>\n" if($form{'extracc'});
  print "<b>Subject:</b> " . $form{'msgtitle'} . "<br>\n";
  print "<b>Text:</b> " . $form{'msgbody'} . "<br>\n";

## old display of message and headers
# print "<pre>\n$msg\n</pre>\n";
  
  $noemails =~s/^(.+), $/$1/;
  print "<p><font color=red> $_STUDTS_NOTSENTTO: $noemails </font> </p>" if ($noemails !~ /^$/);
  
# if it is not the TA accessing the mail program, then it is the professor.
# The professor access the rostermail program via the class webpage,
# so the link should be as follows:
# if(!$ta_uid){
  print '<hr><p><a href="' . $referer . '/admin/?type=other_rostermail">$_SENDMOREMAILTOCLASS</a> ';
  print '<a href="' . $referer . '/admin/?type=other">$_OTHERADVANCED_OPTIONS</a> ';
  print '<a href="' . $referer . '/admin/">$_ADMINISTRATION</a> ';
  print '<a href="' . $referer . '/">$_CLASS_HOME_PAGE</a> ';
  print "</body></html>\n";

# }

sub log {
  if(open(LOG, ">>$LOG_FILE")){
    # print LOG "Mail sent at " . localtime() . ":\n";
    # print LOG "\tTerm: " . $form{'term'} . "\n";
    # print LOG "\tDept: $dept\n";
    # print LOG "\tCoursenum: $coursenum\n";
    # print LOG "\tProf: $prof\n";
    # print LOG "\tSubject: ". $form{'msgtitle'} . "\n\n";
    print LOG localtime() . "|";
    print LOG $form{'term'} . "|";
    print LOG "$dept|";
    print LOG "$coursenum|";
    print LOG $form{'srs'} . "|";
    print LOG "TA:" if ($ta_uid);
    print LOG "$prof|";
    print LOG $form{'msgtitle'} . "\n";
    close(LOG);
  } else {
    print STDERR "Couldn't open $LOG_FILE for writing!\n";
  }

  # Added on 01-11-2000 
  $time = localtime();
  $time = "\"" . $time . "\"";
  $date = `$DOCUMENT_ROOT$ENTRY/dates/convert_date.pl $time`;
  $form_q = "\"" . $form{'term'} . "\"";
  $dept_q = "\"" . $dept . "\"";
  $coursenum_q = "\"" . $coursenum . "\"";
  $srs_q = "\"" . $form{'srs'} . "\"";
  $prof_q = "\"" . $prof . "\"";
  $msgtitle_q = "\"" . $form{'msgtitle'} . "\"";
  $ta_uid_q = "\"" . $ta_uid . "\"";

  if($ta_uid){
    $cmd = "insert into rostermail (time, term, dept, coursenum, srs, reg_name, subject, TA, uid) values ($date, $form_q , $dept_q, $coursenum_q , $srs_q, $prof_q, $msgtitle_q, 'TA', $ta_uid_q)";
  } else{ 
    $cmd = "insert into rostermail (time, term, dept, coursenum, srs, reg_name, subject) 
            values ($date, $form_q, $dept_q, $coursenum_q, $srs_q, $prof_q, $msgtitle_q)";
  }
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  # end of modification to bug 194 
}

sub addannounce {
  # drop URL lookup when we already have it in $referer
  # $cmd = "select url from REGurl 
  #         where srs='" . $form{'srs'} . "' && term='" . $form{'term'} . "'";
  # $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  # $sth->execute || die "Can't execute query: $sth->errstr\n";
  # my @data = $sth->fetchrow_array;
  # $url = $data[0];

  $url = $referer;
  my $date = `date '+%m/%d/%y %H:%M'`;
  chomp $date;
  $message= "$date (email) <b>" . $form{'msgtitle'} . ":</b>" . $form{'msgbody'};
  $message =~ s/\n//g;

  # search for either http or https
  $url =~ s#https?://$SERVER_NAME#$DOCUMENT_ROOT#i;

  # get raid of admin and anything after admin
  $url =~ s#admin/\??.*$##;  

  # get raid of the slash at the end
  $url =~ s#/$##;

  # Adam fixes for secure server also Jan 18 2000

  # changed to require newer version. 'seems' ok, be aware.
  # require "/info-data/classweb3/announce.pm";
  # require "/info-data/classweb3/error_message.pm";
  require "$BASE/announce.pm";
  require "$BASE/error_message.pm";

  &ainsert("$url/",$message);
}
}
