#!/usr/local/bin/perl -w
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
##########################################
# Name: addadmin.pl
# Purpose: add administrator to class web site
# Usage: from command-line, www% addadmin.pl term srs# uid# password 
#        from php, system("addadmin.pl $term $srs $uid $password WWW");
# Steps:
# 1) Add the user to the addadmin table.
# 2) Add uid to $PASSDIR/<term>.group file.
# 3) Add encrypted password to $PASSFILE
# Update: 8-18-99 Yelena - changed how we got the $dir var.  getting it 
#           from the url like before added to the wrong group for crosslisted
#           classes. 
#         7-7-99 yelena - added general comments
#         1-15-99 jason - created
# Status: production
##########################################


## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
$BASE = "/home/classweb"; # main classweb programs directory
require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here
require "$BASE/dbopen.pl";
require "$BASE/dbfuncs.pm";

local($dir, @lines, $line, $found, $class, *FILE);
local($term, $srs, $uid, $password, $mode) = @ARGV;
$mode = "" if(!defined($mode));

if(!$mode){
  print "term --> $term\n";
  print "srs--> $srs\n";
  print "uid--> $uid\n";
  print "password--> $password\n";
}

if(!($term && $srs && $uid && $password)){
  if(!$mode){ #called from the command-line
    print STDERR "Wrong number of args! Exiting ...\n";
  }

  exit(1);	
}

# make sure this person isn't already listed as an admin for this class
$cmd = "select term from addadmin where term='$term' && srs='$srs' && uid='$uid'";
$sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: " . $dbh->errstr . "\n";
$sth->execute || die "Can't execute query: " . $sth->errstr . "\n";

if(@data = $sth->fetchrow_array){
  if(!$mode){
    print "$uid is already in the database for $term $srs!\n";
  }
  exit(2); # bad user
}

# step (1)
$cmd = "INSERT INTO addadmin VALUES ('$term','$srs','$uid')";
$sth = $dbh->prepare($cmd) or die "Can't prepare $cmd: $dbh->errstr\n";
$sth->execute or die "Can't execute query: $sth->errstr\n";
$cmd = "select a.coursenum, a.section, b.dirname from REGclasses a, REGdept b where a.term='$term' && a.srs='$srs' && a.dept = b.dept";
$sth = $dbh->prepare($cmd) or die "Can't prepare $cmd: $dbh->errstr\n";
$sth->execute or die "Can't execute query: $sth->errstr\n";
if(@data = $sth->fetchrow_array){
  $data[0] =~ tr/A-Z/a-z/;
  $data[1] =~ tr/A-Z/a-z/;
  $dir = "$data[2]$data[0]-$data[1]";
} else {
  if(!$mode){
    print "Couldn't find info for $term $srs!\n";
  }

  exit(3); # no info in REGclasses 
}

## Step (2)
if(open(FILE, "$PASSDIR/$term.group")){
  @lines = <FILE>;
  close(FILE);
  $found = 0;

  foreach $line (@lines){
    next unless($line =~ /^$dir/);
    chomp($line);
    ($class, $uids) = split(/:/, $line, 2);
    if($uids !~ /$uid/){
      $uids .= "$uid \n";
      $line = "$class:$uids";
      $found = 1;
    } else {
      $found = -1;
    }
    last;
  }

  if($found == 0){
    push(@lines, "$dir:$uid \n");
    @lines = sort(@lines);
  }
  	
  if($found != -1){
    if(open(FILE,">$PASSDIR/$term.group")){
      print FILE @lines;
      close(FILE);
    } else {
      if(!$mode){
        print "Couldn't open $PASSDIR/$term.group for writing!\n";
      }
      exit(3);
    }
  } else {
    if(!$mode){
      print "Couldn't open $PASSDIR/$term.group for reading!\n";
    }
  
    exit(3); 
  }
  
  
  #Steps (3) & (3.5)
  if(-e $PASSFILE){
    open(FILE, "$PASSFILE");
    @lines = <FILE>;
    $write = 1;
    foreach $line(@lines){
      $uuid = (split(/:/, $line))[0];
      if($uuid eq $uid) { #the user already has a password
        $write = 0;
        last;
      }
    }
    if($write){
      system"$HTPASSWD -b $PASSFILE $uid $password";
    }
  } else {
    if(!$mode){
      print "Couldn't open $PASSFILE for reading!\n";
    }
    exit(4); 
  }
  
  # All done ...
  exit(0);
}
__END__
