######################################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: announce.pm
# Usage: called from stub.pl
# Steps: +announce.pm 
#          +announce()
#            -areplace()
#            -ainsert()
#
# Update 09-12-02 Jerome - replaced eflorent's multilingual features with
#                          new multilingual system
# Update 06-01-01 eflorent :  multilang features added.
# Update 01-31-2000 Mike: commented out print statement in areplace subroutine
#   that was causing bug in TA sites. Redirect was giving internal server error.
# Update 11-04-98 artin: added a new subroutine (ainsert) for use 
#   by rostermail.pl which inserts a message at the top, and removes
#   "No messages at this time" if it exists.
# Update 09-17-98 mike: converted to work with Matt's New Admin pages and PHP
# Update 08-12-98: working, but needs testing
# Update 08-10-98: converting from edit.pm
#
# Status: production
# Purpose: to edit ClassWeb Announcements only


##########################################
# Name: announce
# Usage: &announce()
# Update: 7/12/99 Adam Kaplan - commented
# Status: production
# Purpose: show PHP version of edit screen
##########################################

sub announce {
  if (param('action') eq 'replace') {  # 2nd step, after edit screen
    &areplace;
  } elsif (param('php') == 1) {   # show minimal PHP version of edit screen
if ($basedir eq '.'){
  $basedir = "..";
}
  #warn("$basedir");
    open(IN,"<$basedir/announce.inc") || &error_message("open announce.inc failed");
    $cnt = 0;
    $cols = 55;  #  setting for New Admin rows
    while($cnt < "3") {   # print three blank lines at top
      $cnt++;
      $msg = "msg" . $cnt;
      print "<TR>\n",      # print extra blank cell/row
        "<td><font face='Arial'>$_NEW $cnt</font></td>\n",
        "<TD>", textfield(-name=>$msg,-size=>$cols),"</TD></TR>\n";
    }
    while(<IN>) {
      if (/<[UO]L>/i) {                # <UL> or <OL> is start of list
        until (($_ = <IN>) =~ /<\/[UO]L>/i || eof ) { #  </UL> or </OL> is end of list
          ($line) = (/<LI>(.*)/i);
          if ($line) {
            $cnt++;
            $msg = "msg" . $cnt;
            foreach $var ($line) {
              $var =~ s/^\s*//;     # remove leading blanks
              $var =~ s/\s*$/$1/;   # remove trailing blanks
            }
            print "<TR>\n",   # print one cell/row per message
              "<td><font face='Arial'>$_OLD $cnt</font></td>\n",
              "<TD>",textfield(-name=>$msg,-default=>$line,-size=>$cols),
              "</TD></TR>\n";
          }
        }
        $add3 = $cnt + 3;
        while($cnt < $add3) {   # print blanK announcement spaces at bottom
          $cnt++;
          $msg = "msg" . $cnt;
          print "<TR>\n",      # print extra blank cell/row
            "<td><font face='Arial'>$_NEW $cnt</font></td>\n",
            "<TD>", textfield(-name=>$msg,-size=>$cols),"</TD></TR>\n";
        }
      }
    }
    close(IN);
  } else {   # show old version of edit screen
if ($basedir eq '.'){
  $basedir = "..";
}
    $cols = 80; # Old Admin version
    open(IN,"<$basedir/announce.inc") || &error_message("open announce.inc failed");
    print header;
    print start_html($program),
      h1($program),
      hr,
      "\n";
    print 
      start_form,
      p,
      h2($_ANNOUNCE_EDITORPAGE), "\n",

      "<I>$_ANNNOUNCE_EDIT_DESCRIP_A $ltext, $_ANNOUNCE_EDIT_DESCRIP_B</I>\n",
      "<TABLE border=1 cellpadding=0 cellspacing=0>",
      "<TR ALIGN=CENTER>$_ORDER<TH><TH>$ltitle</TH>",
      "</TR>\n";
  
    $cnt = 0;
    while($cnt < "3") {   # print five blank lines at top
      $cnt++;
      $msg = "msg" . $cnt;
      print "<TR>\n",      # print extra blank cell/row
        "<TD><tt>$_NEW $cnt:</tt></TD>\n",
        "<TD>", textfield(-name=>$msg,-size=>$cols),"<TD></TR>\n";
    }
    while(<IN>) {
      if (/<[UO]L>/i) {                # <UL> or <OL> is start of list
        until (($_ = <IN>) =~ /<\/[UO]L>/i) { #  </UL> or </OL> is end of list
          ($line) = (/<LI>(.*)/i);
          if ($line) {
            $cnt++;
            $msg = "msg" . $cnt;
            foreach $var ($line) {
              $var =~ s/^\s*//;     # remove leading blanks
              $var =~ s/\s*$/$1/;   # remove trailing blanks
            }
            print "<TR>\n",   # print one cell/row per message
              "<TD><tt>$_OLD $cnt:</tt></TD>\n",
              "<TD>",textfield(-name=>$msg,-default=>$line,-size=>$cols),
              "</TD></TR>\n";
          }
        }
        $add3 = $cnt + 3;
        while($cnt < $add3) {   # print blanK announcement spaces at bottom
          $cnt++;
          $msg = "msg" . $cnt;
          print "<TR>\n",      # print extra blank cell/row
            "<TD><tt>$_NEW $cnt:</tt></TD>\n",
           "<TD>", textfield(-name=>$msg,-size=>$cols),"<TD></TR>\n";
        }
        print "</TABLE>\n",
          p,
          hidden(-name=>'action',-default=>"replace"),
          hidden(-name=>'stubsection',-default=>'edit'),
          submit(-value=>"$_UPDATE"), "\n",
          end_form, end_html;
      }
    }
    close(IN);
  } #endif
  
  ####################################################
  # Name: areplace 
  # Usage: &areplace;
  # Update: 7/12/99 Adam Kaplan - commenting
  # Status: production
  # Purpose: replace an announcement into announce.inc
  ####################################################
  sub areplace {
if ($basedir eq '.'){
  $basedir = "..";
}
    system "cp $basedir/announce.inc $basedir/announce.inc.old";
    chmod (0660, "$basedir/announce.inc.old");    # readable, writeable, not executable to user/group
    $|++;     # unbuffers output
    $file = "$basedir/announce.inc";
    $rfile = "$baseurl/announce.php";
    open(OUT,"+>>$file") || &error_message("open $file failed");
    flock OUT, 2;      # wait for exclusive lock
    seek OUT, 0, 0;    # rewind to beginning
    @content = <OUT>;  # pull entire file into this array
    seek OUT, 0, 0;    # rewind to beginning
    truncate $file, 0; # empty the file
    $TASECTION = "no";
    $TAWRITTEN = "no";
    foreach $line (@content) {
      if ($line =~ /<[UO]L>/i) {  # <UL> or <OL> is start of list
        $TASECTION = "yes";
        print OUT $line;             # print line that has <UL> or <OL>
        for ($cnt = 1; $cnt < 100; $cnt++) {   # allows up to 100 messages
          $msg = "msg" . $cnt;
          if (param($msg)) {
            print OUT "<LI>", param($msg), "\n";
          }
        }   # end of for loop
      }
      if ($line =~ /<\/[UO]L>/i) {         # </UL> or </OL> is end of list
        $TASECTION = "no";
      }
      if ($TASECTION eq "no") {
        print OUT $line;             # ok to print line
      }
    }
    close(OUT);
    chmod (0660, "$file");    # readable, writeable, not executable to user/group
    print redirect($rfile);
  } #areplace
  ###################################################

 
  ################################################################
  # Name: ainsert 
  # Usage: &ainsert;
  # Update: 7/12/99 Adam Kaplan - commenting
  # Status: production
  # Purpose: insert an announcement into announce.inc. Used by rostermail
  ################################################################  
  sub ainsert{
if ($basedir eq '.'){
  $basedir = "..";

}
    my ($basedir,$msg) = @_;
    system "cp $basedir/announce.inc $basedir/announce.inc.old";
    chmod (0660, "$basedir/announce.inc.old");    #readable, writeable, not executable to user/group
    $|++;     # unbuffers output
    $file = $basedir."announce.inc";
    open(OUT,"+>>$file") || &error_message("open $file failed");
    flock OUT, 2;      # wait for exclusive lock
    seek OUT, 0, 0;    # rewind to beginning
    @content = <OUT>;  # pull entire file into this array
    seek OUT, 0, 0;    # rewind to beginning
    truncate $file, 0; # empty the file
    $TASECTION = "no";
    $TAWRITTEN = "no";
    foreach $line (@content) {
      print OUT $line if ($line !~ /<li>$_NOANNOUNCEMENTS_YET/i );
      if ($line =~ /<[UO]L>/i) {  # <UL> or <OL> is start of list
        print OUT "<LI>$msg\n";
      }
    }
    close(OUT);
    chmod (0660, "$file");    #readable, writeable, not executable to user/group
  } #ainsert
  ##############################################################

}  # end of announceedit subroutine
1
