#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
##########################################3
# Name: authen_installer.pm
# Usage: called as a stub from an admin stub.pl 
#        (needs param classname and board)
# Steps: +authen_installer.pm
#          +authen_installer()
#            -toggles existence of .htaccess file
#
# Update:09-04-02 Jerome - added require for contenttype.inc
#        8-20-02 Jerome and Nick - substituting out language-dependent text
#          strings with variables to allow multilingual support. 
#        9-23-1999 Adam Kaplan - created
#
# Status: writing
# Purpose: installs/toggles authentication in a given board directory

sub authen_installer {
  $board = param('board');
  $classname = param('classname');
  $dir = $basedir . "/$board";
  $url = $baseurl . "/$board";
  if (-e "$basedir/classinfo.inc") {
    $classinfo = "$basedir/classinfo.inc";
  } elsif (-e "$basedir/../classinfo.inc") {
    $topdir = $basedir;
    $topdir =~s/^(.+)\/[^\/]+$/$1/;
    $classinfo = "$topdir/classinfo.inc";
  } else {
    print <<END;
      <HTML><HEAD>
      <TITLE>$_ERROR!</TITLE>
      </HEAD>
      <BODY BGCOLOR=#FFFFFF><CENTER><H1>$_ERROR!</H1></CENTER>
      <P>$_ERROR_BODY_A $basedir $_ERROR_BODY_B 
      </P>
      </BODY></HTML>
END
    exit;
  } #endif to find classinfo
  
  if (!(-e "$dir/.htaccess.old")) {
     # no old file, so
     # at this point we are copying the present file to old file
    open(IN, "$dir/.htaccess");
    open(OUT, ">$dir/.htaccess.old");
    while (<IN>) {
      print OUT;
    }
    close(IN);
    close(OUT);
    open(NEW, ">$dir/.htaccess");
    print NEW <<"END";
  Options ExecCGI Includes Indexes
  DirectoryIndex index.php index.html index.htm
  AuthName "$classname: WWW Board Authentication"
  AuthType Basic
  ## CUSTOMIZE - server which handles authentication
  PerlAuthenHandler Apache::AuthDir
  PerlSetVar classinfo $classinfo
  <Limit GET POST>
  require valid-user
  </Limit>
END
    close(NEW);
  } else {
    # there is an old file, so merely switch them    
    # this will effectively toggle authentication
    open(OLD,"$dir/.htaccess.old");
    @oldaccess = <OLD>;
    close(OLD);
    open(NEW,"$dir/.htaccess");
    open(OLD,">$dir/.htaccess.old");
    while(<NEW>) {
      print OLD;
    } #endwhile 
    close(NEW);
    close(OLD);
    open(NEW,">$dir/.htaccess");
    foreach $line (@oldaccess) {
      if ($line =~ /^DirectoryIndex/) {
        print NEW "DirectoryIndex index.php index.htm index.html\n";
      } else {
        print NEW "$line";
      } #endif
    } #endforeach
    close(NEW);
  } #endif (old .htaccess doesn't exist)

  require "$BASE/contenttype.inc"; # enable charset
  # print "Content-type: text/html\n\n";
  print <<END;
  <HTML><HEAD>
  <meta http-equiv="Refresh" content="0;url=$url">
  <TITLE></TITLE>
  </HEAD>
  <BODY BGCOLOR=#FFFFFF></BODY></HTML>
END
} #authen_installer
1
