#####################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: board_filter.pm
# Usage: called from web 
# Steps: +board_filter.pm
#          +board_filter()
#            -display_filters()
#            -add_filters()
#
# Update:09-04-02 Jerome - added require for contenttype.inc
#        8-20-02 Jerome and Nick - Substituting out language-dependent text
#          strings with variables to allow multilingual support 
#        3-24-98 strips out ^Ms from filter file before writing
#
# Status: production
# Purpose: creates and edits the filter file for the wwwboard

sub board_filter {
  $filter='filter';
  # location of default filter file
  $default_filter=$DEFAULT_FILTER;

  # uses default filter file from main classweb directory
  if (!-s "$basedir/admin/filter") {
    # location of default filter file
    open (IN,"<$DEFAULT_FILTER");
    @filter=<IN>;
    close(IN);
  }

  # uses filter file for specific class, if found
  if (-s "$basedir/admin/filter") {
    open (IN,"<$basedir/admin/filter");
    @filter=<IN>;
    close(IN);
  }
  
  &add_filters if (param('section') eq 'add_filter');
  &display_filters;

  sub display_filters {
    require "$BASE/contenttype.inc"; # enable charset
    # print "Content-type: text/html\n\n";
    print "<title>$_FILTER_TITLE</title>\n";
    print "<BODY BGCOLOR=#FFFFFF>";
    print "<form method=post action=$cgi_url><h1>$_FILTER_TITLE</h1>\n";
    print "$_FILTER_DIRECTIONS\n<br>";
    print "<br><textarea name=filter_words rows=10>";
    foreach $filter_name (@filter) {
      print "$filter_name";
    }
    print "</textarea><br>\n";
    print "<br><input type=checkbox name=no_filter
    value=no_filter>$_REMOVEFILTERS<br><br>\n";
    print "<input type=hidden name=stubsection value=board_filter>\n";
    print "<input type=hidden name=section value=add_filter>\n";
    print "<input type=submit value=\"$_ADDFILTERS\">\n";
    print "</body></html>\n";
  } #display_filters
  
  sub add_filters {
    # creates new filter file for class site
    if (!param('no_filter')) {
      @filter=param('filter_words');
      foreach $bw (@filter) {
        $bw  =~ s/\x0d//sg;     # drop ctrl-Ms (CRs) that are in data
      }
      open (OUT,">$basedir/admin/filter");
      print OUT @filter;
      close(OUT);
    }
    if (param('no_filter')) {
      unlink("$basedir/admin/filter");
    }
    &Redirect_User("$baseurl") 
  }
}
1
