##########################################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: create_popup.pm
# Usage: called by other_popup.php; 
#   it works with frames and requires three files, the comment file,
#   the htm file that sets the frames and the htm file with the 
#   javascript in it.
# Steps: +create_popup.pm 
#          +create_popup()   
#            -if edit, pop_edit() backend 
#            -if !linkadd, pop_start() backend
#            +if linkadd, pop_create() backend
#              +placelink.pm
#                -Place_link()
#              +includephpvars.pm
#                -includephpvars()
#              +redirect.pm
#                -Redirect_User()
#              -dbopen.pl
#
# Update 09-04-02 Jerome - added require for contenttype.inc
# Update 08-20-02 - Nick and Jerome - Substituting out langauge-dependent text
#   strings with variables to allow multilingual support.
# Update 07-22-00 - Mike set program dir with global $BASE from require.pm
# Update 09-01-99 - Adam chaging to work with the database linkpage
# Update 08-21-98 - Mike changing to work with PHP frontend
# Update 06-08-98 - Mike fixed bug where linkpage was getting wiped out and 
#   it was redirecting to linkpage instead of linkpage.php
# Update 06-08-98 - Artin got it working and stubbed, with hash and popup.pl 
#   created in directory if need be. 
# Update 05-29-98 - how should we name the files?
#
# Status: production
# Purpose: creates links to pages with instructor comments that "pop up"
#   backend to other_popup.php

sub create_popup {
  require 'error_message.pm';
  if (param('edit')) { &pop_edit; }
  if (!param('linkadd')) { &pop_start;}
  if (param('linkadd')) { &pop_create;}

  sub pop_start {
    unless (param('php') == 1) {
      require "$BASE/contenttype.inc"; # enable charset
      # print "Content-type: text/html\n\n";
      print "<html><title>$_POPUP_TITLE</title>\n";
      print "<BODY BGCOLOR=#FFFFFF><h1>$_POPUP_TITLE</h1>\n";
    }
    dbmopen(%popup,"../popup",0644);  # popups kept in dbm files
    system"chmod 660 $basedir/popup.db";
    $count=$popup{count};             # count of previous popups
    if ($count) {  # has previous popups
      print "<form method=post action=\"$cgi_url?stubsection=create_popup\">";
      print "<font face='Arial'>$_CANEDITEXISTING_POPUPS<br>\n";
      print "<select name=linkname>\n";
      $num=1;
      until ($num > $count) {
        print "<option value=\"$num\">",$popup{"name$num"} if $popup{"name$num"} ;
        $num++;
      }
      print "</select>\n";
      print "<input type=hidden name=edit value=edit>\n";
      print "<input type=hidden name=stubsection value=create_popup>\n";
      print "<p><input type=submit value=\"$_EDITPOPUP\">\n" if ($count);
      print "</font></form>";
    }  # end of edit old form
    print "<font face='Arial'><big>$_CREATINGPOPUPLINKS</big><br>\n";
    print "$_POPUP_DIRECTIONS<br>\n";
    print "<form method=post action=\"$cgi_url?stubsection=create_popup\">";
    print "$editing";
    print "$_LINKADDRESS: <input type=text size=45 name=linkadd $linkadd value='http://'><br>\n";
    print "$_LINKDESCRIP: <input type=text size=45 name=linkname $linkname><br>\n";
    print "$_POPUP_COMMENTS:<br><textarea name=comments cols=40 rows=5>$comment</textarea><br>\n";
    print "$_LINKTOWHICHPAGE: <input type=checkbox name=linktom value=yes> $_MAINMENU <input type=checkbox name=linktol value=yes> $_LISTOFLINKS \n";
    print "<p>($_POPUP_NOTE)</p>\n";
    print "<input type=submit value=\"$_POPUP_SUBMIT\"> <input type=reset value=\"$_RESET\"><br>\n";
    print "$hidden" if ($linkadd); 
    print "<input type=hidden name=stubsection value=create_popup>\n";
    print "</font></form>\n";
    print "</body></html>\n" unless (param('php') == 1);
    dbmclose(%popup);
    exit;
  } #pop_start

  sub pop_create {
    dbmopen(%popup,"../popup",0644);
    system"chmod 660 $basedir/popup.db";
        
    if (!$popup{count}) {$popup{count}=1;}
    else { $popup{count}++ if (!param('edit_num')); }
    if (!-s "../popup.cgi") { 
      system "cp $BASE/popup.stub ../popup.cgi"; 
      system "chmod 770 $basedir/popup.cgi";
    }
    undef $/;
    $comment=param('comments');
    $linkadd=param('linkadd');
    $linkname=param('linkname');
    if (!param('edit_num')) {
      $num=$popup{count};
    } else { $num=param('edit_num'); }
    $popup{"comment$num"}=$comment;
    $popup{"url$num"}=$linkadd;
    $popup{"name$num"}=$linkname;
    if (param('linktom')) { &Place_link("popup.cgi?num=$num\&page=frame",$popup{"name$num"}); }
    if (param('linktol')) { 
      if (-e "../ta.inc") {
        $site = "ta";
        &includephpvars("../ta.inc");
        &includephpvars("../../classinfo.inc");
      } else { 
        $site = "class";
        &includephpvars("../classinfo.inc");
      } #endif 
      require ("$BASE/dbopen.pl");
      $cmd1 = "select * from linkold where term = '$term' && srs = '$srs' && site = '$site'";
      $sth = $dbh->prepare($cmd1) || die ("Couldn't prepare $cmd1");
      $sth->execute || die ("Couldn't execute $cmd1");
      $numrows = $sth->rows;
      if ($numrows == 0) { $mode = 1; } else { $mode = 0; }
      if ($mode == 1) { #new linkpage (database)
        $updater = $ENV{REMOTE_USER};
        $url = "popup.cgi?num=$num&page=frame";
        $cmd2 = "insert into links (term,srs,name,parent,url,updater,site) values ('$term','$srs','$linkname',0,'$url','$updater','$site')";
        $sth = $dbh->prepare($cmd2) || die ("Couldn't prepare $cmd2");
        $sth->execute || die ("Couldn't execute $cmd2");
      } else { #old linkpage (flatfile)
        open(IN,"<../linkpage.inc");
        undef $/;
        $file=<IN>;
        close(IN);

        $file=~s#<ul>(.*?)</ul>#<ul>$1\n<LI><a href=\"popup.cgi\?num=$num\&page=frame\">$popup{"name$num"}</A>\n</ul>#sig;
        open(OUT,">../linkpage.inc");
        print OUT $file;
        close(OUT);

      } #endif
    }
    if (param('linktom')) { &Redirect_User("$baseurl"); }
    elsif (param('linktol')){ &Redirect_User("$baseurl/linkpage.php"); }
    else {&Redirect_User("$baseurl"); }
    dbmclose(%popup);
  } #pop_create
    
  sub pop_edit {
    undef $/;
    dbmopen(%popup,"../popup",0644);
    system"chmod 660 $basedir/popup.db";
    $num = param('linkname');
    $comment=$popup{"comment$num"};
    $linkadd=$popup{"url$num"};
    $linkname=$popup{"name$num"};
    $linkadd="value=\"$linkadd\""; 
    $linkname="value=\"$linkname\""; 
    $hidden="<input type=hidden name=edit_num value=$num>";
    $editing="<h2>Editing a Link</h2>\n";
    dbmclose(%popup);
  } #pop_edit
} #create_popup
1
