##########################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: create_private.pm
# Usage: called from web
# Steps: +create_private.pm
#          +create_private()
#            -startpage() frontend
#            -create_dir() backend
#
# Update 09-04-02 Jerome - added require for contenttype.inc
# Update 08-20-02 Nick and Jerome - Substituting out language-depdendent text
#   strings with variables to allow multilingual support.
# Update 05-30-00 kenny: documented
# Update 01-29-98 artin: changed chmods to run from system to keep g+s
#
# Status: production
# Purpose: creates a private subdirectory for classweb site

sub create_private {
  if (param('sub') eq '') {
    &startpage;
  }
  if (param('sub') eq 'createdir') {
    &create_dir;
  }

  # frontend, gathers username and password
  sub startpage {
    require "$BASE/contenttype.inc"; # enable charset
    # print "Content-type: text/html \n\n";
    print "<html><title>$_CREATEPRIVATE_TITLE</title>\n";
    print "<BODY BGCOLOR=#FFFFFF><h1>$_CREATEPRIVATE_TITLE</h1>\n";
    print "<font size=4>$_CREATEPRIVATE_PURPOSE<font>\n"; 
    print "<p><form method=POST action=\"$cgi_url\">\n";
    print "$_ENTERUSERNAME:  <input type=\"text\" name=\"name\">\n<br>"; 
    print "$_ENTERPASSWORD:  <input type=\"password\" name=\"newpass\">\n<br>"; 
    print "$_ENTERPASSWORD_CONFIRM:  <input type=\"password\" name=\"testpass\">\n<br>"; 
    print "<input type=\"hidden\" name=\"sub\" value=\"createdir\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"create_private\">\n";
    print "<input type=\"submit\" value=\"$_CREATEPRIVATE_SUBMIT\">\n";
    print "</form></body>";
    print "</html>";
  } #startpage

  # backend, creates private dir
  sub create_dir {
    if (param('name')) {
      if (param('testpass') eq param('newpass')) {
        system "mkdir $basedir/private";
        system "chmod 770 $basedir/private";    # full access to user/group, none to anyone else
        system "mkdir $basedir/private/pass";   
        system "chmod 770 $basedir/private/pass";    # full access to user/group, none to anyone else
        &set_private_pass;
      }
    }
  } #create_dir
} #create_private
1
