# MySQL dump 8.12
#
# Host: localhost    Database: classweb
#--------------------------------------------------------
# Server version	3.23.31-log

#
# Table structure for table 'REGclasses'
#

CREATE TABLE REGclasses (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  dept varchar(10) NOT NULL default '',
  coursenum varchar(10) NOT NULL default '',
  section varchar(6) default NULL,
  crsidx varchar(8) default NULL,
  secidx varchar(4) NOT NULL default '',
  activity char(3) default NULL,
  coursetitle varchar(255) NOT NULL default '',
  sectitle varchar(255) default NULL,
  status varchar(10) NOT NULL default '',
  examcode char(2) default NULL,
  examcodetext varchar(80) default NULL,
  url tinytext,
  description text,
  PRIMARY KEY (term,srs),
  KEY dept(dept),
  KEY coursenum(coursenum),
  KEY term(term),
  KEY term_2(term)
) TYPE=MyISAM;

#
# Dumping data for table 'REGclasses'
#

INSERT INTO REGclasses VALUES ('01W',100000000,'HIST','101','1','','1','LAB','Demo Class','','Open','','','classweb.ucla.edu/classes/01W/hist101-1/','This is a demonstration Classweb course');

#
# Table structure for table 'REGcontacts'
#

CREATE TABLE REGcontacts (
  dept varchar(10) NOT NULL default '',
  type enum('Contact','Scheduler','WebTech') NOT NULL default 'Contact',
  uid int(9) NOT NULL default '0',
  KEY dept(dept),
  KEY type(type),
  KEY uid(uid)
) TYPE=MyISAM;

#
# Dumping data for table 'REGcontacts'
#

INSERT INTO REGcontacts VALUES ('admin','WebTech',1);
INSERT INTO REGcontacts VALUES ('HIST','WebTech',1);
INSERT INTO REGcontacts VALUES ('HIST','Scheduler',1);
INSERT INTO REGcontacts VALUES ('HIST','Contact',1);

#
# Table structure for table 'REGdept'
#

CREATE TABLE REGdept (
  dept varchar(10) NOT NULL default '',
  lname varchar(40) NOT NULL default '',
  url varchar(60) default NULL,
  dirname varchar(20) NOT NULL default '',
  PRIMARY KEY (dept)
) TYPE=MyISAM;

#
# Dumping data for table 'REGdept'
#

INSERT INTO REGdept VALUES ('AERO ST','Aerospace Studies','/afrotc/','aero');
INSERT INTO REGdept VALUES ('AFRO-AM','Afro-American Studies','/caas/','afroam');
INSERT INTO REGdept VALUES ('AM IND','American Indian Studies','/indian/IDPHome.html','amind');
INSERT INTO REGdept VALUES ('ANTHRO','Anthropology','/anthro/','anthro');
INSERT INTO REGdept VALUES ('ARCHEOL','Archaeology','','archeol');
INSERT INTO REGdept VALUES ('ASIA AM','Asian American Studies','/aasc/','asian');
INSERT INTO REGdept VALUES ('CHICANO','Chicano Studies','http://www.sscnet.ucla.edu/chavez/','chicano');
INSERT INTO REGdept VALUES ('COM STD','Communication Studies','http://www.humnet.ucla.edu/humnet/commstudies/','comm');
INSERT INTO REGdept VALUES ('ECON','Economics','http://econweb.sscnet.ucla.edu/','econ');
INSERT INTO REGdept VALUES ('EUR STD','European Studies','http://www.isop.ucla.edu/euro/','euro');
INSERT INTO REGdept VALUES ('GEOG','Geography','http://www.geog.ucla.edu','geog');
INSERT INTO REGdept VALUES ('HIST','History','/history/','hist');
INSERT INTO REGdept VALUES ('HNRS','Honors Collegium','','hnrs');
INSERT INTO REGdept VALUES ('INT DEV','International Development Studies','http://www.isop.ucla.edu/ids/','ids');
INSERT INTO REGdept VALUES ('LAT AM','Latin American Studies','http://www-server.isop.ucla.edu/lac/','latam');
INSERT INTO REGdept VALUES ('MIL SCI','Military Science','/milsci/','milsci');
INSERT INTO REGdept VALUES ('NAV SCI','Naval Science','/nrotc/','naval');
INSERT INTO REGdept VALUES ('POL SCI','Political Science','/polisci/','polisci');
INSERT INTO REGdept VALUES ('SOCIOL','Sociology','/soc/','soc');
INSERT INTO REGdept VALUES ('SPEECH','Speech','http://www.humnet.ucla.edu/humnet/commstudies/','speech');
INSERT INTO REGdept VALUES ('AFR STD','African Studies','http://www.isop.ucla.edu/jscasc/','african');
INSERT INTO REGdept VALUES ('WOMEN','Women\'s Studies','http://women.ucla.edu/','women');
INSERT INTO REGdept VALUES ('ISLAMIC','Islamic Studies','http://www.isop.ucla.edu/cnes/','islamic');
INSERT INTO REGdept VALUES ('GE CLST','General Education Clusters','http://www.college.ucla.edu/ge/','gecl');
INSERT INTO REGdept VALUES ('DEMO','ClassWeb Demo','','demo');
INSERT INTO REGdept VALUES ('SSC','Social Sciences Computing','http://computing.sscnet.ucla.edu/','ssc');
INSERT INTO REGdept VALUES ('WOM STD','Women\'s Studies','http://women.ucla.edu/','women');
INSERT INTO REGdept VALUES ('EVANG','Evangelistic Studies','','evang');
INSERT INTO REGdept VALUES ('BUR STD','Burnsian Studies','','burns');
INSERT INTO REGdept VALUES ('LING','Linguistics','','ling');
INSERT INTO REGdept VALUES ('FILM&TV','Film and TV','','filmtv');
INSERT INTO REGdept VALUES ('THEATER','Theater','','theater');
INSERT INTO REGdept VALUES ('ETHNOMU','Ethnic North American Music','','ethnomu');
INSERT INTO REGdept VALUES ('URB PLN','Urban Planning','','geog');
INSERT INTO REGdept VALUES ('ENGL','English','','engl');
INSERT INTO REGdept VALUES ('AP&TESL','Ape Primates and Tesla Coils','','anthro');
INSERT INTO REGdept VALUES ('STATS','Statistics','','stats');
INSERT INTO REGdept VALUES ('NURSING','Nursing','','anthro');
INSERT INTO REGdept VALUES ('ENGSER','Engineering Services','','engser');

#
# Table structure for table 'REGfaculty'
#

CREATE TABLE REGfaculty (
  uid int(9) NOT NULL default '0',
  fullname varchar(30) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  AdmCode varchar(4) default NULL,
  department varchar(30) default NULL,
  Title varchar(50) default NULL,
  Address varchar(50) default NULL,
  MailCode varchar(11) default NULL,
  phone varchar(12) default NULL,
  fax varchar(12) default NULL,
  LocCode char(2) default NULL,
  URL varchar(50) default NULL,
  ListCode char(2) default NULL,
  PRIMARY KEY (uid),
  KEY fullname(fullname)
) TYPE=MyISAM;

#
# Dumping data for table 'REGfaculty'
#

INSERT INTO REGfaculty VALUES (1,'Webmaster','webmaster@classweb.ucla.edu','','HIST','','','','','','','','');

#
# Table structure for table 'REGmeetings'
#

CREATE TABLE REGmeetings (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  days varchar(5) default NULL,
  start varchar(6) default NULL,
  stop varchar(6) default NULL,
  bldg varchar(10) default NULL,
  room varchar(10) default NULL,
  startday varchar(6) default NULL,
  endday varchar(6) default NULL,
  KEY term(term,srs)
) TYPE=MyISAM;

#
# Dumping data for table 'REGmeetings'
#

INSERT INTO REGmeetings VALUES ('01W',100000000,'MWF','08:00','09:15','Wesley','15','','');

#
# Table structure for table 'REGprof'
#

CREATE TABLE REGprof (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  dept varchar(10) NOT NULL default '',
  coursenum varchar(10) NOT NULL default '',
  section varchar(6) default NULL,
  uid int(9) default NULL,
  reg_name varchar(18) default NULL,
  profcode char(2) default NULL,
  KEY term(term,srs)
) TYPE=MyISAM;

#
# Dumping data for table 'REGprof'
#

INSERT INTO REGprof VALUES ('01W',100000000,'HIST','101','1',1,'Webmaster','1');
INSERT INTO REGprof VALUES ('01W',100000000,'HIST','101','1',1,'Webmaster','4');

#
# Table structure for table 'REGrosters'
#

CREATE TABLE REGrosters (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  uid int(9) NOT NULL default '0',
  email varchar(50) NOT NULL default '',
  lastname varchar(35) NOT NULL default '',
  firstname varchar(35) NOT NULL default '',
  middlename varchar(35) default NULL,
  suffix varchar(10) default NULL,
  enroll_status char(1) NOT NULL default '',
  PRIMARY KEY (term,srs,uid)
) TYPE=MyISAM;

#
# Dumping data for table 'REGrosters'
#

INSERT INTO REGrosters VALUES ('01W',100000000,2,'glen_stewart@classweb.ucla.edu','Stewart','Glen','','','E');

#
# Table structure for table 'REGsummer'
#

CREATE TABLE REGsummer (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  session_code char(2) NOT NULL default '',
  session char(1) NOT NULL default '',
  PRIMARY KEY (term,srs)
) TYPE=MyISAM;

#
# Dumping data for table 'REGsummer'
#


#
# Table structure for table 'REGta'
#

CREATE TABLE REGta (
  term char(3) NOT NULL default '',
  uid int(9) NOT NULL default '0',
  fullname varchar(35) default NULL,
  email varchar(50) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  dept varchar(10) NOT NULL default '',
  coursenum varchar(10) NOT NULL default '',
  section varchar(6) default NULL,
  relsecidx varchar(4) NOT NULL default '',
  KEY term(term,dept,coursenum,relsecidx),
  KEY uid(uid)
) TYPE=MyISAM;

#
# Dumping data for table 'REGta'
#


#
# Table structure for table 'REGxref'
#

CREATE TABLE REGxref (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  xsrs varchar(9) NOT NULL default '',
  xdept varchar(10) NOT NULL default '',
  xcoursenum varchar(10) NOT NULL default '',
  xcrsidx varchar(8) default NULL,
  xurl tinytext,
  joinedclass char(3) default NULL,
  xactivity char(3) default NULL,
  xsection varchar(6) default NULL,
  KEY term(term,srs)
) TYPE=MyISAM;

#
# Dumping data for table 'REGxref'
#


#
# Table structure for table 'addadmin'
#

CREATE TABLE addadmin (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  uid int(9) NOT NULL default '0',
  PRIMARY KEY (term,srs,uid)
) TYPE=MyISAM;

#
# Dumping data for table 'addadmin'
#


#
# Table structure for table 'board_extras'
#

CREATE TABLE board_extras (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  username varchar(25) NOT NULL default '',
  display_name varchar(50) default '',
  auth varchar(64) NOT NULL default '',
  icon varchar(64) default '',
  PRIMARY KEY (term,srs,username)
) TYPE=MyISAM;

#
# Dumping data for table 'board_extras'
#


#
# Table structure for table 'boardnames'
#

CREATE TABLE boardnames (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  directory varchar(100) NOT NULL default '',
  title varchar(50) NOT NULL default '',
  creator varchar(9) NOT NULL default '',
  created timestamp(14) NOT NULL,
  PRIMARY KEY (term,srs,directory)
) TYPE=MyISAM;

#
# Dumping data for table 'boardnames'
#


#
# Table structure for table 'boards'
#

CREATE TABLE boards (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  directory varchar(100) NOT NULL default '',
  count smallint(6) NOT NULL default '0',
  auth char(1) default NULL,
  hwm smallint(6) NOT NULL default '0',
  type enum('main','extra','homework') default NULL,
  site enum('class','ta') default 'class',
  PRIMARY KEY (term,srs,directory)
) TYPE=MyISAM;

#
# Dumping data for table 'boards'
#

INSERT INTO boards VALUES ('01W',100000000,'01W/hist101-1/wwwboard/',0,'N',0,'main','class');

#
# Table structure for table 'classloc'
#

CREATE TABLE classloc (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  dept varchar(10) NOT NULL default '',
  coursenum varchar(10) NOT NULL default '',
  section varchar(6) default NULL,
  title varchar(160) default NULL,
  exam varchar(80) default NULL,
  description text,
  updated timestamp(14) NOT NULL,
  updateruid int(9) default NULL,
  remarks text,
  PRIMARY KEY (term,srs),
  KEY dept(dept),
  KEY coursenum(coursenum)
) TYPE=MyISAM;

#
# Dumping data for table 'classloc'
#


#
# Table structure for table 'current'
#

CREATE TABLE current (
  term char(3) NOT NULL default '',
  valid varchar(160) default NULL,
  next char(3) NOT NULL default '',
  previous char(3) NOT NULL default '',
  PRIMARY KEY (term)
) TYPE=MyISAM;

#
# Dumping data for table 'current'
#

INSERT INTO current VALUES ('01W','00F 01W 01S 011','01S','00F');

#
# Table structure for table 'current2'
#

CREATE TABLE current2 (
  term char(3) NOT NULL default '',
  name varchar(15) NOT NULL default '',
  PRIMARY KEY (term)
) TYPE=MyISAM;

#
# Dumping data for table 'current2'
#

INSERT INTO current2 VALUES ('00F','Fall 2000');
INSERT INTO current2 VALUES ('01W','Winter 2001');
INSERT INTO current2 VALUES ('01S','Spring 2001');
INSERT INTO current2 VALUES ('011','Summer 2001');

#
# Table structure for table 'dates'
#

CREATE TABLE dates (
  days varchar(6) default NULL
) TYPE=MyISAM;

#
# Dumping data for table 'dates'
#

INSERT INTO dates VALUES ('');
INSERT INTO dates VALUES ('Jan 1');
INSERT INTO dates VALUES ('Jan 2');
INSERT INTO dates VALUES ('Jan 3');
INSERT INTO dates VALUES ('Jan 4');
INSERT INTO dates VALUES ('Jan 5');
INSERT INTO dates VALUES ('Jan 6');
INSERT INTO dates VALUES ('Jan 7');
INSERT INTO dates VALUES ('Jan 8');
INSERT INTO dates VALUES ('Jan 9');
INSERT INTO dates VALUES ('Jan 10');
INSERT INTO dates VALUES ('Jan 11');
INSERT INTO dates VALUES ('Jan 12');
INSERT INTO dates VALUES ('Jan 13');
INSERT INTO dates VALUES ('Jan 14');
INSERT INTO dates VALUES ('Jan 15');
INSERT INTO dates VALUES ('Jan 16');
INSERT INTO dates VALUES ('Jan 17');
INSERT INTO dates VALUES ('Jan 18');
INSERT INTO dates VALUES ('Jan 19');
INSERT INTO dates VALUES ('Jan 20');
INSERT INTO dates VALUES ('Jan 21');
INSERT INTO dates VALUES ('Jan 22');
INSERT INTO dates VALUES ('Jan 23');
INSERT INTO dates VALUES ('Jan 24');
INSERT INTO dates VALUES ('Jan 25');
INSERT INTO dates VALUES ('Jan 26');
INSERT INTO dates VALUES ('Jan 27');
INSERT INTO dates VALUES ('Jan 28');
INSERT INTO dates VALUES ('Jan 29');
INSERT INTO dates VALUES ('Jan 30');
INSERT INTO dates VALUES ('Jan 31');
INSERT INTO dates VALUES ('Feb 1');
INSERT INTO dates VALUES ('Feb 2');
INSERT INTO dates VALUES ('Feb 3');
INSERT INTO dates VALUES ('Feb 4');
INSERT INTO dates VALUES ('Feb 5');
INSERT INTO dates VALUES ('Feb 6');
INSERT INTO dates VALUES ('Feb 7');
INSERT INTO dates VALUES ('Feb 8');
INSERT INTO dates VALUES ('Feb 9');
INSERT INTO dates VALUES ('Feb 10');
INSERT INTO dates VALUES ('Feb 11');
INSERT INTO dates VALUES ('Feb 12');
INSERT INTO dates VALUES ('Feb 13');
INSERT INTO dates VALUES ('Feb 14');
INSERT INTO dates VALUES ('Feb 15');
INSERT INTO dates VALUES ('Feb 16');
INSERT INTO dates VALUES ('Feb 17');
INSERT INTO dates VALUES ('Feb 18');
INSERT INTO dates VALUES ('Feb 19');
INSERT INTO dates VALUES ('Feb 20');
INSERT INTO dates VALUES ('Feb 21');
INSERT INTO dates VALUES ('Feb 22');
INSERT INTO dates VALUES ('Feb 23');
INSERT INTO dates VALUES ('Feb 24');
INSERT INTO dates VALUES ('Feb 25');
INSERT INTO dates VALUES ('Feb 26');
INSERT INTO dates VALUES ('Feb 27');
INSERT INTO dates VALUES ('Feb 28');
INSERT INTO dates VALUES ('Feb 29');
INSERT INTO dates VALUES ('Mar 1');
INSERT INTO dates VALUES ('Mar 2');
INSERT INTO dates VALUES ('Mar 3');
INSERT INTO dates VALUES ('Mar 4');
INSERT INTO dates VALUES ('Mar 5');
INSERT INTO dates VALUES ('Mar 6');
INSERT INTO dates VALUES ('Mar 7');
INSERT INTO dates VALUES ('Mar 8');
INSERT INTO dates VALUES ('Mar 9');
INSERT INTO dates VALUES ('Mar 10');
INSERT INTO dates VALUES ('Mar 11');
INSERT INTO dates VALUES ('Mar 12');
INSERT INTO dates VALUES ('Mar 13');
INSERT INTO dates VALUES ('Mar 14');
INSERT INTO dates VALUES ('Mar 15');
INSERT INTO dates VALUES ('Mar 16');
INSERT INTO dates VALUES ('Mar 17');
INSERT INTO dates VALUES ('Mar 18');
INSERT INTO dates VALUES ('Mar 19');
INSERT INTO dates VALUES ('Mar 20');
INSERT INTO dates VALUES ('Mar 21');
INSERT INTO dates VALUES ('Mar 22');
INSERT INTO dates VALUES ('Mar 23');
INSERT INTO dates VALUES ('Mar 24');
INSERT INTO dates VALUES ('Mar 25');
INSERT INTO dates VALUES ('Mar 26');
INSERT INTO dates VALUES ('Mar 27');
INSERT INTO dates VALUES ('Mar 28');
INSERT INTO dates VALUES ('Mar 29');
INSERT INTO dates VALUES ('Mar 30');
INSERT INTO dates VALUES ('Mar 31');
INSERT INTO dates VALUES ('Apr 1');
INSERT INTO dates VALUES ('Apr 2');
INSERT INTO dates VALUES ('Apr 3');
INSERT INTO dates VALUES ('Apr 4');
INSERT INTO dates VALUES ('Apr 5');
INSERT INTO dates VALUES ('Apr 6');
INSERT INTO dates VALUES ('Apr 7');
INSERT INTO dates VALUES ('Apr 8');
INSERT INTO dates VALUES ('Apr 9');
INSERT INTO dates VALUES ('Apr 10');
INSERT INTO dates VALUES ('Apr 11');
INSERT INTO dates VALUES ('Apr 12');
INSERT INTO dates VALUES ('Apr 13');
INSERT INTO dates VALUES ('Apr 14');
INSERT INTO dates VALUES ('Apr 15');
INSERT INTO dates VALUES ('Apr 16');
INSERT INTO dates VALUES ('Apr 17');
INSERT INTO dates VALUES ('Apr 18');
INSERT INTO dates VALUES ('Apr 19');
INSERT INTO dates VALUES ('Apr 20');
INSERT INTO dates VALUES ('Apr 21');
INSERT INTO dates VALUES ('Apr 22');
INSERT INTO dates VALUES ('Apr 23');
INSERT INTO dates VALUES ('Apr 24');
INSERT INTO dates VALUES ('Apr 25');
INSERT INTO dates VALUES ('Apr 26');
INSERT INTO dates VALUES ('Apr 27');
INSERT INTO dates VALUES ('Apr 28');
INSERT INTO dates VALUES ('Apr 29');
INSERT INTO dates VALUES ('Apr 30');
INSERT INTO dates VALUES ('May 1');
INSERT INTO dates VALUES ('May 2');
INSERT INTO dates VALUES ('May 3');
INSERT INTO dates VALUES ('May 4');
INSERT INTO dates VALUES ('May 5');
INSERT INTO dates VALUES ('May 6');
INSERT INTO dates VALUES ('May 7');
INSERT INTO dates VALUES ('May 8');
INSERT INTO dates VALUES ('May 9');
INSERT INTO dates VALUES ('May 10');
INSERT INTO dates VALUES ('May 11');
INSERT INTO dates VALUES ('May 12');
INSERT INTO dates VALUES ('May 13');
INSERT INTO dates VALUES ('May 14');
INSERT INTO dates VALUES ('May 15');
INSERT INTO dates VALUES ('May 16');
INSERT INTO dates VALUES ('May 17');
INSERT INTO dates VALUES ('May 18');
INSERT INTO dates VALUES ('May 19');
INSERT INTO dates VALUES ('May 20');
INSERT INTO dates VALUES ('May 21');
INSERT INTO dates VALUES ('May 22');
INSERT INTO dates VALUES ('May 23');
INSERT INTO dates VALUES ('May 24');
INSERT INTO dates VALUES ('May 25');
INSERT INTO dates VALUES ('May 26');
INSERT INTO dates VALUES ('May 27');
INSERT INTO dates VALUES ('May 28');
INSERT INTO dates VALUES ('May 29');
INSERT INTO dates VALUES ('May 30');
INSERT INTO dates VALUES ('May 31');
INSERT INTO dates VALUES ('Jun 1');
INSERT INTO dates VALUES ('Jun 2');
INSERT INTO dates VALUES ('Jun 3');
INSERT INTO dates VALUES ('Jun 4');
INSERT INTO dates VALUES ('Jun 5');
INSERT INTO dates VALUES ('Jun 6');
INSERT INTO dates VALUES ('Jun 7');
INSERT INTO dates VALUES ('Jun 8');
INSERT INTO dates VALUES ('Jun 9');
INSERT INTO dates VALUES ('Jun 10');
INSERT INTO dates VALUES ('Jun 11');
INSERT INTO dates VALUES ('Jun 12');
INSERT INTO dates VALUES ('Jun 13');
INSERT INTO dates VALUES ('Jun 14');
INSERT INTO dates VALUES ('Jun 15');
INSERT INTO dates VALUES ('Jun 16');
INSERT INTO dates VALUES ('Jun 17');
INSERT INTO dates VALUES ('Jun 18');
INSERT INTO dates VALUES ('Jun 19');
INSERT INTO dates VALUES ('Jun 20');
INSERT INTO dates VALUES ('Jun 21');
INSERT INTO dates VALUES ('Jun 22');
INSERT INTO dates VALUES ('Jun 23');
INSERT INTO dates VALUES ('Jun 24');
INSERT INTO dates VALUES ('Jun 25');
INSERT INTO dates VALUES ('Jun 26');
INSERT INTO dates VALUES ('Jun 27');
INSERT INTO dates VALUES ('Jun 28');
INSERT INTO dates VALUES ('Jun 29');
INSERT INTO dates VALUES ('Jun 30');
INSERT INTO dates VALUES ('Jul 1');
INSERT INTO dates VALUES ('Jul 2');
INSERT INTO dates VALUES ('Jul 3');
INSERT INTO dates VALUES ('Jul 4');
INSERT INTO dates VALUES ('Jul 5');
INSERT INTO dates VALUES ('Jul 6');
INSERT INTO dates VALUES ('Jul 7');
INSERT INTO dates VALUES ('Jul 8');
INSERT INTO dates VALUES ('Jul 9');
INSERT INTO dates VALUES ('Jul 10');
INSERT INTO dates VALUES ('Jul 11');
INSERT INTO dates VALUES ('Jul 12');
INSERT INTO dates VALUES ('Jul 13');
INSERT INTO dates VALUES ('Jul 14');
INSERT INTO dates VALUES ('Jul 15');
INSERT INTO dates VALUES ('Jul 16');
INSERT INTO dates VALUES ('Jul 17');
INSERT INTO dates VALUES ('Jul 18');
INSERT INTO dates VALUES ('Jul 19');
INSERT INTO dates VALUES ('Jul 20');
INSERT INTO dates VALUES ('Jul 21');
INSERT INTO dates VALUES ('Jul 22');
INSERT INTO dates VALUES ('Jul 23');
INSERT INTO dates VALUES ('Jul 24');
INSERT INTO dates VALUES ('Jul 25');
INSERT INTO dates VALUES ('Jul 26');
INSERT INTO dates VALUES ('Jul 27');
INSERT INTO dates VALUES ('Jul 28');
INSERT INTO dates VALUES ('Jul 29');
INSERT INTO dates VALUES ('Jul 30');
INSERT INTO dates VALUES ('Jul 31');
INSERT INTO dates VALUES ('Aug 1');
INSERT INTO dates VALUES ('Aug 2');
INSERT INTO dates VALUES ('Aug 3');
INSERT INTO dates VALUES ('Aug 4');
INSERT INTO dates VALUES ('Aug 5');
INSERT INTO dates VALUES ('Aug 6');
INSERT INTO dates VALUES ('Aug 7');
INSERT INTO dates VALUES ('Aug 8');
INSERT INTO dates VALUES ('Aug 9');
INSERT INTO dates VALUES ('Aug 10');
INSERT INTO dates VALUES ('Aug 11');
INSERT INTO dates VALUES ('Aug 12');
INSERT INTO dates VALUES ('Aug 13');
INSERT INTO dates VALUES ('Aug 14');
INSERT INTO dates VALUES ('Aug 15');
INSERT INTO dates VALUES ('Aug 16');
INSERT INTO dates VALUES ('Aug 17');
INSERT INTO dates VALUES ('Aug 18');
INSERT INTO dates VALUES ('Aug 19');
INSERT INTO dates VALUES ('Aug 20');
INSERT INTO dates VALUES ('Aug 21');
INSERT INTO dates VALUES ('Aug 22');
INSERT INTO dates VALUES ('Aug 23');
INSERT INTO dates VALUES ('Aug 24');
INSERT INTO dates VALUES ('Aug 25');
INSERT INTO dates VALUES ('Aug 26');
INSERT INTO dates VALUES ('Aug 27');
INSERT INTO dates VALUES ('Aug 28');
INSERT INTO dates VALUES ('Aug 29');
INSERT INTO dates VALUES ('Aug 30');
INSERT INTO dates VALUES ('Aug 31');
INSERT INTO dates VALUES ('Sep 1');
INSERT INTO dates VALUES ('Sep 2');
INSERT INTO dates VALUES ('Sep 3');
INSERT INTO dates VALUES ('Sep 4');
INSERT INTO dates VALUES ('Sep 5');
INSERT INTO dates VALUES ('Sep 6');
INSERT INTO dates VALUES ('Sep 7');
INSERT INTO dates VALUES ('Sep 8');
INSERT INTO dates VALUES ('Sep 9');
INSERT INTO dates VALUES ('Sep 10');
INSERT INTO dates VALUES ('Sep 11');
INSERT INTO dates VALUES ('Sep 12');
INSERT INTO dates VALUES ('Sep 13');
INSERT INTO dates VALUES ('Sep 14');
INSERT INTO dates VALUES ('Sep 15');
INSERT INTO dates VALUES ('Sep 16');
INSERT INTO dates VALUES ('Sep 17');
INSERT INTO dates VALUES ('Sep 18');
INSERT INTO dates VALUES ('Sep 19');
INSERT INTO dates VALUES ('Sep 20');
INSERT INTO dates VALUES ('Sep 21');
INSERT INTO dates VALUES ('Sep 22');
INSERT INTO dates VALUES ('Sep 23');
INSERT INTO dates VALUES ('Sep 24');
INSERT INTO dates VALUES ('Sep 25');
INSERT INTO dates VALUES ('Sep 26');
INSERT INTO dates VALUES ('Sep 27');
INSERT INTO dates VALUES ('Sep 28');
INSERT INTO dates VALUES ('Sep 29');
INSERT INTO dates VALUES ('Sep 30');
INSERT INTO dates VALUES ('Oct 1');
INSERT INTO dates VALUES ('Oct 2');
INSERT INTO dates VALUES ('Oct 3');
INSERT INTO dates VALUES ('Oct 4');
INSERT INTO dates VALUES ('Oct 5');
INSERT INTO dates VALUES ('Oct 6');
INSERT INTO dates VALUES ('Oct 7');
INSERT INTO dates VALUES ('Oct 8');
INSERT INTO dates VALUES ('Oct 9');
INSERT INTO dates VALUES ('Oct 10');
INSERT INTO dates VALUES ('Oct 11');
INSERT INTO dates VALUES ('Oct 12');
INSERT INTO dates VALUES ('Oct 13');
INSERT INTO dates VALUES ('Oct 14');
INSERT INTO dates VALUES ('Oct 15');
INSERT INTO dates VALUES ('Oct 16');
INSERT INTO dates VALUES ('Oct 17');
INSERT INTO dates VALUES ('Oct 18');
INSERT INTO dates VALUES ('Oct 19');
INSERT INTO dates VALUES ('Oct 20');
INSERT INTO dates VALUES ('Oct 21');
INSERT INTO dates VALUES ('Oct 22');
INSERT INTO dates VALUES ('Oct 23');
INSERT INTO dates VALUES ('Oct 24');
INSERT INTO dates VALUES ('Oct 25');
INSERT INTO dates VALUES ('Oct 26');
INSERT INTO dates VALUES ('Oct 27');
INSERT INTO dates VALUES ('Oct 28');
INSERT INTO dates VALUES ('Oct 29');
INSERT INTO dates VALUES ('Oct 30');
INSERT INTO dates VALUES ('Oct 31');
INSERT INTO dates VALUES ('Nov 1');
INSERT INTO dates VALUES ('Nov 2');
INSERT INTO dates VALUES ('Nov 3');
INSERT INTO dates VALUES ('Nov 4');
INSERT INTO dates VALUES ('Nov 5');
INSERT INTO dates VALUES ('Nov 6');
INSERT INTO dates VALUES ('Nov 7');
INSERT INTO dates VALUES ('Nov 8');
INSERT INTO dates VALUES ('Nov 9');
INSERT INTO dates VALUES ('Nov 10');
INSERT INTO dates VALUES ('Nov 11');
INSERT INTO dates VALUES ('Nov 12');
INSERT INTO dates VALUES ('Nov 13');
INSERT INTO dates VALUES ('Nov 14');
INSERT INTO dates VALUES ('Nov 15');
INSERT INTO dates VALUES ('Nov 16');
INSERT INTO dates VALUES ('Nov 17');
INSERT INTO dates VALUES ('Nov 18');
INSERT INTO dates VALUES ('Nov 19');
INSERT INTO dates VALUES ('Nov 20');
INSERT INTO dates VALUES ('Nov 21');
INSERT INTO dates VALUES ('Nov 22');
INSERT INTO dates VALUES ('Nov 23');
INSERT INTO dates VALUES ('Nov 24');
INSERT INTO dates VALUES ('Nov 25');
INSERT INTO dates VALUES ('Nov 26');
INSERT INTO dates VALUES ('Nov 27');
INSERT INTO dates VALUES ('Nov 28');
INSERT INTO dates VALUES ('Nov 29');
INSERT INTO dates VALUES ('Nov 30');
INSERT INTO dates VALUES ('Dec 1');
INSERT INTO dates VALUES ('Dec 2');
INSERT INTO dates VALUES ('Dec 3');
INSERT INTO dates VALUES ('Dec 4');
INSERT INTO dates VALUES ('Dec 5');
INSERT INTO dates VALUES ('Dec 6');
INSERT INTO dates VALUES ('Dec 7');
INSERT INTO dates VALUES ('Dec 8');
INSERT INTO dates VALUES ('Dec 9');
INSERT INTO dates VALUES ('Dec 10');
INSERT INTO dates VALUES ('Dec 11');
INSERT INTO dates VALUES ('Dec 12');
INSERT INTO dates VALUES ('Dec 13');
INSERT INTO dates VALUES ('Dec 14');
INSERT INTO dates VALUES ('Dec 15');
INSERT INTO dates VALUES ('Dec 16');
INSERT INTO dates VALUES ('Dec 17');
INSERT INTO dates VALUES ('Dec 18');
INSERT INTO dates VALUES ('Dec 19');
INSERT INTO dates VALUES ('Dec 20');
INSERT INTO dates VALUES ('Dec 21');
INSERT INTO dates VALUES ('Dec 22');
INSERT INTO dates VALUES ('Dec 23');
INSERT INTO dates VALUES ('Dec 24');
INSERT INTO dates VALUES ('Dec 25');
INSERT INTO dates VALUES ('Dec 26');
INSERT INTO dates VALUES ('Dec 27');
INSERT INTO dates VALUES ('Dec 28');
INSERT INTO dates VALUES ('Dec 29');
INSERT INTO dates VALUES ('Dec 30');
INSERT INTO dates VALUES ('Dec 31');

#
# Table structure for table 'feedback'
#

CREATE TABLE feedback (
  ID int(11) NOT NULL auto_increment,
  name varchar(100) default '',
  email varchar(50) default '',
  server varchar(100) default '',
  user_agent varchar(100) default '',
  remote_addr varchar(100) default '',
  referer varchar(100) default '',
  comments text NOT NULL,
  comment_time timestamp(14) NOT NULL,
  PRIMARY KEY (ID)
) TYPE=MyISAM;

#
# Dumping data for table 'feedback'
#


#
# Table structure for table 'hours'
#

CREATE TABLE hours (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  uid int(9) NOT NULL default '0',
  office_hours varchar(80) default NULL,
  PRIMARY KEY (term,srs,uid)
) TYPE=MyISAM;

#
# Dumping data for table 'hours'
#

INSERT INTO hours VALUES ('00W',111110110,2,'T-TH 3-5pm');
INSERT INTO hours VALUES ('00W',207086131,6,'8-6pm M-F');
INSERT INTO hours VALUES ('01W',207795203,12,'9-5');
INSERT INTO hours VALUES ('01W',207795201,10,'7-3');
INSERT INTO hours VALUES ('01W',207795204,6,'2-3pm');
INSERT INTO hours VALUES ('01W',207795205,13,'2:30-3pm');
INSERT INTO hours VALUES ('01W',207795205,5,'10am-4pm');
INSERT INTO hours VALUES ('01W',207795201,8,'9-5');
INSERT INTO hours VALUES ('01W',100000000,1,'9am-5pm');

#
# Table structure for table 'indirect_url'
#

CREATE TABLE indirect_url (
  term char(3) default NULL,
  srs int(9) default NULL,
  url tinytext
) TYPE=MyISAM;

#
# Dumping data for table 'indirect_url'
#


#
# Table structure for table 'joinedclasses'
#

CREATE TABLE joinedclasses (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  xsrs int(9) NOT NULL default '0',
  PRIMARY KEY (term,srs,xsrs)
) TYPE=MyISAM;

#
# Dumping data for table 'joinedclasses'
#


#
# Table structure for table 'linkold'
#

CREATE TABLE linkold (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  site enum('class','ta') NOT NULL default 'class',
  PRIMARY KEY (term,srs,site)
) TYPE=MyISAM;

#
# Dumping data for table 'linkold'
#


#
# Table structure for table 'links'
#

CREATE TABLE links (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  ID int(11) NOT NULL auto_increment,
  parent int(11) default NULL,
  name varchar(80) NOT NULL default '',
  url tinytext,
  description text,
  sort float(10,2) default NULL,
  updated timestamp(14) NOT NULL,
  updater varchar(20) default NULL,
  site enum('class','ta') default 'class',
  PRIMARY KEY (ID),
  KEY termsrs(term,srs)
) TYPE=MyISAM;

#
# Dumping data for table 'links'
#


#
# Table structure for table 'oldclasses'
#

CREATE TABLE oldclasses (
  term varchar(9) NOT NULL default '',
  srs int(9) default NULL,
  uid int(9) default NULL,
  dept varchar(10) NOT NULL default '',
  coursenum varchar(10) NOT NULL default '',
  section varchar(6) default NULL,
  url tinytext,
  status enum('exist','mia','overwrite','modified') default 'exist',
  notes tinytext,
  password varchar(25) default '',
  profname varchar(35) default '',
  crsidx varchar(8) default NULL
) TYPE=MyISAM;

#
# Dumping data for table 'oldclasses'
#


#
# Table structure for table 'order_table'
#

CREATE TABLE order_table (
  term char(3) default NULL,
  rank smallint(5) default NULL
) TYPE=MyISAM;

#
# Dumping data for table 'order_table'
#

INSERT INTO order_table VALUES ('97S',100);
INSERT INTO order_table VALUES ('971',101);
INSERT INTO order_table VALUES ('97F',102);
INSERT INTO order_table VALUES ('98W',103);
INSERT INTO order_table VALUES ('98S',104);
INSERT INTO order_table VALUES ('981',105);
INSERT INTO order_table VALUES ('98F',106);
INSERT INTO order_table VALUES ('99W',107);
INSERT INTO order_table VALUES ('99S',108);
INSERT INTO order_table VALUES ('991',109);
INSERT INTO order_table VALUES ('99F',110);
INSERT INTO order_table VALUES ('00W',111);
INSERT INTO order_table VALUES ('00S',112);
INSERT INTO order_table VALUES ('001',113);
INSERT INTO order_table VALUES ('00F',114);
INSERT INTO order_table VALUES ('01W',115);
INSERT INTO order_table VALUES ('01S',116);
INSERT INTO order_table VALUES ('011',117);
INSERT INTO order_table VALUES ('01F',118);
INSERT INTO order_table VALUES ('02W',119);
INSERT INTO order_table VALUES ('02S',120);
INSERT INTO order_table VALUES ('021',121);
INSERT INTO order_table VALUES ('02F',122);
INSERT INTO order_table VALUES ('03W',123);
INSERT INTO order_table VALUES ('03S',124);
INSERT INTO order_table VALUES ('031',125);
INSERT INTO order_table VALUES ('03F',126);

#
# Table structure for table 'profcontacts'
#

CREATE TABLE profcontacts (
  entry int(11) NOT NULL auto_increment,
  uid int(9) default NULL,
  updated timestamp(14) NOT NULL,
  type enum('phone','meeting','email','massmail') default 'phone',
  staff_uid int(9) default NULL,
  notes text,
  followup text,
  PRIMARY KEY (entry)
) TYPE=MyISAM;

#
# Dumping data for table 'profcontacts'
#

INSERT INTO profcontacts VALUES (1,1,20010220205255,'massmail',NULL,'01W HIST 101-1 ClassWeb site created: sent to webmaster@classweb.ucla.edu','');

#
# Table structure for table 'profsloc'
#

CREATE TABLE profsloc (
  uid int(9) NOT NULL default '0',
  fullname varchar(35) default NULL,
  office varchar(50) default NULL,
  phone varchar(35) default NULL,
  email varchar(50) default NULL,
  notes text,
  hide_email enum('Yes','No') default 'No',
  password varchar(8) default NULL,
  email2 varchar(50) default NULL,
  updated timestamp(14) NOT NULL,
  updateruid int(9) default NULL,
  PRIMARY KEY (uid)
) TYPE=MyISAM;

#
# Dumping data for table 'profsloc'
#

INSERT INTO profsloc VALUES (1,'Webmaster','JON 316','800-555-1212','webmaster@classweb.ucla.edu','','No','','webmaster@classweb.ucla.edu',20010220205610,1);

#
# Table structure for table 'profurl'
#

CREATE TABLE profurl (
  uid int(9) NOT NULL default '0',
  url tinytext,
  PRIMARY KEY (uid)
) TYPE=MyISAM;

#
# Dumping data for table 'profurl'
#

INSERT INTO profurl VALUES (1,'http://classweb.ucla.edu');

#
# Table structure for table 'reports'
#

CREATE TABLE reports (
  title text NOT NULL,
  query text NOT NULL,
  notes text,
  number int(11) NOT NULL auto_increment,
  PRIMARY KEY (number)
) TYPE=MyISAM;

#
# Dumping data for table 'reports'
#

INSERT INTO reports VALUES ('test report','select a.dept,a.coursenum,a.crsidx,a.section,a.srs,reg_name,profcode from REGclasses a left join REGprof b using(term,srs) where a.term=\"00S\" && reg_name is NULL order by a.dept,a.crsidx,b.reg_name','A-mazing report.  i have learned so much!',12);
INSERT INTO reports VALUES ('nother junkie report','select a.dept,a.coursenum,a.crsidx,a.section,a.srs,reg_name,profcode from REGclasses a left join REGprof b using(term,srs) where a.term=\"00S\" && reg_name is NULL order by a.dept,a.crsidx,b.reg_name','ooooo, more reports ',14);

#
# Table structure for table 'rostermail'
#

CREATE TABLE rostermail (
  time varchar(50) default NULL,
  term char(3) NOT NULL default '',
  dept varchar(10) NOT NULL default '',
  coursenum varchar(10) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  reg_name varchar(30) default NULL,
  subject varchar(200) default NULL,
  TA char(3) default NULL,
  timestamp timestamp(14) NOT NULL,
  uid int(9) NOT NULL default '0',
  KEY term(term,srs)
) TYPE=MyISAM;

#
# Dumping data for table 'rostermail'
#


#
# Table structure for table 'sections'
#

CREATE TABLE sections (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  uid int(9) NOT NULL default '0',
  url tinytext,
  PRIMARY KEY (term,srs,uid)
) TYPE=MyISAM;

#
# Dumping data for table 'sections'
#


#
# Table structure for table 'sitelog'
#

CREATE TABLE sitelog (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  url tinytext NOT NULL,
  dir tinytext NOT NULL,
  status text,
  notes text,
  updated timestamp(14) NOT NULL,
  updateruid int(9) default NULL,
  PRIMARY KEY (term,srs)
) TYPE=MyISAM;

#
# Dumping data for table 'sitelog'
#

INSERT INTO sitelog VALUES ('01W',100000000,'classweb.ucla.edu/classes/01W/hist101-1/','/web/classes/01W/hist101-1',' CREATED',NULL,20010220205255,0);

#
# Table structure for table 'stats'
#

CREATE TABLE stats (
  term char(3) NOT NULL default '',
  srs int(9) NOT NULL default '0',
  syllabus enum('DK','No','YesS','YesH','Refuse','YesPrev','YesPrelim','Archive') default 'DK',
  hits int(11) default NULL,
  menu int(11) default NULL,
  announce int(11) default NULL,
  links int(11) default NULL,
  PRIMARY KEY (srs,term)
) TYPE=MyISAM;

#
# Dumping data for table 'stats'
#

INSERT INTO stats VALUES ('01W',100000000,'No',29,9,0,0);

#
# Table structure for table 'times'
#

CREATE TABLE times (
  time varchar(5) default NULL
) TYPE=MyISAM;

#
# Dumping data for table 'times'
#

INSERT INTO times VALUES ('');
INSERT INTO times VALUES ('06:00');
INSERT INTO times VALUES ('06:05');
INSERT INTO times VALUES ('06:10');
INSERT INTO times VALUES ('06:15');
INSERT INTO times VALUES ('06:20');
INSERT INTO times VALUES ('06:25');
INSERT INTO times VALUES ('06:30');
INSERT INTO times VALUES ('06:35');
INSERT INTO times VALUES ('06:40');
INSERT INTO times VALUES ('06:45');
INSERT INTO times VALUES ('06:50');
INSERT INTO times VALUES ('06:55');
INSERT INTO times VALUES ('07:00');
INSERT INTO times VALUES ('07:05');
INSERT INTO times VALUES ('07:10');
INSERT INTO times VALUES ('07:15');
INSERT INTO times VALUES ('07:20');
INSERT INTO times VALUES ('07:25');
INSERT INTO times VALUES ('07:30');
INSERT INTO times VALUES ('07:35');
INSERT INTO times VALUES ('07:40');
INSERT INTO times VALUES ('07:45');
INSERT INTO times VALUES ('07:50');
INSERT INTO times VALUES ('07:55');
INSERT INTO times VALUES ('08:00');
INSERT INTO times VALUES ('08:05');
INSERT INTO times VALUES ('08:10');
INSERT INTO times VALUES ('08:15');
INSERT INTO times VALUES ('08:20');
INSERT INTO times VALUES ('08:25');
INSERT INTO times VALUES ('08:30');
INSERT INTO times VALUES ('08:35');
INSERT INTO times VALUES ('08:40');
INSERT INTO times VALUES ('08:45');
INSERT INTO times VALUES ('08:50');
INSERT INTO times VALUES ('08:55');
INSERT INTO times VALUES ('09:00');
INSERT INTO times VALUES ('09:05');
INSERT INTO times VALUES ('09:10');
INSERT INTO times VALUES ('09:15');
INSERT INTO times VALUES ('09:20');
INSERT INTO times VALUES ('09:25');
INSERT INTO times VALUES ('09:30');
INSERT INTO times VALUES ('09:35');
INSERT INTO times VALUES ('09:40');
INSERT INTO times VALUES ('09:45');
INSERT INTO times VALUES ('09:50');
INSERT INTO times VALUES ('09:55');
INSERT INTO times VALUES ('10:00');
INSERT INTO times VALUES ('10:05');
INSERT INTO times VALUES ('10:10');
INSERT INTO times VALUES ('10:15');
INSERT INTO times VALUES ('10:20');
INSERT INTO times VALUES ('10:25');
INSERT INTO times VALUES ('10:30');
INSERT INTO times VALUES ('10:35');
INSERT INTO times VALUES ('10:40');
INSERT INTO times VALUES ('10:45');
INSERT INTO times VALUES ('10:50');
INSERT INTO times VALUES ('10:55');
INSERT INTO times VALUES ('11:00');
INSERT INTO times VALUES ('11:05');
INSERT INTO times VALUES ('11:10');
INSERT INTO times VALUES ('11:15');
INSERT INTO times VALUES ('11:20');
INSERT INTO times VALUES ('11:25');
INSERT INTO times VALUES ('11:30');
INSERT INTO times VALUES ('11:35');
INSERT INTO times VALUES ('11:40');
INSERT INTO times VALUES ('11:45');
INSERT INTO times VALUES ('11:50');
INSERT INTO times VALUES ('11:55');
INSERT INTO times VALUES ('12:00');
INSERT INTO times VALUES ('12:05');
INSERT INTO times VALUES ('12:10');
INSERT INTO times VALUES ('12:15');
INSERT INTO times VALUES ('12:20');
INSERT INTO times VALUES ('12:25');
INSERT INTO times VALUES ('12:30');
INSERT INTO times VALUES ('12:35');
INSERT INTO times VALUES ('12:40');
INSERT INTO times VALUES ('12:45');
INSERT INTO times VALUES ('12:50');
INSERT INTO times VALUES ('12:55');
INSERT INTO times VALUES ('13:00');
INSERT INTO times VALUES ('13:05');
INSERT INTO times VALUES ('13:10');
INSERT INTO times VALUES ('13:15');
INSERT INTO times VALUES ('13:20');
INSERT INTO times VALUES ('13:25');
INSERT INTO times VALUES ('13:30');
INSERT INTO times VALUES ('13:35');
INSERT INTO times VALUES ('13:40');
INSERT INTO times VALUES ('13:45');
INSERT INTO times VALUES ('13:50');
INSERT INTO times VALUES ('13:55');
INSERT INTO times VALUES ('14:00');
INSERT INTO times VALUES ('14:05');
INSERT INTO times VALUES ('14:10');
INSERT INTO times VALUES ('14:15');
INSERT INTO times VALUES ('14:20');
INSERT INTO times VALUES ('14:25');
INSERT INTO times VALUES ('14:30');
INSERT INTO times VALUES ('14:35');
INSERT INTO times VALUES ('14:40');
INSERT INTO times VALUES ('14:45');
INSERT INTO times VALUES ('14:50');
INSERT INTO times VALUES ('14:55');
INSERT INTO times VALUES ('15:00');
INSERT INTO times VALUES ('15:05');
INSERT INTO times VALUES ('15:10');
INSERT INTO times VALUES ('15:15');
INSERT INTO times VALUES ('15:20');
INSERT INTO times VALUES ('15:25');
INSERT INTO times VALUES ('15:30');
INSERT INTO times VALUES ('15:35');
INSERT INTO times VALUES ('15:40');
INSERT INTO times VALUES ('15:45');
INSERT INTO times VALUES ('15:50');
INSERT INTO times VALUES ('15:55');
INSERT INTO times VALUES ('16:00');
INSERT INTO times VALUES ('16:05');
INSERT INTO times VALUES ('16:10');
INSERT INTO times VALUES ('16:15');
INSERT INTO times VALUES ('16:20');
INSERT INTO times VALUES ('16:25');
INSERT INTO times VALUES ('16:30');
INSERT INTO times VALUES ('16:35');
INSERT INTO times VALUES ('16:40');
INSERT INTO times VALUES ('16:45');
INSERT INTO times VALUES ('16:50');
INSERT INTO times VALUES ('16:55');
INSERT INTO times VALUES ('17:00');
INSERT INTO times VALUES ('17:05');
INSERT INTO times VALUES ('17:10');
INSERT INTO times VALUES ('17:15');
INSERT INTO times VALUES ('17:20');
INSERT INTO times VALUES ('17:25');
INSERT INTO times VALUES ('17:30');
INSERT INTO times VALUES ('17:35');
INSERT INTO times VALUES ('17:40');
INSERT INTO times VALUES ('17:45');
INSERT INTO times VALUES ('17:50');
INSERT INTO times VALUES ('17:55');
INSERT INTO times VALUES ('18:00');
INSERT INTO times VALUES ('18:05');
INSERT INTO times VALUES ('18:10');
INSERT INTO times VALUES ('18:15');
INSERT INTO times VALUES ('18:20');
INSERT INTO times VALUES ('18:25');
INSERT INTO times VALUES ('18:30');
INSERT INTO times VALUES ('18:35');
INSERT INTO times VALUES ('18:40');
INSERT INTO times VALUES ('18:45');
INSERT INTO times VALUES ('18:50');
INSERT INTO times VALUES ('18:55');
INSERT INTO times VALUES ('19:00');
INSERT INTO times VALUES ('19:05');
INSERT INTO times VALUES ('19:10');
INSERT INTO times VALUES ('19:15');
INSERT INTO times VALUES ('19:20');
INSERT INTO times VALUES ('19:25');
INSERT INTO times VALUES ('19:30');
INSERT INTO times VALUES ('19:35');
INSERT INTO times VALUES ('19:40');
INSERT INTO times VALUES ('19:45');
INSERT INTO times VALUES ('19:50');
INSERT INTO times VALUES ('19:55');
INSERT INTO times VALUES ('20:00');
INSERT INTO times VALUES ('20:05');
INSERT INTO times VALUES ('20:10');
INSERT INTO times VALUES ('20:15');
INSERT INTO times VALUES ('20:20');
INSERT INTO times VALUES ('20:25');
INSERT INTO times VALUES ('20:30');
INSERT INTO times VALUES ('20:35');
INSERT INTO times VALUES ('20:40');
INSERT INTO times VALUES ('20:45');
INSERT INTO times VALUES ('20:50');
INSERT INTO times VALUES ('20:55');
INSERT INTO times VALUES ('21:00');
INSERT INTO times VALUES ('21:05');
INSERT INTO times VALUES ('21:10');
INSERT INTO times VALUES ('21:15');
INSERT INTO times VALUES ('21:20');
INSERT INTO times VALUES ('21:25');
INSERT INTO times VALUES ('21:30');
INSERT INTO times VALUES ('21:35');
INSERT INTO times VALUES ('21:40');
INSERT INTO times VALUES ('21:45');
INSERT INTO times VALUES ('21:50');
INSERT INTO times VALUES ('21:55');
INSERT INTO times VALUES ('22:00');
INSERT INTO times VALUES ('22:05');
INSERT INTO times VALUES ('22:10');
INSERT INTO times VALUES ('22:15');
INSERT INTO times VALUES ('22:20');
INSERT INTO times VALUES ('22:25');
INSERT INTO times VALUES ('22:30');
INSERT INTO times VALUES ('22:35');
INSERT INTO times VALUES ('22:40');
INSERT INTO times VALUES ('22:45');
INSERT INTO times VALUES ('22:50');
INSERT INTO times VALUES ('22:55');
INSERT INTO times VALUES ('23:00');
INSERT INTO times VALUES ('23:05');
INSERT INTO times VALUES ('23:10');
INSERT INTO times VALUES ('23:15');
INSERT INTO times VALUES ('23:20');
INSERT INTO times VALUES ('23:25');
INSERT INTO times VALUES ('23:30');
INSERT INTO times VALUES ('23:35');
INSERT INTO times VALUES ('23:40');
INSERT INTO times VALUES ('23:45');
INSERT INTO times VALUES ('23:50');
INSERT INTO times VALUES ('23:55');
INSERT INTO times VALUES ('00:00');
INSERT INTO times VALUES ('00:05');
INSERT INTO times VALUES ('00:10');
INSERT INTO times VALUES ('00:15');
INSERT INTO times VALUES ('00:20');
INSERT INTO times VALUES ('00:25');
INSERT INTO times VALUES ('00:30');
INSERT INTO times VALUES ('00:35');
INSERT INTO times VALUES ('00:40');
INSERT INTO times VALUES ('00:45');
INSERT INTO times VALUES ('00:50');
INSERT INTO times VALUES ('00:55');
INSERT INTO times VALUES ('01:00');
INSERT INTO times VALUES ('01:05');
INSERT INTO times VALUES ('01:10');
INSERT INTO times VALUES ('01:15');
INSERT INTO times VALUES ('01:20');
INSERT INTO times VALUES ('01:25');
INSERT INTO times VALUES ('01:30');
INSERT INTO times VALUES ('01:35');
INSERT INTO times VALUES ('01:40');
INSERT INTO times VALUES ('01:45');
INSERT INTO times VALUES ('01:50');
INSERT INTO times VALUES ('01:55');
INSERT INTO times VALUES ('02:00');
INSERT INTO times VALUES ('02:05');
INSERT INTO times VALUES ('02:10');
INSERT INTO times VALUES ('02:15');
INSERT INTO times VALUES ('02:20');
INSERT INTO times VALUES ('02:25');
INSERT INTO times VALUES ('02:30');
INSERT INTO times VALUES ('02:35');
INSERT INTO times VALUES ('02:40');
INSERT INTO times VALUES ('02:45');
INSERT INTO times VALUES ('02:50');
INSERT INTO times VALUES ('02:55');
INSERT INTO times VALUES ('03:00');
INSERT INTO times VALUES ('03:05');
INSERT INTO times VALUES ('03:10');
INSERT INTO times VALUES ('03:15');
INSERT INTO times VALUES ('03:20');
INSERT INTO times VALUES ('03:25');
INSERT INTO times VALUES ('03:30');
INSERT INTO times VALUES ('03:35');
INSERT INTO times VALUES ('03:40');
INSERT INTO times VALUES ('03:45');
INSERT INTO times VALUES ('03:50');
INSERT INTO times VALUES ('03:55');
INSERT INTO times VALUES ('04:00');
INSERT INTO times VALUES ('04:05');
INSERT INTO times VALUES ('04:10');
INSERT INTO times VALUES ('04:15');
INSERT INTO times VALUES ('04:20');
INSERT INTO times VALUES ('04:25');
INSERT INTO times VALUES ('04:30');
INSERT INTO times VALUES ('04:35');
INSERT INTO times VALUES ('04:40');
INSERT INTO times VALUES ('04:45');
INSERT INTO times VALUES ('04:50');
INSERT INTO times VALUES ('04:55');
INSERT INTO times VALUES ('05:00');
INSERT INTO times VALUES ('05:05');
INSERT INTO times VALUES ('05:10');
INSERT INTO times VALUES ('05:15');
INSERT INTO times VALUES ('05:20');
INSERT INTO times VALUES ('05:25');
INSERT INTO times VALUES ('05:30');
INSERT INTO times VALUES ('05:35');
INSERT INTO times VALUES ('05:40');
INSERT INTO times VALUES ('05:45');
INSERT INTO times VALUES ('05:50');
INSERT INTO times VALUES ('05:55');

