# 04-22-99 [jason] original hacking & addslashes()
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: dbfuncs.pm 
# Purpose: Provides addslashes, dbconnect, dbclear_table, dbdel_table, dbquery functions for MySQL. Called by addadmin.pl, dumpsite.pl, linksite.pl, onweb/admin/pmailweb.pl, onweb/rostermail.pl, phpadmin/change_pass.pl, security/setpass.pl, wwwboard/bbs-require.pm and wwwboard/rank.pm

# 04-26-99 [jason] dbquery
# 05-26-99 [jason] added dbopen
# 05-26-99 [jason] added dbclear_table, dbdel_table

use DBD::mysql;

#Doesn't modify its argument
sub addslashes
{
  my $str = $_[0];

	$str =~ s/\\/\\\\/g;
  $str =~ s/"/\"/g;
  $str =~ s/'/\'/g;

  return $str;
}

sub dbclear_table
{
  return &dbquery($_[0], "delete from $_[0]");
}

sub dbdel_table
{
	return &dbquery($_[0], "drop table $_[0]");
}

sub dbquery
{
  my($dbh, $cmd) = @_;
  my($sth, @res);

  unless($sth = $dbh->prepare($cmd)){
    $? = $dbh->errstr;
    return undef;
  }

  unless($sth->execute){
    $? = $sth->errstr;
    return undef;
  }

  @res = $sth->fetchrow_array;
  return wantarray ? @res : "@res";
}

sub dbconnect
{
  my($host, $user, $pass, $db) = @_;
  my($dbh);
  $host = "localhost" unless($host);
  $db = "classweb" unless($db);
  if($dbh = DBI->connect("DBI:mysql:$db", $user, $pass)) {
    $? = "";
  } else {
    $? = $DBI::errstr;
  }
  return $dbh;
}
1
