#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# dumpsite.pl 
# Purpose: removes mysql link to site from REGurl table. It doesn't remove the class site because there might be uploaded materials there.
# 8-20-02 Nick and Jerome - Substituting out language-dependent text strings
#   with variables to allow mulitilingual support.
# 7-28-00 mike - removed UCLA specific stuff and added GLOBAL vars
# 9-18-98 mike franks
# usage: dumpsite.pl term srs


## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
$BASE = "/home/classweb"; # main classweb programs directory

require "$BASE/customize.pl";  # important vars set here
require "$BASE/language.pl";  ###Multilingual support
require "$BASE/dbvars.pl";     # database vars set here
require "$BASE/dbopen.pl";

require "$BASE/dbfuncs.pm";
# require "$BASE/urlupdate.pm";  # UCLA specific
chdir "$BASE" || die "Can't cd to $BASE: $!\n";

# initialized LWP module for Perl to act as a web browser and update UCLA
# Registrar database with removal of this class URL. 
# CUSTOMIZE: - same as linksite.pl if you have a central system to update
# use LWP::Simple;     # to be used to get profinfo from folha
# use LWP::UserAgent;  # to be used by get_details subroutine
# $ua = new LWP::UserAgent;
# $ua->agent("Mozilla/4.05 [en] (Win95; I)"); # who we're pretending to be

$|++;     # unbuffers output

####################################################
#  handle command line parameters
$term = $ARGV[0];
$srs = $ARGV[1];

print "<html><head><title>$_DUMPSITE_TITLE</title></head>\n";
print "<BODY BGCOLOR=#FFFFFF><font face='arial,helvetica'>\n";
print "<center><h1>$_DUMPSITE_TITLE</h1></center>\n";
# UCLA-specific, being left in case others at UCLA start using ClassWeb
#print "Removing Registrar, my.ucla.edu &amp; SSC links pointing to $term $srs\n";
print "$_REMOVING_URL $term $srs\n";
print "<ul>\n";

####################################################
#  Update UCLA's Registrar - CUSTOMIZE for your own situation
#   if (&urlupdate($term,$srs,"",$IEIposter,$IEIemail,$errmsg)) {
#     print "<LI>my.ucla.edu &amp; Registrar UPDATE OK: $errmsg\n";
#     $cmdlog = "update sitelog set status='DUMPED: IEI Update OK', updateruid='601270210' where term='$term' && srs='$srs'";
#   } else {
#     print "<LI>my.ucla.edu &amp; Registrar UPDATE FAILED: $errmsg\n";
#     $cmdlog = "update sitelog set status='DUMPED: IEI Update Failed: $errmsg', updateruid='601270210' where term='$term' && srs='$srs'";
#   }

######################################
# Update sitelog table to keep record
#   $sthlog = $dbh->prepare($cmdlog) || die "Can't prepare $cmdlog: $dbh->errstr\n";
#   $rv = $sthlog->execute || die "Can't execute query: $cmdlog: $sthlog->errstr\n";
#   $rv = $sthlog->rows;
#   print "<LI>Error - SSC MySQL sitelog: $rv rows updated.\n" unless($rv);

#######################################
# Log to ascii file exceptions.dat
  open(EXCEPT,">>$BASE/exceptions.dat") or die "Can't open exceptions.dat";
  print EXCEPT "$term,$srs\n";
  close(EXCEPT);

#######################################
# Update REGurl for our immediate use
    #$cmdurl = "delete from REGurl where term='$term' && srs='$srs'";
    # Glen: I'm assuming the record for this class isn't gone (yet) and we just want the url to go away...
    $cmdurl = "update REGclasses set url='' where term='$term' && srs='$srs'";

    $sturlh = $dbh->prepare($cmdurl) or die "Can't prepare $cmdurl: $dbh->errstr\n";
    $rvurl = $sturlh->execute or die "Can't execute query: $sturlh->errstr\n";
    $rv = $sturlh->rows;
    print "<LI>MySQL REGclasses (url): $rv $_ROWSREMOVED.\n";
    print "<LI>$_ERROR - SSC MySQL REGclasses (url): $rv $_ROWSUPDATED\n" unless($rv);
  print "</ul>\n";
  print "$_IFPROBLEMS_CONTACT $CONTACT_ADMIN.\n";
  print "</font></body></html>\n";
