#########################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: error_message.pm
# Usage: called on by other subs in event of an error
# Steps: +error_message.pm
#          -error_message()
#
# Update 09-04-02 Jerome - added require for contenttype.inc
# Update 08-20-02 Nick and Jerome - Substituting out language-dependent text
#   strings to allow multilingual support.
# Update 05-30-00 kenny: documented
#
# Status: production
# Purpose: displays an error page/message

sub error_message {
  local ($errormsg) = @_;
  require "$BASE/contenttype.inc"; # enable charset
  # print "Content-type: text/html\n\n";
  print <<END_OF_HTML_CODE;

<HTML>
<HEAD>
<TITLE>$_ERROR!</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<H1><TT><B>$_ERROR! </B></TT></H1><br>
$errormsg
</BODY>
</HTML>

END_OF_HTML_CODE

  exit;
}
1
