########################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: fedit.pm
# Usage: called from stub
# Steps: +fedit.pm
#          +fedit()
#            -getfiles()
#            -mainscreen()
#            -editscreen()
#            +savefile()
#              -Redirect_User()
#            +deletefile()
#              -readonlywarn()
#              +deleteconfirm()  
#                +killfile()
#                  -followupD()
#            +copyfile()
#              -followupC()
#
# Update: 03-08-00 mike removed ALPHA TEST from front screen, and added red 
#   explanation of changes in this version. Made Kenny's version live.
# Update: 03-07-00 kenny fong
#   added followup screen for copy utility
#   delete now checks permissions of the file to be deleted.  does not delete read-only files
# Update: 03-06-00 kenny fong
#   added confirmation and followup screens for delete utility
# Update: 02-24-00 kenny fong
#   all pulldowns show all files, excluding *.php, *.inc, *.pl, *.cgi, popup.dir, popup.pag
#   edit pulldown also excludes *.jpg, *.gif, *.pdf files.  delete now really deletes file.
#
# Status: writing/testing
# Purpose: front and back end of file edit/copy/delete utility


sub fedit {
  $skip='admin|wwwboard';
  open (STDERR,">/dev/null");
  
  &getfiles if (!param('section'));
  &mainscreen if (!param('section'));
  &editscreen if (param('section') eq 'edit');
  &savefile if (param('section') eq 'save'); 
  &Redirect_User("$baseurl/$file") if (param('section') eq 'save');
  &deletefile if (param('section') eq 'delete');
  &copyfile if (param('section') eq 'copy');
  &killfile if (param('section') eq 'kill');
  
  ## get file listings from directory and subdirectories
  sub getfiles {
    @ext=("*");
    foreach $ext (@ext) { 
      @templist=`ls -1 ../*.$ext`;
      foreach $templist (@templist) {
        if (!($templist =~ /php|inc|popup.dir|popup.pag|pl|cgi/)) {
          @files=(@files,$templist);
        }
      }
      @templist='';
    }
    foreach $ext (@ext) { 
      @templist=`ls -1 ../wwwboard/messages/*.$ext`;
      foreach $templist (@templist) {
        if (!($templist =~ /php|inc|popup.dir|popup.pag|pl|cgi/)) {
          @files=(@files,$templist);
        }
      }
      @templist='';
    }
    @dirs=`ls -1 ..`;
    foreach $other_dir (@dirs) {
      if ($other_dir=~/$skip/) { next;}
      chomp($other_dir);
      $other_dir="../$other_dir";
      @doing=(@doing,$other_dir);
      if (-d $other_dir) {
        foreach $ext (@ext) { 
          @templist=`ls -1 $other_dir/*.$ext`;
            foreach $templist (@templist) {
              if (!($templist =~ /php|inc|popup.dir|popup.pag|pl|cgi/)) {
                @files=(@files,$templist);
              }
            }
            @templist='';
            @doing=(@doing,"yes");
        }
      }
    }
    foreach $file (@files) {
      $file=~ s/\.\.\///;
      if ($file =~ /.*dat/) {
        $files{$file} = "This is an image description file";
      } else {
        $files{$file} = "This is an html file";
      }
    }
  } #getfiles
  
  sub mainscreen {
    unless (param('php') == 1) {
      print "Content-type:  text/html\n\n";
      print "<html><title>ClassWeb File Editor</title><body bgcolor=\"#FFFFFF\">\n";
    }
    print "<form method=post action=\"$cgi_url\">\n";
    print "<h1>ClassWeb File Editor</h1>\n";
    print "If you have any problems or questions, please send us <a href=\"$ENTRY/feedback_classweb.php\">ClassWeb Feedback</a>.<br><br>\n";
    print "<font size=5>Pick a file to edit</font><br><font size=3><i>\(Note, when editing a file, the original will be backed up to <b>filename.sav</b>. You can restore the file by using the copy command to restore whichever .sav file to the original filename.\)</i></font><br><br>\n";
    print "<select name=\"file\">\n";
    @items=sort(keys(%files));
    foreach $file (@items) {
      if (!($file =~ /.jpg|.gif|.pdf/i)) {
        print "<option>$file\n";
      }
    }
    print "</select><br>\n";
    print "<input type=\"hidden\" name=\"section\" value=\"edit\">\n";
    print "<input type=\"hidden\" name=\"php\" value=\"show_banner\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"fedit\">\n";
    print "<input type=\"submit\" value=\"   Edit File   \">\n";
    print "</form>";
    print "<form method=post action=\"$cgi_url\">\n";
    print "<font size=5>Pick a file to copy or restore</font><br>\n";
    print "<br>";
    print "<select name=\"file\">\n";
    @items=sort(keys(%files));
    foreach $file (@items) {
      print "<option>$file\n";
    }
    print "</select>  <b>To --> </b> <input type=text name=copyto><br>\n";
    print "<input type=\"hidden\" name=\"section\" value=\"copy\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"fedit\">\n";
    print "<input type=\"submit\" value=\"   Copy File   \">\n";
    print "</form>";
    print "<form method=post action=\"$cgi_url\">\n";
    print "<font size=5>Pick a file to delete</font><br>\n";
    print "<br>";
    print "<select name=\"file\">\n";
    @items=sort(keys(%files));
    foreach $file (@items) {
      print "<option>$file\n";
    }
    print "</select><br>\n";
    print "<input type=\"hidden\" name=\"section\" value=\"delete\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"fedit\">\n";
    print "<input type=\"submit\" value=\"   Delete File   \">\n";
    print "</form>";
    unless (param('php') == 1) {
      print "</body></html>";
    }
  } #mainscreen
  
  sub editscreen {
    $file=param('file');
    $file_size= -s "$basedir/$file";
    unless (param('php') == 1) {
      print "Content-type: text/html\n\n";
      print "<html><title>Editing file: $file</title>\n";
    }
    if ($file_size > 29999) { 
      print "<BODY BGCOLOR=#FFFFFF><h2>Cannot edit file $file, the file is over 30000 bytes in size<br>file size = $file_size bytes</h2></body>\n"; 
      exit;
    }
    print "<BODY BGCOLOR=#FFFFFF>";
    print "<h1>Editing file: $file</h1>\n";
    print "<form method=post action=\"$cgi_url\">\n";
    open (IN,"$basedir/$file");
    @curfile=<IN>;  
    close(IN);
    print "<textarea cols=75 rows=25 name=\"filedata\">\n";
    print "@curfile";
    print "</textarea><br>\n";
    print "<input type=\"hidden\" name=\"section\" value=\"save\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"fedit\">\n";
    print "<input type=\"hidden\" name=\"file\" value=\"$file\">\n";
    print "<input type=\"submit\" value=\"  Save Changes  \">\n";
    print "<input type=\"Reset\" value=\"  Reset File  \">\n";
    print "</form>\n";
  } #editscreen
  
  ## creates backup copy during edit
  sub savefile {
    $file=param('file');
    @fileinfo=param('filedata');
    system "cp $basedir/$file $basedir/$file.sav";
    open(OUT,">$basedir/$file");
    print OUT @fileinfo;
    close(OUT); 
    chmod (0770,"$basedir/$file.sav");    # full access to user/group
  } #savefile
  
  ## creates copy of target file
  sub copyfile {
    $file=param('file');
    $copyto=param('copyto');
    ($filepath) = ($file =~ m#(.*)/#);
    $filepath=$filepath."/";
#   if ($file =~ m#(.*)/#) {
#     $filepath = $1 ."/";
#   } else {
#     $filepath="";
#   }
    $copyto = $filepath . $copyto;
    system "cp $basedir/$file $basedir/$copyto";
    chmod (0770,"$basedir/$copyto");    # full access to user/group
    followupC(); 
  } #copyfile
  
  ## runs confirmation first, then delete, followed by followup
  sub deletefile {
    $file=param('file');
    if(!(-w "$basedir/$file")){     #checks permissions on file
      readonlywarn(); 
    } else{
      deleteconfirm();
    }
  }
  
  ## ask for confirmation of delete from user
  sub deleteconfirm {
    $file=param('file');
    print "Content-type:  text/html\n\n";
    print "<html><title>ClassWeb File Delete Confirmation</title>\n";
    print "<body bgcolor=white><H1 align=c$>";
    print "<p>This is a warning that you will delete the file:  $file <br>Are you sure?</p><br>";
    print "<a href=\"$cgi_url?stubsection=fedit&section=kill&file=$file\">DELETE FILE</a>\n\n\n";
    print "</body></html>";
    print "<html><center><br><br>Press the <font color=red>BACK</font> button of your browser to return without deleting.</center></html>";
  }
  
  ## actually deletes file
  sub killfile {
    $file=param('file');
    system "rm $basedir/$file";
    unlink("$basedir/$file");
    followupD();
  }
  
  ## lets user know file has been successfully deleted
  sub followupD {
    print "Content-type:  text/html\n\n";
    print "<html><title>ClassWeb File Deletion Followup</title>\n";
    print "<body bgcolor=white><H1 align=c$>";
    print "<p>You have successfully deleted the file. </p><br><br>";
    print "back to <a href=\"$cgi_url?stubsection=fedit\">FILE EDIT/COPY/DELETION UTILITY</a><br><br>";
    print "back to <a href=\"$baseurl\">MAIN PAGE</a>\n\n\n";
    print "</body></html>";
  }
  
  ## lets user know file has been successfully copied
  sub followupC {
    $file=param('file');
    $copyto=param('copyto');
    print "Content-type:  text/html\n\n";
    print "<html><title>ClassWeb File Copy Followup</title>\n";
    print "<body bgcolor=white><H1 align=c$>";
    print "<p>You have successfully copied the file:  $file  to  $copyto </p><br><br>";
    print "back to <a href=\"$cgi_url?stubsection=fedit\">FILE EDIT/COPY/DELETION UTILITY</a><br><br>";
    print "back to <a href=\"$baseurl\">MAIN PAGE</a>\n\n\n";
    print "</body></html>";
  } 
  
  ## warns user file attempted to be delete was read-only, no action taken
  sub readonlywarn {
    $file=param('file');
    print "Content-type:  text/html\n\n";
    print "<html><title>ClassWeb File Delete Warning</title>\n";
    print "<body bgcolor=white><H1 align=c$>";
    print "<p>You do not have permission to delete the file:  $file </p><br>";
    print "This file has been designated READ-ONLY.  No action has been taken.<br><br><br>";
    print "back to <a href=\"$cgi_url?stubsection=fedit\">FILE EDIT/COPY/DELETION UTILITY</a><br><br>";
    print "back to <a href=\"$baseurl\">MAIN PAGE</a>\n\n\n";
    print "</body></html>";
  }
}  #end of fedit sub
1
