# Name: gradeedit.pm
# Usage: called from stub
#
# Purpose: front and back end of grade edit utility
# Update: 09-04-02 Jerome - added require for contenttype.inc
# Update: 8-22-02: Nick and Jerome - Substituting out language-dependent text
#   strings with variables to allow multilingual support.

sub gradeedit {
  open (STDERR,">/dev/null");
  
  &editscreen if (param('section') ne 'save');
  &savefile if (param('section') eq 'save'); 
  &preview if (param('section') eq 'save'); 
  #&Redirect_User("$baseurl") if (param('section') eq 'save');
    
  sub preview {
    $file="admin/grades.txt";
    $file_size= -s "$basedir/$file";
    unless (param('php') == 1) {
      require "$BASE/contenttype.inc"; # enable charset
      # print "Content-type: text/html\n\n";
      print "<html><head><title>$_PREVIEWGRADE_TITLE: $file</title></head><body BGCOLOR=#FFFFFF>\n";
    }      
    
    open (GRADES, "<$basedir/$file") || die "Unable to read admin/$file";
    $line=0;
    print "<BR><BR><BR><H2 align=center>$_PREVIEWGRADE_HEADER</H2><table border=1 align=center>\n";
    print "<BR>$_GRADEEDIT_DESCRIP\n";
    while(<GRADES>) {
      $GRADES = $_;
      if ($line eq 0){
        $GRADES =~ s/^/<tr><th bgcolor=yellow>/;
        $GRADES =~ s/$/<\/th><\/tr>\n/;
        $GRADES =~ s/,/<\/th><th bgcolor=yellow>/g;
      } else {
        $GRADES =~ s/^/<tr><td>/;
        $GRADES =~ s/$/<\/td><\/tr>\n/;
        $GRADES =~ s/,/<\/td><td>/g;
      }
      print "$GRADES\n";
      $line++;
    }
    $path=$ENV{SCRIPT_NAME};
    $path =~ s/\/stub.pl$//g;
    print "</table><pre>$env</pre><P align=center><a href=\"$path\">$_ADMINPAGE</a></body></html>\n";
    close GRADES;

    exit;
  }
  
  sub editscreen {
    $file="admin/grades.txt";
    $file_size= -s "$basedir/$file";
    unless (param('php') == 1) {
      require "$BASE/contenttype.inc"; # enable charset
      # print "Content-type: text/html\n\n";
      print "<html><title>$_GRADEEDIT_TITLE: $file</title>\n";
    }
    if ($file_size > 29999) { 
      print "<BODY BGCOLOR=#FFFFFF><h2>$_GRADEEDIT_BIGFILE_ERROR_A $file, $_GRADEEDIT_BIGFILE_ERROR_B $file_size $_GRADEEDIT_BIGFILE_ERROR_C</h2></body>\n"; 
      exit;
    }
    print "<BODY BGCOLOR=#FFFFFF>";
    print "<h1>$_GRADEEDIT_TITLE: $file</h1>\n";
    print "$_GRADEEDIT_DIRECTIONS<P>  
	   $_FOREXAMPLE:<br><tt>
	   $_GRADEEDIT_SAMPLE<br>
	   12553212,90,87,92,85,98,93,$_A<br>
	   25517731,65,75,76,78,82,80,$_C<br>
	   .<br>
	   .<br>
	   .</tt><P>
	   $_STUDENTS_SEE_OWN_GRADES<br>
	   <table border=1><tr><th bgcolor=yellow>$_UID</th><th bgcolor=yellow>$_WEEK1QUIZ</th><th bgcolor=yellow>$_SPECIALPROJECT</th><th bgcolor=yellow>$_MIDTERMTEST</th><th bgcolor=yellow>$_WEEK6QUIZ</th><th bgcolor=yellow>$_FINALPROJECT</th><th bgcolor=yellow>$_FINALEXAM</th><th bgcolor=yellow>$_CLASSGRADE</th></tr>
	   <tr><td>25517731</td><td>65</td><td>75</td><td>76</td><td>78</td><td>82</td><td>80</td><td>$_C</td></tr>
	   </table><P>";
    print "<form method=post action=\"$cgi_url\">\n";
    open (IN,"$basedir/$file");
    @curfile=<IN>;  
    close(IN);
    print "<textarea cols=75 rows=25 wrap=off name=\"filedata\">\n";
    print "@curfile";
    print "</textarea><br>\n";
    print "<input type=\"hidden\" name=\"section\" value=\"save\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"gradeedit\">\n";
    print "<input type=\"hidden\" name=\"file\" value=\"$file\">\n";
    print "<input type=\"submit\" value=\"  $_GRADEEDIT_SUBMIT  \">\n";
    print "<input type=\"Reset\" value=\"  $_RESETFILE  \">\n";
    print "</form></body></html>\n";
  } #editscreen
  
  ## creates backup copy during edit
  sub savefile {
    $file=param('file');
    @fileinfo=param('filedata');
    system "cp $basedir/$file $basedir/$file.sav";
    open(OUT,">$basedir/$file");
    print OUT @fileinfo;
    close(OUT); 
    chmod (0770,"$basedir/$file.sav");    # full access to user/group
  } #savefile
}  #end of gradeedit sub
1
