##############################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: linkdel.pm 
# Usage: called by main_linkdelete.php (frontend)  
# Steps: +linkdel.pm 
#          +menudelete()
#            -showlink() (displays links, frontend)
#            +putlink() (removes link, backend)
#              -Redirect_User()            
#
# Update: 09-04-02 Jerome - added require for contenttype.inc
# Update: 8-22-02 Nick and Jerome - Substituting out language-dependent text
# strings with variables to allow multilingual support.           
# Update: 08-02-00 mike - added seek 0,0 to get to start of file to fix 
#  "Couldn't find menu section in .htm"
# Update 11-13-98: changed cols max to 10
# Update 08-18-98: changing to provide table output only, when called by PHP
#   also fixed bug where relative links broke because calling from admin
# Update 08-07-98: changed to work with coursemenu.inc
# Update 04-04-98: commented out chgrp debug.txt beecause it's obsoleted by
#   chmod g+s, and it was showing up in error logs
# Update 12-18-97: completely rewritten to use same logic as placelink.pm
# Update 12-17-97: need to change to new, formatted cells
# Update 08-05-97: works but doesn't need associative array for tblitem, could change
#   algorithm to use delete[cellno] instead
# Update 07-31-97: Artin added routine to do deletes and got it working with bugs.
# Update 07-30-97: external error_message and Redirect_user subroutines
#   Mike shortened table grabbing and writing routines
# Update 07-29-97: working with stub.pl
# Update 03-19-97: Mike subbed $table for ../demo/demo in all file refs for table
#   and added link to class page on Thank You.
# Update: written by Artin Rebekale and Mike Franks
#
# Status: production
# Purpose: backend to main_linkdelete.php, 
#   deletes links from the home page menu

sub menudelete{
# $debug = "YES";
  $debug = "";   # turns off debugging

  if ($debug) {
    open(DEBUG,">$basedir/debuglinkdel.txt") || 
      &error_message("$_COULDNOTOPEN $basedir/debuglinkdel.txt");
  }

  # $baseurl is provided by stub.pl. It's where we'll send the user at the end
  local $tablefile = "coursemenu.inc"; 
  if ($basedir eq '.') {
    $basedir = "..";
  }
  $table = $basedir . "/" . $tablefile;
  $| = 1;   # immediate write 

  if (param('sub') eq '') {
    &show_link;     # added by art
  }
  if (param('sub') eq 'placecell') {
    &put_link;
    &Redirect_User("$baseurl");   
  }
}  
### end of menu_delete subroutine ###


############################################
# added by art
# this sub simply gets the variable link-name and trys
# to place it on the web page
###########################################
sub show_link {
  # open home page file and read and count table cells
  undef $/;
  open (INDEX,"<$table") || &error_message("$_COULDNOTOPEN $table");
  $index=<INDEX>;    # suck whole file into $index
  $/ = "\n";
  if ($index =~ /<!--menustart(-COLS=(\d+))?-->(.*)<!--menuend-->/s) {
    $menu = $3;
    $cols = $2;    # maximum number of columns per row
    unless (($cols > 0) && ($cols <= 10)) { $cols = 4; }   # set to 4 if invalid
    $rowcnt = 1;  # should cycle between 1 and 4 (or $cols maximum)
    $cellcnt = 1;
    $newmenu = "";  # will eventually replace existing menu section

    # break menu into cells, ignoring row markers. They'll be put back later
    if ($totalcells = (@cells) = ($menu =~ m#(<TD.*?>.*?</TD>)#sig)) {
      if (param('php') == 1) {
        print "<center><table border='0' cellpadding=3 width='75%'>\n";
      } else { 
        ### Print out Header for Link Deletion Utility Page ###
        # print "Content-type: text/html\n\n";
        require "$BASE/contenttype.inc"; # enable charset
        print << "END_OF_HTML";
<html>
<head>
<title>$_LINKDEL_TITLE</title>
</head>
<body bgcolor="#FFFFFF">
<h1><tt><b>$_LINKDEL_TITLE</b></tt>
</h1>$_LINKDEL_DIRECTIONS:<BR><BR>
<center><table border=3 cellpadding=3 width=75%>
END_OF_HTML
      }
      print "\n",'<form method=POST action="',"$cgi_url",'">',"\n";

      ### Loop through cells in Menu ###
      foreach $mcell (@cells) {
        $cell = $mcell;   # to leave original cell exactly the same
        $cell =~ s/\n//sg;     # drop newlines
        $cell =~ s/>(\s*?)</></sg;     # drop blankspace between markup
        if ($cell =~ m#(<TD.*?>)(.*?)<a href="(.*?)">(.*?)</A></TD>#si) {
          $cellstart = $1;
          $preurl  = $2;
          $url     = $3;
          $labelm   = $4;  # label with HTML markup
          $url = "$baseurl/$url" unless ($url =~ /^(http:|\/)/); 
          $label = $labelm;
          $label =~ s#<.*?>##sg;  # remove HTML markup
          $label =~ s/^\s*//;     # remove whitespace from front
          $label =~ s/\s*$//;     # remove whitespace from back

          # Adam's nifty recursive algorithm to substitute original bugprone code
          while ($labelm =~ /^(<.*?>)(.*)(<.*?>)$/) {
            $premarkup = $premarkup . $1;
            $postmarkup = $3 . $postmarkup;
            $labelm = $2;
          } #endwhile
         
          ### display array as web page with radio buttons ###
          ### cells start with 1                           ###
          print "<tr>\n" if ($rowcnt == 1);
          print "<td align='center' bgcolor='#CCCCCC'><font face='Arial'>\n";
          print "<A HREF=\"$url\">$label</a>\n";
          print "<BR><B>$cellcnt</B>\n";
          print "<INPUT TYPE='checkbox' NAME='deletecells' VALUE=$cellcnt>\n";
          print "\n";
          print "</font></td>\n";
          $cellcnt++;
          if ($rowcnt == $cols) {
            print "</tr>\n";
            $rowcnt = 1;
          } else {
            $rowcnt++; 
          }
        }  #  end of  if ($cell =~ m#(<TD.*?>)(.*?)
      }
      ### end of reading cells ###
      close(INDEX);
    }  # end of if it found cells <TD>text</TD> sets
  }    # end of if it found menustart - menuend set

  print "\n</tr></table></center>\n";
  print hidden(-name=>'stubsection',-value=>'menudelete'),
   hidden(-name=>'sub',-value=>'placecell'),"\n",br,br,
   submit(-value=>"$_DELETELINK_S"), end_form;
  unless (param('php') == 1) {
    print "\n</body></html>\n";
  }
}
### end of show_link subroutine ###

##########################################
# get list of items to delete from @tblitem 

sub put_link {
  my @deletelinks=param('deletecells');
  foreach $deletee (@deletelinks) {
    print DEBUG "  DELETE ITEM #$deletee##\n" if $debug;
    $delete{$deletee}++;
  }

  if (!$table) {
    $table="$basedir/coursemenu.inc";
  }
  system "cp $table $table.old";   # $table comes from calling programs
  chmod (0660, "$table.old");      # readable, writeable, not executable to user/group
  if ($?) {
    &error_message("cp $table $table.old $_FAILED");
  }
  undef $/;
  open (INDEX,"+>>$table") || &error_message("$_COULDNOTOPEN $table");
  flock INDEX, 2;    # lock file open
  seek INDEX, 0, 0;  # on Linux, need this to move pointer back to start of file
  $index=<INDEX>;    # suck whole file into $index
  $/ = "\n";
  # print DEBUG $index if $debug;
  if ($index =~ /<!--menustart(-COLS=(\d+))?-->(.*)<!--menuend-->/s) {
    print DEBUG "FOUND MENU.\n" if $debug;
    $menu = $3;
    $cols = $2;    # maximum number of columns per row
    unless (($cols > 0) && ($cols <= 10)) { $cols = 4; }   # set to 4 if invalid
    $cellcnt = 1;   # to help grab formatting from first cell only
    $rowcnt = 1;  # should cycle between 1 and 4 (or $cols maximum)
    $newmenu = "";  # will eventually replace existing menu section

    # break menu into cells, ignoring row markers. They'll be put back later
    if ($totalcells = (@cells) = ($menu =~ m#(<TD.*?>.*?</TD>)#sig)) {
      print DEBUG "Total Cells = $totalcells\n" if $debug;
      foreach $mcell (@cells) {
        $cell = $mcell;   # to leave original cell exactly the same
        $cell =~ s/\n//sg;     # drop newlines
        $cell =~ s/>(\s*?)</></sg;     # drop blankspace between markup

        ### grab good cells, those with <a href= in them. Ignore rest ###
        if ($cell =~ m#(<TD.*?>)(.*?)<a href="(.*?)">(.*?)</A></TD>#si) {
          if ($delete{$cellcnt}) {  # check for deleted cell
            print DEBUG "  Skipping Cell #$cellcnt because it's spozed to be deleted.\n";
            $cellcnt++;
            next;    # skip this cell
          }  # end of check for deleted cell
          print DEBUG "PARSING CELL #$cellcnt\n" if $debug;
          $cellstart = $1;
          $preurl  = $2;
          $url     = $3;
          $labelm   = $4;  # label with HTML markup
          $label = $labelm;
          $label =~ s#<.*?>##sg;  # remove HTML markup
          $label =~ s/^\s*//;     # remove whitespace from front
          $label =~ s/\s*$//;     # remove whitespace from back

          while ($labelm =~ /^(<.*?>)(.*)(<.*?>)$/) {
            $premarkup = $premarkup . $1;
            $postmarkup = $3 . $postmarkup;
            $labelm = $2;
          } #endwhile

          if ($cellcnt == 1) {   # capture formatting from first cell
            $kcellstart = $cellstart; $kpremarkup = $premarkup;
            $kpostmarkup = $postmarkup;
          }
          print DEBUG "  \$cellstart = $cellstart\n" if $debug;
          print DEBUG "  \$preurl = $preurl#####\n" if $debug;
          print DEBUG "  \$url = $url\n" if $debug;
          print DEBUG "  \$premarkup = $premarkup\n" if $debug;
          print DEBUG "  \$label = $label#####\n" if $debug;
          print DEBUG "  \$postmarkup = $postmarkup\n" if $debug;

          if ($rowcnt < $cols) {
            $newmenu .= "\n    <TR>\n" if $rowcnt == 1; # need <TR> to start row
            $newmenu .= "\n        $mcell\n";
            $rowcnt++;     # increment counter within row
          } else {                 # $rowcnt = $cols, so end of row
            $newmenu .= "\n        $mcell\n";
            $newmenu .= "\n    </TR>\n";            # need </TR> to end row
            $rowcnt = 1;
          }
          $cellcnt++;
        }  
        print DEBUG "\n\n" if $debug;
      }
      ### end of writing old cells ###

      ### write blank cells to fill up row if need be ###
      until (($rowcnt == 1) || ($rowcnt > $cols)) { 
        $newmenu .= "\n        $kcellstart\n";
        $newmenu .= "          &nbsp;</A></TD>\n\n";
        $rowcnt++;     # increment counter within row
      }
      $newmenu .= "\n    </TR>\n";         # need </TR> to end row

      ### end of writing new cell ###
    } else {
      &error_message("$_COULDNOTFINDCELLSINMENU");
    }   # end of if ($totalcells = (@cells) = ...
    
    ### replace old menu with $newmenu ###
    $index =~ s/(<!--menustart(-COLS=(\d+))?-->)(.*)(<!--menuend-->)/$1$newmenu$5/si;

    seek INDEX, 0, 0;
    truncate INDEX, 0;  # zero out file
    print INDEX $index;      # rewrite file
    close(INDEX);
    #  could use check for file size here
  } else {
    &error_message("$_COULDNOTFINDMENUSECTION $table.");
  }
  close(DEBUG) if $debug;
} #end of put_link
1
