#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# linksite.pl 
# Purpose: changes mysql link in "REGurl" table to point to given URL

# usage: linksite.pl term srs newurl [crossed]

# 8-22-02 Nick and Jerome - Substituting out language-dependent text strings
#   with variables to allow multilingual support.
# 7-27-00 mike - changing to GLOBAL vars and Kenny debugged it
# 3-23-99 mike - adding switch to update REGxref xurl if crossed
# 9-22-98 mike franks

#  handle command line parameters
$term = $ARGV[0];
$srs = $ARGV[1];
$newurl = $ARGV[2];
$mode = $ARGV[3];

## $BASE comes from Apache environment
$BASE = "/home/classweb"; # main classweb programs directory
require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here
require "$BASE/dbopen.pl";
require "$BASE/dbfuncs.pm";
require "$BASE/language.pl";
use DBD::mysql;


$newurl =~ s#http://##i;  # remove http:// at beginning, if it's there 

chdir "$BASE" ||
  die "Can't cd to $BASE: $!\n";

####################################
# removed; updates campus records
#
# require "urlupdate.pm";
# $IEIposter = "Mike Franks";
# $IEIemail = 'franks@ssc.ucla.edu';

$stub = "$BASE/stub.pl"; # location of model admin stub program
$classbase = "$DOCUMENT_ROOT";          # was /classes
$payload = "$BASE/payload"; # material to be copied

# This section initializes the LWP Perl Module (download from CPAN) which is
# later used to update the UCLA Registrar's Office with this class website URL
#  CUSTOMIZE - you'll want to do the same at your school
# use LWP::Simple;     # to be used to get profinfo from folha
# use LWP::UserAgent;  # to be used by get_details subroutine
# $ua = new LWP::UserAgent;
# $ua->agent("Mozilla/4.05 [en] (Win95; I)"); # who we're pretending to be

$|++;     # unbuffers output

####################################################
 
 print "<html><head><title>$_LINKSITE_TITLE</title></head>\n";
 print "<BODY BGCOLOR=#FFFFFF><font face='arial,helvetica'>\n";
 print "<center><h1>$_LINKSITE_TITLE</h1></center>\n";
 print "$mode<br>\n";
 print "$_RELINKINGCLASSWEBLINKS $term $srs $_TOUSE $newurl\n";
 print "<ul>\n";
 
####################################################
#  Calls subroutine to update UCLA Registrar's Office with this class URL
#  CUSTOMIZE - substitute your system in here
#    if (&urlupdate($term,$srs,$newurl,$IEIposter,$IEIemail,$errmsg)) {
#      print "<LI>my.ucla.edu &amp; Registrar UPDATE OK: $errmsg\n";
#       $cmdlog = "update sitelog set status='RELINKED: IEI Update OK', updateruid='601270210' where term='$term' && srs='$srs'";
#     } else {
#       print "<LI>my.ucla.edu &amp; Registrar UPDATE FAILED: $errmsg\n";
#       $cmdlog = "update sitelog set status='RELINKED: IEI Update Failed: $errmsg', updateruid='601270210' where term='$term' && srs='$srs'";
#     }
#

######################################
# Update sitelog table to keep record

    $cmdlog = "update sitelog set status='RELINKED: Update OK', updateruid='$ADMIN_NAME' where term='$term' && srs='$srs'";
    $sthlog = $dbh->prepare($cmdlog) or die "Can't prepare $cmdlog: $dbh->errstr\n";
    $sthlog->execute or die "Can't execute query: $cmdlog: $sthlog->errstr\n";
    $rv = $sthlog->rows;
    print "<LI>$_ERROR - MySQL $_SITELOG: $rv $_ROWSUPDATED\n" unless($rv);

    if ($mode eq "crossed") {  # update REGxref
      $cmdurl = "update REGxref set xurl='$newurl' where term='$term' && xsrs='$srs'";
    } else {                   # update REGurl
      # $cmdurl = "replace into REGurl (term,srs,url) values ('$term','$srs','$newurl')";
      $cmdurl = "update REGclasses set url='$newurl' where term='$term' and srs='$srs'";
    }

    $sturlh = $dbh->prepare($cmdurl) or die "Can't prepare $cmdurl: $dbh->errstr\n";
    $sturlh->execute or die "Can't execute query: $sturlh->errstr\n";
    $rv = $sturlh->rows;
    print "<LI>MySQL $cmdurl: $rv $_ROWSREPLACED.\n";
    print "<LI>Error: $rv $_ROWSUPDATED\n" unless($rv);
  print "</ul>\n";
  print "$_IFPROBLEMS_CONTACT $CONTACT_ADMIN\n";
  print "</font></body></html>\n";
