#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
####################################################################
# Name: makequiz.pm 
# Usage: called by other_quiz.php
# Steps: +makequiz.pm
#          -make_quiz()
#
# Update: 09-04-02 Jerome - added require for contenttype.inc
# Update: 8-22-02: Nick and Jerome - Substituting out language-dependent text
#   strings with variables to allow multilingual support.
# Update: 07-22-00 Mike replaced hard-coded vars with GLOBAL
# Update: 08-21-98 - mike changing to work with PHP frontend
#         01-11-98 - mike changed chmods to be more restrictive
#
# Note: funny thing CGI.pm causes @array=(a..g) to break
#
# Status: production
# Purpose: multiple choice quiz generator, backend of other_quiz.php

sub make_quiz {
  if (!-e "$basedir/quiz.cgi"){
    system "cp $BASE/quiz.cgi $basedir";
    chmod (0770,"$basedir/quiz.cgi");
  }
  
  # changed by Adam Kaplan Jan 18 2000
  # to allow it to run on the secure server
  if ($base eq ''){
    $mkquizcgi_url="stub.pl?stubsection=make_quiz";
    $quizcgi_url="quiz.cgi";
  } else {
    $mkquizcgi_url="/$base/admin/stub.pl?stubsection=make_quiz";
    $quizcgi_url="http://$SERVER_NAME/$base/quiz.cgi";
  }
  
  # quiz utility frontend, main page
  if (param('section') eq '') {
    unless (param('php') == 1) {
      # print "Content-type: text/html\n\n";
      require "$BASE/contenttype.inc"; # enable charset
      print "<html><title>$_MAKEQUIZ_TITLE</title>\n<body bgcolor=\"\#FFFFFF\">\n";
      print "<h2>$_MAKEQUIZ_TITLE</h2>\n";
    }
    print "<form method=post action=\"$mkquizcgi_url\">\n";
    print "<font size=4>$_CREATEQUIZ</font><br>\n";
    print "$_ENTERFILENAMEFORQUIZ: <input type=\"text\" name=\"newquiz\"><input type=\"submit\" value=\"   $_STARTQUIZ  \">\n<br>$_OVERWRITEQUIZ_CAUTION<br><br>\n";
    print "<input type=\"hidden\" name=\"section\" value=\"newquiz\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"make_quiz\">\n";
    print "</form>\n";
    unless (param('php') == 1) {
      print "<hr>";
    }
    @oldquiz=`ls -1 ../*.qz`;
    if(@oldquiz) { 
      print "<form method=post action=\"$mkquizcgi_url\">\n";
      print "<font size=4>$_ADDQUESTIONSTOQUIZ</font><br>\n";
      print "$_CHOOSEQUIZTOADDQUESTIONS: <select name=\"quiz\">\n";
      foreach $oldquiz(@oldquiz) {
        ($oldfilename)=($oldquiz =~ /..\/(.*).qz/);
        print "<option>$oldfilename\n";
      }
      print "</select>"; 
      print "<input type=\"hidden\" name=\"section\" value=\"addquiz\">\n";
      print "<input type=\"hidden\" name=\"stubsection\" value=\"make_quiz\">\n";
      print "<input type=\"submit\" value=\"   $_ADDQUESTIONS   \">\n"; 
      print "</form>\n";
    
      print "<hr>";
      print "<form method=post action=\"$mkquizcgi_url\">\n";
      print "<font size=4>$_EDITQUIZ</font><br>\n";
      print "$_CHOOSEQUIZTOADDQUESTIONS: <select name=\"quiz\">\n";
      foreach $oldquiz(@oldquiz) {
        ($oldfilename)=($oldquiz =~ /..\/(.*).qz/);
        print "<option>$oldfilename\n";
      }
      print "</select>"; 
      print "<input type=\"hidden\" name=\"section\" value=\"oldquiz\">\n";
      print "<input type=\"hidden\" name=\"stubsection\" value=\"make_quiz\">\n";
      print "<input type=\"submit\" value=\"   $_EDITOLDQUIZ  \">\n"; 
      print "</form>\n";
      unless (param('php') == 1) {
        print "</body></html>\n";
      }
    }
  } #endif - quiz util main page

  sub done_things {
    $title=param('title');
    $testingstuff=param('title');
    $quiz=param('quiz');
    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print "<html><body bgcolor=\"\#FFFFFF\">\n";
    print "<h1>$_QUIZ <i>$title</i> $_ISDONE.</h1>";
    print "<br>$_QUIZURL,<a href=\"$quizcgi_url?quiz=$quiz\">$quizcgi_url?quiz=$quiz</a> <br>$_ADDQUIZLINK\n";
    print "<form method=post action=\"$mkquizcgi_url\">\n";
    print "<input type=\"hidden\" value=\"linksection\" name=\"section\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"make_quiz\">\n";
    print "<input type=\"hidden\" value=\"$quiz\" name=\"quiz\">\n";
    print "<input type=\"hidden\" value=\"$title\" name=\"title\">\n";
    print "<input type=\"submit\" value=\"  $_ADDLINK  \">\n";
    print "</form></body></html>";
    exit;
  } #done_things

  # util to add questions to already existing quiz file(s)
  if (param('section') eq 'addquiz') {
    $quiz=param('quiz');
    if (-s "$basedir/$quiz.qz") {
      open (TITLE,"<$basedir/$quiz.qz");
      @fortitle=<TITLE>;
      close(TITLE);
      foreach $oldline(@fortitle) {
        if ($oldline =~/<title>/) {
          ($title)=($oldline =~/<title>(.*)/);
        }
      }
      $title=~s/\s/\%20/g;
    } else {
      &error_message ("That quiz file does not exist, please try again.");
    }
    print STDERR "Location: $mkquizcgi_url\&quiz=$quiz\&title=\"$title\"\&count=4\&section=newcont\n\n\n";
    print "Location: $mkquizcgi_url\&quiz=$quiz\&title=$title\&count=4\&section=newcont\n\n\n";
  } #endif - additional question util

  # creates a new quiz
  if (param('section') eq 'newquiz') {
    $quiz=param('newquiz');
    if ($quiz =~ /\W/){ 
      &error_message("The quiz name can not contain any spaces or non alphanumeric characters.  Please try again.");
    }
    unlink <$basedir/$quiz.qz>; 
    if (param('sub') eq '') {
      # print "Content-type: text/html\n\n";
      require "$BASE/contenttype.inc"; # enable charset
      print "<html><body bgcolor=\"\#FFFFFF\"><form method=post action=\"$mkquizcgi_url\">\n";
      print "<h1>$_CREATINGNEWQUIZ: $quiz.qz</h1>\n";
      print "$_GIVETITLEFORQUIZ <i>($_IE <u>$_QUIZ_MUSCLEBONE</u> $_OR <u>$_QUIZ_WAR1812<input type=\"text\" name=\"title\" size=50><br><br>\n";
      print "<input type=\"hidden\" value=\"newcont\" name=\"section\">\n";
      print "<input type=\"hidden\" name=\"stubsection\" value=\"make_quiz\">\n";
      print "<input type=\"hidden\" value=\"$quiz\" name=\"quiz\">\n";
      print "<input type=\"submit\" value=\"  $_CONTINUE  \">\n";
      print "</form></body></html>";
    }
  } #endif - create new quiz
  
  # inside quiz generating/editing utility
  if (param('section') eq 'newcont') {
    $quiz=param('quiz');
    $image=param('image') if (param('image'));
    if (!param('title')) { &error_message("You did not enter a title.  Please try again."); }
    $title=param('title');
    if (param('count') eq '') {
      $count = 1 ; 
    } else { 
      $count = param('count'); 
      $count++;
    }
    if (param('question') ne '') {
      @addinfo=param('addinfo');
      @question=param('question');
      @answers= (A .. G);
      if (!param('cans')) { &error_message("You must choose a correct answer.  Please try again."); }
      if (param('cans')) {
        $tempcansvalue=param('cans');
        if (!param($tempcansvalue)) { &error_message("You have chosen a blank answer as the correct answer.  Please try again."); } 
      }
      open (OUT,">>$basedir/$quiz.qz");
      print OUT "<title>$title\n" if ($count=='2');
      print OUT "<question-start>\n";    
      print OUT "@question";
      print OUT "\n<answers-start>\n";
      $field='0';
      until ($field == 6) {
        $ansvar=@answers[$field];
        $answer=param($ansvar);
        if ($answer) { 
          print OUT "<correct-answer>" if (param('cans') eq $ansvar);
          print OUT "$ansvar\|\|$answer\n";
          $field++;
        } else { 
          $field++; 
        }
      }
      print OUT "<answers-end>\n";
      print OUT "<info-start>\n";
      print OUT "@addinfo";
      print OUT "\n<info-end>\n";
      print OUT "<image>$image\n" if ($image);
      print OUT "<question-end>\n";
      close(OUT);
      chmod (0770,"$basedir/$quiz.qz");
    }
    if (param('done')) {
      # print "Content-type: text/html\n\n";
      require "$BASE/contenttype.inc"; # enable charset
      print "<html><body bgcolor=\"\#FFFFFF\">\n";
      print "<h1>$_QUIZ <i>$title</i> $_ISDONE</h1>";
      print "<br>$_QUIZURL,<a href=\"$quizcgi_url?quiz=$quiz\">$quizcgi_url?quiz=$quiz</a> <br>$_ADDQUIZLINK\n";
      print "<form method=post action=\"$mkquizcgi_url\">\n";
      print "<input type=\"hidden\" value=\"linksection\" name=\"section\">\n";
      print "<input type=\"hidden\" name=\"stubsection\" value=\"make_quiz\">\n";
      print "<input type=\"hidden\" value=\"$quiz\" name=\"quiz\">\n";
      print "<input type=\"hidden\" value=\"$title\" name=\"title\">\n";
      print "<input type=\"submit\" value=\"  $_ADDLINK  \">\n";
      print "</form></body></html>";
      exit;
    }
    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print "<html><body bgcolor=\"\#FFFFFF\">\n<form method=post action=\"$mkquizcgi_url\">";
    print "<h1>$_ADDINGQUESTIONSTO $title</h1>\n";
    print "<b>$_QUESTION $count.</b>\n";
    print "<br>\n<table width=85%>\n<tr><td><b>$_ENTERQUESTION:</b></td>\n<td><textarea cols=55 rows=4 name=\"question\">\n</textarea>\n</td></tr>\n";
    @answers= (A .. G);
    print "</table>\n";
    print "<center><hr width=60%></center>";
    print "$_ADDIMAGETOQUESTION<input type=\"text\" name=\"image\" size=25>\n";
    print "<center><hr width=60%></center>";
    print "<table width=85%><th>$_CORRECTANSWER</th><th>$_MULTIPLECHOICEVALUE</th><th>$_ANSWER</th>\n";
  
    foreach $item (@answers) {
      print "<tr><td><center><input type=\"radio\" name=\"cans\" value=\"$item\"> </center></td><td><center>Answer <b>$item</b></center></td>\n<td><input type=\"text\" name=\"$item\" size=50></td></tr>\n"; 
    }
    print "</table>\n";
    print "<br><center><B>$_ENTERADDTLINFO</b>\n";
    print "<br><i>$_ANSWERSREVEALED</i>\n";
    print "<br><textarea name=\"addinfo\" cols=60 rows=4></textarea>\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"make_quiz\">\n";
    print "<input type=\"hidden\" value=\"newcont\" name=\"section\">\n";
    print "<input type=\"hidden\" value=\"$count\" name=\"count\">\n";
    print "<input type=\"hidden\" value=\"$title\" name=\"title\">\n";
    print "<input type=\"hidden\" value=\"$quiz\" name=\"quiz\">\n";
    print "<br><br><input type=\"checkbox\" value=\"done\" name=\"done\"> $_CHECKIFLASTQUESTION\n<br></center><br><center>";
    print "<input type=\"submit\" value=\"    $_ADDQUESTION    \">\n</center>";
    print "</body></html>";
  
  } #endif newcont

  # places link on main class page
  if (param('section') eq 'linksection') {
    $quiz=param('quiz');
    $title=param('title');
    $quizlink="$quizcgi_url?quiz=$quiz";
    &Place_link($quizlink,$title);  
    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print "<html><body bgcolor=\"\#FFFFFF\">";
    print "<h1>$_THANKYOU</h1>\n";
    print "$_LINKADDED\n";
    print "<BR><BR><CENTER><font size=\"4\" face=\"Arial,Helvetica\"><a href=\"../\">$_CLASSPAGE</A></font></CENTER>";
    print "</body></html>";
    exit;
  } #endif - linksection
 
  # dumps quiz into a test file in class's dir as name_of_quiz.qz 
  if (param('section') eq 'dumpall') {
    @anspos=(A .. G);
    $quiz=param('quiz');
    $title=param('title');
    $tcount=param('qnum');
    $count=1;
    open (OUT,">$basedir/$quiz.qz");
    print OUT "<title>$title\n";
    until ($count > $tcount) {
      if (param($count) =~/^\s+$/) {
        $count++;
        next;
      }
      $can="$count.can";
      $image="$count.image";
      print OUT "<question-start>\n";
      print OUT param($count),"\n";
      print OUT "<answers-start>\n";
      foreach $ans (@anspos) {
        $curans="$count$ans";
        if (param($curans)) {
          if ($ans eq param($can)) { 
            print OUT "<correct-answer>$ans\|\|",param($curans),"\n"; 
          } else {
            print OUT "$ans\|\|",param($curans),"\n"; 
          }
        }
      }
      print OUT "<answers-end>\n";
      print OUT "<info-start>\n"; 
      $info="$count.info"; 
      print OUT param($info),"\n";
      print OUT "<info-end>\n";
      print OUT "<image>",param($image),"\n" if (param($image));
      print OUT "<question-end>\n";
      $count++;
    }
    close(OUT); 
    &done_things;
  } #endif - dumpall
 
  # utility to edit existing quiz 
  if (param('section') eq 'oldquiz') {
    $quiz=param('quiz');
    $qnum=1;
    open (IN,"<$basedir/$quiz.qz");
    @qcontents=<IN>;
    close (IN);
    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print "<html><body bgcolor=\"\#FFFFFF\"><form method=post action=\"$mkquizcgi_url\"><br>\n";
    foreach $line (@qcontents) {
      if ($line =~/<title>/) {
        ($title)=($line =~/<title>(.*)/);
        print "<center><h1>$title\n</h1>"; 
        print "<h1><input size=\"50\" type=\"text\" name=\"title\" value=\"$title\"></h1></center>\n";
      }
      if ($line =~ /<answers-end>/) {
        $pos='';
        $ans++;
        until ($ans gt 'G' ) { 
          print "<table><tr><td><input type=\"radio\" name=\"$qnum.can\" value=\"$ans\">$ans</td>\n<td><input size=\"50\" type=\"text\" name=\"$qnum$ans\"></td></tr></table>\n";  
          $ans++;
        }   
      }
      if ($pos eq 'info') {
        print "$line" if ($line !~ /<info-end>/);
      }
      if ($line =~ /<info-start>/) {
        $pos = 'info';
        print "<hr>";
        print"<b>$_ADDTLINFO</b><br>\n";
        print"<textarea cols=60 rows=3 name=\"$qnum.info\">\n";
      } 
      if ($line =~ /<info-end>/) {
        $pos = '';
        print "</textarea>\n";
      } 
      if ($line =~ /<question-end>/) {
        $pos='';
        print "</td></tr><tr><td><b>$_IMAGEURL</b><br><input type=\"text\" name=\"$qnum.image\">\n" if (!$image);
        print "</td></tr></table><br>\n";
        $qnum++;
      }
      if ($pos eq 'question') {
        print "$line" if ($line !~ /<answers-start>/);
      }
      if ($pos eq 'answer') {
        if ($line =~/<correct-answer>/) {
          $line =~ s/<correct-answer>//g;
          ($ans,$info)=($line =~/(.*)\|\|(.*)/);
          print "<table><tr><td><b><input type=\"radio\" name=\"$qnum.can\" value=\"$ans\" checked>$ans</b></td>\n<td><b><input size=\"50\" type=\"text\" value=\"$info\" name=\"$qnum$ans\"></b></td>\n</tr></table>\n";  
        } else {
          ($ans,$info)=($line =~/(.*)\|\|(.*)/);
          print "<table><tr><td><input type=\"radio\" name=\"$qnum.can\" value=\"$ans\">$ans</td>\n<td><input size=\"50\" type=\"text\" value=\"$info\" name=\"$qnum$ans\"></td></tr></table>\n";  
        }
      }
      if ($line =~ /<question-start>/) {
        $image='';
        $pos='question';
        print "<table width=80% border=1><tr><td align=\"top\">$_QUESTION <b>$qnum.</b><br>\n ";
        print "<textarea cols=50 rows=4 name=\"$qnum\">\n";
      }
      if ($line =~ /<image>(.*)/) {
        $image = $1;
        print "<tr><td><b>$_IMAGEURL</b><br>\n<input type=\"text\" name=\"$qnum.image\" value=\"$image\">\n";
      }
      if ($line =~ /<answers-start>/) {
        $pos='answer';
        print "</textarea>\n";
        print "<hr>";
      }
    }
    $newqnum=$qnum-1;
    print "<input type=\"hidden\" name=\"quiz\" value=\"$quiz\">\n";
    print "<input type=\"hidden\" name=\"section\" value=\"dumpall\">\n";
    print "<input type=\"hidden\" name=\"qnum\" value=\"$newqnum\">\n";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"make_quiz\">\n";
    print "<input type=\"submit\" value=\"  $_MAKECHANGES  \">\n";
    print "</form></body></html>\n";
  } #endif - oldquiz

} #make_quiz
1
