#!/usr/local/bin/perl
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# move2ta.pl 
# Purpose: cron job that moves people from REGprof to REGta table to solve UCLA-specific problem where TAs in classes without discussion sections, get listed in REGprof table instead of REGta table.
#  intended to be run as part of daily regcheck.pl

# Steps:
# + loop through move2ta table
#   + for each term,srs & uid, check if exists in REGprof
#     + if so:
#       + insert it, plus relevant fake fields into REGta
#       + remove it from REGprof

# Updated 8-25-99 mike 


## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
$BASE = "/home/classweb"; # main classweb programs directory

# if setup.pl is run from a cronjob or the command line
# following code is necessary to determine the BASE prog. dir
unless ($BASE) { # If $BASE doesn't exist, use calling path or current directory
  use File::Basename;
  $BASE = dirname($0); # set $BASE to this program's calling path
  unless ($BASE) {
    # for programs called from this directory via telnet command with . on path
    $BASE=".";  # set to current directory if it still doesn't exist
  }
}

  require "$BASE/customize.pl";  # important vars set here
  require "$BASE/dbvars.pl";     # database vars set here
  require("$BASE/dbopen.pl");


####################################################
#  set up database variables and connection
$PROGBASE = "$BASE";

$cmd = "select * from move2ta";
$sth = $dbh->prepare($cmd) or die "Can't prepare $cmd: $dbh->errstr\n";
$sth->execute or die "Can't execute query: $sth->errstr\n";
while($ta = $sth->fetchrow_hashref) {
  $term = $ta->{term};
  $srs  = $ta->{srs};
  $uid  = $ta->{uid};
# print "$term, $srs, $uid\n";
  $cmd2 = "select reg_name,dept,coursenum,section,LPAD(section,3,'0') 
    as relsecidx
    from REGprof 
    where term='$term' && srs='$srs' && uid='$uid'";
  $sth2 = $dbh->prepare($cmd2) or die "Can't prepare $cmd2: $dbh->errstr\n";
  $sth2->execute or die "Can't execute query: ",$sth2->errstr,"\n";
  if($a = $sth2->fetchrow_hashref) {
    $reg_name = $a->{reg_name};
    $dept = $a->{dept};
    $coursenum = $a->{coursenum};
    $section = $a->{section};
    $relsecidx = $a->{relsecidx};
#   print "  $reg_name $dept $coursenum $section $relsecidx\n";

## put into REGta
    $cmd3 = "replace into REGta 
      (term,uid,fullname,srs,dept,coursenum,section,relsecidx)
      values('$term','$uid','$reg_name','$srs','$dept','$coursenum',
        '$section',' $relsecidx')";
    $sth3 = $dbh->prepare($cmd3) or die "Can't prepare $cmd3: $dbh->errstr\n";
    $sth3->execute or die "Can't execute query: ",$sth3->errstr,"\n";
    $rv = $sth3->rows;
#   print "  $rv rows affected.\n";

## delete from REGprof
    $cmd4 = "delete from REGprof
      where term='$term' && srs='$srs' && uid='$uid'";
    $sth4 = $dbh->prepare($cmd4) or die "Can't prepare $cmd4: $dbh->errstr\n";
    $sth4->execute or die "Can't execute query: ",$sth4->errstr,"\n";
    $rv = $sth4->rows;
#   print "  $rv rows affected.\n";
  }
}
$rc = $dbh->disconnect;
