######################################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: password.pm 
# Usage: called by discuss_password.php
# Steps: +password.pm
#          +password()
#            -enter_admin_pass()
#            -enter_wwwboard_pass()
#            -setwwwboardpass()
#            -change_pass()
#            -set_private_pass()
#
# Update 09-04-02 Jerome - added require for contenttype.inc
# Update 8-22-02 Nick and Jerome - Substituting out language-dependent text
#   strings with variables to allow multilingual support.
# Update 07-22-00 mike - replaced hard-coded with GLOBAL vars
# Update 08-17-99 mike - Changed Get to GET in .htaccess write in password setup
# Update 09-17-98 mike - changed enter_wwwboardpass subroutine to work with New Admin
# Update 09-16-98 mike - changed wwwboard to add two lines at beginning of .htaccess
#   and to make sure they stay there when password is deleted.
# Update 12-28-97 mike - change we made to change admin password inplace broke the
#   setup of wwwboard password (which needed -c option to create file.
#   Solved it by having separate routines for admin and wwwboard
# Update 12-08-97 mike - changed to fixed version of htpasswdcgi and don't need to
#   delete the file first, it changes password in place
# Update 08-20-97 mike - changed password fields to type=password so they don't show
#   when typing
# Update 08-19-97 added Discussion Board Password Utility 
# Update 08-05-97 working by adding rm old .htpasswd file first so -c works
# written by Artin Rebekale
#
# Status: production
# Purpose: module to change passwords on the admin directory

sub password{
  if (param('sub') eq ''){
    if (param('passtype') eq 'admin') {
      &enter_admin_pass;
    }
    if (param('passtype') eq 'wwwboard'){
      &enter_wwwboard_pass;
    }
  }
  if (param('sub') eq 'changepass'){
    if (param('passtype') eq 'wwwboard') {
      &setwwwboardpass;
    } elsif (param('passtype') eq 'admin') {
      &change_pass;
    }
  }

  sub enter_admin_pass {
    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print "<html><title>$_CHANGECLASSWEBPASSWORD</title><BODY BGCOLOR=#FFFFFF>";
    print "<form method=POST action=\"$cgi_url\">"; 
    print "<h2>$_PASSWORDCHANGEUTILITY</h2>\n";
    print "<br><h4>$_CHANGEPASSWORD_DIRECTIONS<br><br>";
    print "<input type=\"password\" name=\"newpass\"> $_CHANGEPASSWORD_CONFIRM ";
    print "<input type=\"password\" name=\"testpass\"><br>";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"password\">\n";
    print "<input type=\"hidden\" name=\"passtype\" value=\"admin\">\n";
    print "<input type=\"hidden\" name=\"sub\" value=\"changepass\"><br>\n";
    print "<input type=\"submit\" value=\"$_CHANGEADMINPASSWORD\">";
    print "</form></body></html>";

  } #enter_admin_pass

  sub enter_wwwboard_pass {
    unless (param('php') == 1) {
      # print "Content-type: text/html\n\n";
      require "$BASE/contenttype.inc"; # enable charset
      print "<html><title>$_BOARDPASSWORDUTILITY</title><BODY BGCOLOR=#FFFFFF>\n";
      print "<CENTER><h1>$_BOARDPASSWORDUTILITY</h1></CENTER>\n";
      print "<br>$_BOARDPASSWORD_DIRECTIONS<P>\n";
    }
    print "<form method=POST action=\"$cgi_url\">\n"; 
    print "$_ENTERUSERNAME: ";
    print "<input type=\"text\" name=\"name\"><br>\n";
    print "<br>$_ENTERPASSWORD: ";
    print "<input type=\"password\" name=\"newpass\"> $_CHANGEPASSWORD_CONFIRM ";
    print "<input type=\"password\" name=\"testpass\"><br><br>";
    print "<input type=\"hidden\" name=\"stubsection\" value=\"password\">\n";
    print "<input type=\"hidden\" name=\"passtype\" value=\"wwwboard\">\n";
    print "<input type=\"hidden\" name=\"sub\" value=\"changepass\"><br>\n";
    print "<input type=\"submit\" value=\"$_CHANGEBOARDPASSWORD\">\n";
    print "</form>\n";
    print "<form method=POST action=\"$cgi_url\">\n"; 
    print "<input type=\"hidden\" name=\"stubsection\" value=\"password\">\n";
    print "<input type=\"hidden\" name=\"passtype\" value=\"wwwboard\">\n";
    print "<input type=\"hidden\" name=\"sub\" value=\"changepass\">\n";
    print "<input type=\"hidden\" name=\"delete\" value=\"goahead\">";
    print "<input type=\"submit\" value=\"$_DELETEBOARDPASSWORD\">"; 
    print "</form>\n";
    unless (param('php') == 1) {
      print "</body></html>\n";
    }
  } #enter_wwwboard_pass

  sub change_pass {
    $passdir= $basedir . "/admin/pass";  
    $name = "instructor";
    my $newpass=param('newpass');     # new password 
    my $testpass=param('testpass');   # confirmation of password
    if (!$newpass eq ''){
      if ($newpass eq $testpass){     #checks/confirms accuracy of password
        system "$HTPASSWD -b $passdir/.htpasswd $name $newpass";
      &Redirect_User($baseurl);
      } else { 
        &error_message("The passwords did not match, please try again");
        exit;
      }
    } else {
      &error_message("You did not enter a password, please try again");
      exit; 
    }
  } #change_pass

  sub setwwwboardpass {
    if (param('delete') eq 'goahead') {
      open (OUT,">$basedir/wwwboard/.htaccess");
      print OUT "Options ExecCGI Includes\n";                       # added 9-16-98
      print OUT "DirectoryIndex index.htm index.html index.php\n";  # added 9-16-98
      close(OUT);
      $htaccess=$basedir . "/wwwboard/.htaccess";
      chmod (0664, "$basedir/wwwboard/.htaccess");
      &Redirect_User($baseurl);
    }  
    $passdir = $basedir . "/wwwboard/pass"; 
    $name = param('name');
    if (param('name') eq '') { &error_message("You did not enter a name, please try again"); }
    open (OUT,">$basedir/wwwboard/.htaccess");
    print OUT "Options ExecCGI Includes\n";                       # added 9-15-98
    print OUT "DirectoryIndex index.htm index.html index.php\n";  # added 9-15-98
    print OUT "AuthUserFile $passdir/.htpasswd\n";
    print OUT "AuthGroupFile /dev/null\n";
    print OUT "AuthName WWWBoard\n";
    print OUT "AuthType Basic\n";
    print OUT "<Limit GET>\n";
    print OUT "require user $name\n";
    print OUT "</Limit>\n";
    close(OUT);
    $htaccess=$basedir . "/wwwboard/.htaccess";
    chmod (0664, "$basedir/wwwboard/.htaccess");
    mkdir $passdir,0755; 
    chmod (0770,$passdir);
    system "chmod g+s $passdir";
    my $newpass=param('newpass');
    my $testpass=param('testpass'); 
    if (!$newpass eq ''){
      if ($newpass eq $testpass){     #new password matches confirmation
        # wwwboard/pass/.htpasswd has to be created first time. And since there
        # is only one wwwboard passwd for now, it doesn't matter if we recreate
        # it each time. Otherwise we've got to detect whether we're adding a 
        # password or changing one
        system "rm $passdir/.htpasswd";
        system "$HTPASSWD -bc $passdir/.htpasswd $name $newpass";
        chmod 0660, "$passdir/.htpasswd";
        &Redirect_User($baseurl);
      } else { 
        &error_message("The passwords did not match, please try again");
        exit;
      }
    } else {
      &error_message("You did not enter a password, please try again");
      exit; 
    }
  } #setwwwboardpass

  sub set_private_pass{
    $name=param('name');
    $passdir= $basedir . "/private/pass";  
    my $newpass=param('newpass');
    my $testpass=param('testpass'); 
    if (param('name') eq '') { &error_message("You did not enter a name, please try again"); }
    open (OUT,">$basedir/private/.htaccess");
    print OUT "AuthUserFile $passdir/.htpasswd\n";
    print OUT "AuthGroupFile /dev/null\n";
    print OUT "AuthName Private\n";
    print OUT "AuthType Basic\n";
    print OUT "<Limit GET>\n";
    print OUT "require user $name\n";
    print OUT "</Limit>\n";
    close(OUT);
    chmod (0660,"$basedir/private/.htaccess");
    if (!$newpass eq ''){
      if ($newpass eq $testpass){     #new password matches confirmation
        system "$HTPASSWD -bc $passdir/.htpasswd $name $newpass";
      chmod 0660, "$passdir/.htpasswd";
      &Redirect_User($baseurl);
      } else { 
        &error_message("The passwords did not match, please try again");
        exit;
      }
    } else {
      &error_message("You did not enter a password, please try again");
      exit; 
    }
  } #set_private_pass
} #password
1

