<? 
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
###############################################################
# Name: addlinks.php
# Usage: called from web
# Steps: +addlinks.php
#          +functions.php
#            +getcurrentlinkmode()
#              -ta site
#              -main site
#          +if(!$doit); frontend form 
#            +if(!$changeid); main frontend 
#              -recursivetable()
#            +elseif($changeid); edit frontend            
#              -recursivechangeprint()
#          +elseif(!$changeid && !$delid && !$delidd); normal backend  
#          +elseif($changeid && !$delid && !$delidd); backend to edit link           
#          +elseif($delid); delete warning/confirmation
#          +elseif($delidd); backend to actually delete link
#
# Update: 08-21-02 Jerome - replaced text with variables to support Multilingual
# Update: 7-20-00 kenny replaced hardcoded references with customize vars.
# Update: 2-27-00 mike line 471 had bug, fixed
# Update: 2-21-00 mike found typo on line 542 which caused link edit to not
#                 do anything.
# Update: 2-18-00 tim added the "are you sure" to the delete function
# Update: 2-15-00 mike and tim, moving the addlinksmike.php into production
# Update: 2-10-00 mike shrunk size of input fields to fit on screen
# Update: 2-9-00 mike changed type=addlinks to addlinksmike to ensure we stay
#                on this form while testing.
#       - found bug like Treiman's but was induced by dropping gray pulldowns
#       - added log to LOLBUG.log in admin directory for each class
# Update: 2-8-00 mike added display of ID and parent values in pull downs 
#                and removed pulldowns from old items. can be changed one at a time
#                thru the Edit Link Info link. decreases the massive size of the form
#                as the number of items grows.
# Update: 1-24-2000 mike edited EDIT and DELETE wording per Prof. Rigby
# Update: 7-23-1999 Adam Kaplan and Yelena Tsukerman - created
#
# Status: writing
# Purpose: adds to the links table     


  # initialize global variables, load functions and connect to database
  $BASE="/home/classweb";      # get program directory from Apache Environment  
  require "$BASE/customize.inc"; # load in customization info
  require "$BASE/dbopen.inc";    # connect to database
  require "$BASE/language.php";  # multilingual support

##################################################
# see notes; log to track instances of Treiman bug
##################################################
#
# $fp = fopen("LOLBUG.log", 'a');  # open and append
# $date = getdate();
# $ds = date("l dS of F Y h:i:s A");
# fputs ($fp,"**************** $ds\n");
#
##################################################


if (! isset($mode)) {
  require "$BASE/functions.php"; # load in library of functions
} #endif

if ($ta_uid) { #ta site
  $mode = getcurrentlinkmode($term,$srs,"ta");
  $site = "ta";
} else { #main site
  $mode = getcurrentlinkmode($term,$srs,"class");
  $site = "class";
} #endif

if ($mode == 0) { #redirect to old linkpage editor
  # location of classweb file
  include "$BASE/phpadmin/links.php";
  exit;
}

$NUM_BLANK_LINES = 5;
$updater = $REMOTE_USER;
if ($delid || $delidd) { #makes sure $delid and $delidd goes right to
                         #the backend -- delidd is a confirmation
  $doit = 1;
} #endif
$qnumlinks = query("select * from links where term='$term' && srs='$srs' && site='$site'");
$numlinks = numrows($qnumlinks);


#######################################
# Name: depthsearch
# Usage: $res = depthsearch($underitem,$overitem,$above)
# Update: 7/27/99 Adam Kaplan - created
# Status: writing
# Purpose: determines if there is a problem putting one item under another
###############################

function depthsearch ($underitem, $overitem, $above) {
  $currentitem = $overitem;
  while($above[$currentitem] != '') {
    if($above[$currentitem] == $underitem) {
      return 1;  # error! the underitem is above the overitem
    } elseif ($above[$currentitem] != '') {
      $currentitem = $above[$currentitem];
    } #endif
  } #endwhile
  return 0;  # ok...the underitem is not above the overitem
} #end depthsearch
############################### 


#######################################
# Name: children
# Usage: $child = children($term,$srs,$id,$site)
# Update: 7/27/99 Adam Kaplan - created
# Status: writing
# Purpose: sets every child/grandchild/etc. of a given parent to 1 in an array
#          called $child
###############################
function children($term,$srs,$parent,$site) {
  $child[$parent] = 1;
  $q = query("select * from links where term = '$term' && srs = '$srs' && parent = '$parent' && site = '$site'");
  if (numrows($q) == 0) {
    return $child;
  } #endif
  while($array = walk($q)) {
    $id = $array[ID];
    $child[$id] = 1;
    $childadditions = children($term,$srs,$id,$site);
    while($arrayinfo = each($childadditions)) {
      if ($arrayinfo[value] == 1) {
        $child[$arrayinfo[key]] = 1; 
      } #endif
    } #endwhile 
  } #endwhile
  return $child;
} #children
############################### 


#####################################
# Name: recursivechangeprint
# Usage: recursivechangeprint($parent,$term,$srs,$changeid,$site)
# Update: 7/26/99 Adam Kaplan - created
# Status: writing
# Purpose: print the links as they will appear on linkpage  
###############################
function recursivechangeprint ($parent, $term, $srs, $changeid, $site) {
  if ($parent == '') {
    $q = query("select * from links where term = '$term' && srs = '$srs' && site = '$site' && parent = '0' order by name");
  } else { # not first level
    $q = query("select * from links where term = '$term' && srs = '$srs' && site = '$site' && parent = '$parent' order by name");
  } #endif

  if (numrows($q) == 0) {
    return;
  } #endif
  print "<UL>\n";
  while ($current = walk($q)) {
    $specialpre = "";
    $specialpost = "";
    $number = $current[ID];
    print "<LI>\n";
    $pval = "";
    if ($current[parent] != 0) {
      $pval = $current[parent];
    }  #endif

    if ($current[ID] == $changeid) {
      $specialpre = "<BLINK><FONT COLOR=red>";
      $specialpost = "</BLINK></FONT>";
    }
    $kids = query("select ID from links where term='$term' && srs='$srs' && site = '$site' && parent='$current[ID]'");
    if ((numrows($kids) != 0) || ($current[parent] == 0)) { # no children
      $specialpre = "$specialpre" . "<B>";
      $specialpost = "</B>" . "$specialpost";  
    }

    $pvalx = $pval;
    if ($pval == "") { $pvalx = "Top"; }
    $shownums ="<font size=-1>($number under $pvalx)</font>"; 

    if ($current[url]) {
      print "<A HREF=\"$current[url]\">$specialpre$current[name]$specialpost</A> $shownums";
    } else {
      print "$specialpre <B>$current[name] </B>$specialpost $shownums";
    } #endif
    if ($current[description]) {
      print " - $current[description]<BR>\n";
    } #endif
    recursivechangeprint($number, $term, $srs, $changeid, $site);
  } #endwhile
 
  print "</UL>\n";
 
} #recursivechangeprint
########################################


#####################################
# Name: recursivetable
# Usage: recursivetable($parent, $term, $srs, $site)
# Update: 7/26/99 Adam Kaplan - created
# Status: writing
# Purpose: print the table of links recursively
###############################
function recursivetable ($parent, $term, $srs, $site) {
  global $_EDITLINKINFO, $_DELETELINK, $_DONOTMOVE, $_MOVETOTOPLEVEL;

  if ($parent == '') {
    $q = query("select * from links where term = '$term' && srs = '$srs' && site = '$site' && parent = '0' order by name");
  } else { # not first level
    $q = query("select * from links where term = '$term' && srs = '$srs' && site = '$site' && parent = '$parent' order by name");
  } #endif 

  if (numrows($q) == 0) {
    return;
  } #endif
  print "<ul>\n";
  while ($current = walk($q)) {
    $specialpre = "";
    $specialpost = "";
    $number = $current[ID];
    print "<li>";
    $pval = "";
    if ($current[parent] != 0) {
      $pval = $current[parent];
    } #endif
    $kids = query("select ID from links where term='$term' && srs='$srs' && site = '$site' && parent='$current[ID]'");
    if (($current[parent] == 0) || (numrows($kids) != 0)) {
      $specialpre = "<B>";
      $specialpost = "</B>";
    } #endif

    $pvalx = $pval;
    if ($pval == "") { $pvalx = "Top"; }
    $shownums ="<font size=-1>($number under $pvalx)</font>"; 
    if ($current[url] != "") { 
      if( (ereg("^http://",$current[url])) || (ereg("^www",$current[url]))){
        print "<a href=\"$current[url]\">$specialpre$current[name]$specialpost</a> $shownums $current[description] ";
      } else {  
#       print "<a href=\"$current[url]\">$specialpre$current[name]$specialpost</a> $shownums $current[description] ";
        print "<a href=\"../$current[url]\">$specialpre$current[name]$specialpost</a> $shownums $current[description] ";
      }
    } elseif ($current[url] == "") {
      print "<b>$specialpre$current[name]$specialpost </b> $shownums $current[description]";
    } #endif
    print "&nbsp;&nbsp;--&nbsp;&nbsp;\n";
    print " <a href=\"$PHP_SELF?type=addlinks&changeid=$number\">$_EDITLINKINFO</a>";
    print ", <a href=\"$PHP_SELF?type=addlinks&delid=$number\">$_DELETELINK</a>\n";

    ## See notes on usage of expert mode
#   $expert = 1;   #has pull-down menus for every link
    $expert = 0;   #turns off menus for every link 
    $choices = 0;
    if ($expert == 1) {
      if($current[parent] != 0) {
        $choices = 1;
        print "<select name=\"choice$number\">\n";
        print "<OPTION selected value=\"leave\">$_DONOTMOVE</OPTION>\n";
        print "<OPTION value=\"toplevel\">$_MOVETOTOPLEVEL</OPTION>\n";
      } else { 
        $choices = 0;
      } #endif
      $child = children($term, $srs, $number, $site);
      $child[$current[parent]] = 1; # since it's already under its parent
      if ($current[parent] == 0) {
        $top = 1;
      }  
      $qcursor = query("select * from links where term = '$term' && srs = '$srs' && site = '$site' order by name");
      $oldchoices = $choices;
      $num = numrows($qcursor); $size = sizeof($child);
      $choices = $choices + numrows($qcursor) - (sizeof($child) - $top);
      if($choices > $oldchoices) {
        if ($oldchoices == 0) {
          print "<select name=\"choice$number\">\n";
          print "<OPTION selected value=\"leave\">$_DONOTMOVE</OPTION>\n";
        } #endif
        while($row = walk($qcursor)) {
          $checknum = $row[ID];
          if($child[$checknum] != 1) {
            $checkname = $row[name];
            print "<OPTION value=\"mov$checknum\">$checkname #$checknum</OPTION>\n";
          } #endif
        } #endwhile
        print "</select>\n";
      } elseif ($oldchoices == 1) {
        print "</select>\n";
      } #endif ($choices > $oldchoices)
    } #endif ($expert == 1)
    print "<br>\n";
    recursivetable($number, $term, $srs, $site);
  } #endwhile

  print "</ul>\n";

} #recursivetable
########################################

if (!$doit) { #frontend form
  if (!$changeid) { #main frontend
?>
<HTML><HEAD><TITLE>
<?
      $combinednums = findnums($term,$srs);
      echo "$combinednums ";
?>
<? echo $_LINKADDEDITUTILITY; ?></title>
</head>
<body bgcolor="#FFFFFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<? include "$BASE/phpadmin/adminbanner.inc"; ?>
<font face="Arial,Helvetica" color="#FFFFFF" size="6"><? echo $_LISTOFLINKSEDIT_CAP; ?></font>
  </td>
  </tr>
</table>
<P>
<table border="0" cellspacing="0" cellpadding="0" bgcolor="#FFFFCC" align=center>
<tr>
<td bgcolor="#FFFFCC"><font face="Arial,Helvetica" color="#000000" size="5"><? echo $_DIDYOUKNOW; ?></font></td>
</tr>
<tr>
<td bgcolor="#FFFFCC"><font face="Arial">
<OL>
<? echo $_ADDLINKS_DESCRIPTION; ?>
</OL>
</font></td>
</tr>
</table>
<BR clear=all>

<FORM METHOD=POST ACTION="<? echo $PHP_SELF; ?>">
<CENTER>
<?     
    if ($numlinks > 0) {
?>
       <font color=red size="+1"><? echo $_FILLBOXESTOADD; ?> 
       <? echo $_USEPULLDOWNTOPUTUNDER; ?>
       </font>
<?
    } #endif
?>
<br>
<input type="submit" value="<? echo $_SUBMITCHANGES; ?>">
<input type="reset" value="<? echo $_RESET; ?>">
</CENTER>
       <TABLE VALIGN=TOP BORDER=0 ALIGN=CENTER Cellspacing=0 Width=100%><TR>
       <th><font size="+1"><? echo $_ITEMNAME; ?></font></th>
       <th><font size="+1"><? echo $_URL; ?></font></th>
       <th><font size="+1"><? echo $_DESCRIPTION; ?></font></th>
       <th>
<?     
    if ($numlinks > 0) {
?>
         <font size="+1"><? echo $_PLACEUNDER; ?></font>
<?     
    } #endif
?>
       </th>
       </TR>

       <input type="hidden" name="type" value="addlinks">
       <input type="hidden" name="doit" value="1">
       <input type="hidden" name="term" value="<? echo $term; ?>">
       <input type="hidden" name="srs" value="<? echo $srs; ?>">

<?
    for($i = 1; ($i <= $NUM_BLANK_LINES) && (!$changeid); $i++) {
?>
         <tr>
         <td><INPUT SIZE="20" name="newname<? echo $i; ?>"></td>
         <td><INPUT SIZE="20" name="newurl<? echo $i; ?>"></td>
         <td><INPUT SIZE="20" name="newdescription<? echo $i; ?>"></td>
         <td>
<?       
      if ($numlinks > 0) {
?>
           <SELECT name="newchoice<? echo $i; ?>">
           <OPTION selected value="toplevel"><? echo $_PLACEATTOPLEVEL; ?></OPTION> 
<?
        $qlinks = query("select name,ID from links where term = '$term' && srs = '$srs' && site = '$site' order by name");
        while ($link = walk($qlinks)) {
          $num = $link[ID];
          print "<OPTION value=\"mov$num\">$link[name] #$link[ID]</OPTION>\n";
        } #endwhile
?>        
           </SELECT> 
<?
      } #endif ($numlinks > 0)
?>
         </td>
         </tr>
<?
    } #endfor
    print "</table>\n";
    if ($numlinks > 0) {
?>
         <table bgcolor="#FFFFCC" width=100%><tr><td>
         <center>
         <H3 ALIGN=center><? echo $_LINKSASTHEYAPPEAR; ?>:</H3>
         <font color=red size="+1"><? echo $_EDITDELETELINKS; ?> 
         </font>
         </center>
<?
         recursivetable('',$term,$srs,$site);
         print "</td></tr></table>\n";
    } else { # if there are no links
      print "<BR><BR><BR>\n";
    } #endif
?>
       <center><font size=+2>
       <a href="../linkpage.php"><? echo $_GOTOLISTOFLINKS; ?></a>
       </font>
       </center>
<?
  } elseif ($changeid) { #edit frontend
?>
      <HTML><HEAD><TITLE><? echo $_LINKEDITUTILITY; ?></TITLE></HEAD>
      <BODY BGCOLOR="white">
      <H1 ALIGN=CENTER><? echo $_LINKEDITUTILITY; ?></H1>
      <P> <FONT COLOR=red size=+1>
      <? echo $_USEPULLDOWNONRIGHT; ?>
</FONT></P>
<?
    print "<TABLE VALIGN=TOP BORDER=0 ALIGN=CENTER Cellspacing=0 Width=100%><TR>\n";
    print "<th><font size=\"+1\"><? echo $_ITEMNAME; ?></font></th>\n";
    print "<th><font size=\"+1\"><? echo $_URL; ?></font></th>\n";
    print "<th><font size=\"+1\"><? echo $_DESCRIPTION; ?></font></th>";
    print "<th><font size=\"+1\"><? echo $_PLACEUNDER; ?></font></th>\n";
    print "</TR><tr>\n";
    print "<FORM METHOD=POST ACTION=\"$PHP_SELF\">\n";
    print "<input type=\"hidden\" name=\"type\" value=\"addlinks\">\n";
    print "<input type=\"hidden\" name=\"doit\" value=\"1\">\n";
    print "<input type=\"hidden\" name=\"term\" value=\"$term\">\n";
    print "<input type=\"hidden\" name=\"srs\" value=\"$srs\">\n";
    print "<INPUT TYPE=\"hidden\" name=\"changeid\" value=\"$changeid\">\n";

    $current = selectfirst("select * from links where ID='$changeid' && site='$site'");
    $number = $current[ID];
    print "<td><INPUT SIZE=\"20\" name=\"name$number\" value=\"$current[name]\"></td>\n";
    print "<td><INPUT SIZE=\"20\" name=\"url$number\" value=\"$current[url]\"></td>\n";
    print "<td><INPUT SIZE=\"20\" name=\"description$number\" value=\"$current[description]\"></td>\n"; 
    print "<td>\n";
    print "<select name=\"choice$number\">\n";
    print "<OPTION selected value=\"leave\">$_DONOTMOVELINK</OPTION>\n";
    if($current[parent] != 0) {
      print ("<OPTION value=\"toplevel\">$_MOVETOTOPLEVEL</OPTION>\n");
    } #endif
    $child = children($term, $srs, $number, $site);
    $child[$current[parent]] = 1; # since it's already under its parent
    $qcursor = query("select * from links where term = '$term' && srs = '$srs' && site = '$site' order by name");
    while($row = walk($qcursor)) {
      $checknum = $row[ID];
      if($child[$checknum] != 1) {
        $checkname = $row[name];
        print "<OPTION value=\"mov$checknum\">$checkname #$checknum</OPTION>\n";
      } #endif
    } #endwhile
    print "</select></td>\n";
    print "</tr></table>\n";
    print "<center>";
    print "<input type=submit value=\"$_SUBMITCHANGES\"><input type=reset value=\"$_RESET\"></center></form>\n";
    print "<table bgcolor=\"#BBBBBB\" width=100%><tr><td>\n";
    print "<H3 ALIGN=center>$_LINKSASTHEYAPPEAR:</H3>\n";
    recursivechangeprint('',$term,$srs, $changeid, $site);
    print "</td></tr></table>\n";
  } #endif (!$changeid)
} elseif(!$changeid && !$delid && !$delidd) { # normal backend
# fputs ($fp,"LINE 423: \$changeid=$changeid <br>\n");
  # find current max ID in database  
  $id = selectfirst("select max(ID) from links where term = '$term' && srs = '$srs' && site = '$site'");
  $maxid = $id[0];
# fputs ($fp, "LINE 427: \$changeid=$changeid \$maxid=$maxid<br>\n");
  $id = selectfirst("select min(ID) from links where term = '$term' && srs = '$srs' && site = '$site'");
  $minid = $id[0];
  # insert new links (if defined) into the database
  for ($i = 1; $i <= $NUM_BLANK_LINES; $i++) {
    $choicevar = "newchoice" . $i;
    $sortvar = "newsort" . $i;
    $namevar = "newname" . $i;
    $urlvar = "newurl" . $i;
    $descriptionvar = "newdescription" . $i;
    if ( (isset($$sortvar) || 
          isset($$namevar) || 
           isset($$urlvar) || 
           isset($$descriptionvar)  
          ) && $$namevar) {
      $choice = $$choicevar;
      $sort = $$sortvar;
      $name = $$namevar;
      $url = $$urlvar;
      $description = $$descriptionvar;
      if ($choice == "toplevel") {
        $parent = 0;
      } elseif (ereg("^mov([0-9]+)$",$choice,$results)) {
        $parent = $results[1];
      } #endif
#     fputs ($fp,"LINE 471: \$choice=$choice,\$name=$name,\$parent=$parent\n");
      $term = addslashes($term);
      $srs = addslashes($srs);
      $parent = addslashes($parent);
      $name = addslashes($name);
      $url = addslashes($url);
      $description = addslashes($description);
      $sort = addslashes($sort);
      $q = query("insert into links (term, srs, parent, name, url, description, sort,updater,site) values ('$term', '$srs', '$parent', '$name', '$url' , '$description', '$sort','$updater','$site')");
    } #endif
  } #endfor
     
  # now update all changed HEADING IDs
  # be careful not to create orphans by using function depthsearch
  # (move links)
  
  $errors = '';
  for ($i = $minid; ($i <= $maxid) && ($errors == ''); $i++) { # first iteration is to check for errors only
    $choicevar = "choice" . $i;
    $choice = $$choicevar;
    if (ereg("^mov([0-9]+)$",$choice,$result)) {
      $newparent = $result[1];
      if(depthsearch($i,$newparent,$above)) {  # error: $i was found above $newparent
        $iname = selectfirst("select name from links where ID='$i'");
        $undername = $iname[0];
        $oname = selectfirst("select name from links where ID='$newparent'");
        $overname = $oname[0];
        $errors .= "<BR>$_COULDNOTMOVE $undername $_BELOW $overname.  $_MOVECREATEDCYCLE";
      } else { # no error yet
        $above[$i] = $newparent;
      } #endif    
    } #endif 
  } #endfor

  if ($errors != '') { #we had an error
?>
       <HTML><HEAD><TITLE><? echo $_ERROR; ?></TITLE>
       </HEAD>
       <BODY BGCOLOR="white">
       <H1 ALIGN=CENTER><? echo $_ERROR; ?></H1>
       <P> <? echo $_MOVELINKING_ERROR; ?>  
       </P>
       <P> <FONT COLOR=red> <? # echo $errors; ?>
       </FONT></P>
       <CENTER>    
       <? echo $_PRESSBACKTOSEEORIGINAL; ?>
       </CENTER>
<?
  } else {  #no error...
    for ($i = $minid; $i <= $maxid; $i++) { # now if there's no problem...commence with database update
      $choicevar = "choice" . $i;
      $choice = $$choicevar;
      if ((isset($choice)) && ($choice != "leave")) {
        if ($choice == "toplevel") {
          $newparent = 0;
        } elseif (ereg("^mov([0-9]+)$",$choice,$result)) {
          $newparent = $result[1];
        } #endif 
        $newparent = addslashes($newparent);
        query("update links set parent = '$newparent' where ID = '$i' && term = '$term' && srs = '$srs' && site = '$site'");
      } #endif
    } #endfor
?>
       <HTML><HEAD><TITLE><? echo $_LINKADDEDITUTILITY; ?></TITLE>
       <meta http-equiv="Refresh" content="1;url=<? echo "../linkpage.php"?>">
       </HEAD>
       <BODY BGCOLOR="white">
       <H1 ALIGN=CENTER> <? echo $_THANKYOU; ?></H1>
       <P> <? echo $_PROCESSING_MOVELINK; ?>
       </P>
<?
  } #endif (error) 
} elseif ($changeid && !$delid && !$delidd) { # backend to edit a link
# fputs ($fp,"LINE 526: \$changeid=$changeid <br>\n");
  $choicevar = "choice" . $changeid;
  $namevar = "name" . $changeid;
  $urlvar = "url" . $changeid;
  $descriptionvar = "description" . $changeid;
  $choice = $$choicevar;
  $name = $$namevar;
  $url = $$urlvar;
  $description = $$descriptionvar;
  if($choice == "leave" ) {
    $current = selectfirst("select parent from links where ID=$changeid && site='$site'");
    $parent = $current[parent];         
  } elseif ($choice == "toplevel") {
    $parent = 0;
  } elseif (ereg("^mov([0-9]+)$",$choice,$result)) {
    $parent = $result[1];
  } #endif
  $parent = addslashes($parent);
  $name = addslashes($name);
  $url = addslashes($url);
  $description = addslashes($description);
  $updater = addslashes($updater);
  query("update links set parent = '$parent', name = '$name', url = '$url', description = '$description', updater = '$updater' where ID = '$changeid' && term = '$term' && srs = '$srs' && site = '$site'");
?>
     <H1 ALIGN=CENTER> <? echo $_THANKYOU; ?> </H1>
     <P> <? echo $_PROCESSING_MOVINGLINK; ?></P>
     <HTML><HEAD><TITLE><? echo $_LINKEDITUTILITY ?></TITLE>
     <meta http-equiv="Refresh" content="1;url=<? echo "../linkpage.php"?>">
     </HEAD>
     <BODY BGCOLOR="white">
<?
} elseif ($delid){  # the delete warning making sure confirmation
  
?>
         <HTML><HEAD><TITLE><? echo $_DELETEWARNING; ?></TITLE></HEAD><BODY
BGCOLOR=white><H1
ALIGN=C$
         <p><? echo $_DELETEWARNING_MSG; ?>
          </P>
         </HTML>
<?
  print " <a href=\"$PHP_SELF?type=addlinks&delidd=$delid\">$_DELETELINK
    </a>\n
    ";           
?>
         <HTML>
         <CENTER>
         <? echo $_PRESSBACKBUTTON; ?>
         </CENTER></HTML>
<?                                                                            
} elseif ($delidd) { # backend to ACTUALLY delete a link
  $q = query("select * from links where parent = '$delidd' && site =
    '$site'");
  if (numrows($q) != 0) {
?>       
         <HTML><HEAD><TITLE><? echo $_ERROR; ?></TITLE></HEAD><BODY BGCOLOR=white><H1 ALIGN=CENTER><? echo $_ERROR; ?></H1>
         <p><? echo $_LINKWITHSUBITEMS; ?> </P>
         <CENTER>   
         <? echo $_BACKTOLINKUTILITY; ?> 
         </CENTER></BODY></HTML>
<?
  } else {
    query("delete from links where ID = '$delidd' && site = '$site'");
?>
       <HTML><HEAD><TITLE><? echo $_LINKDEL_TITLE; ?></TITLE>
       <meta http-equiv="Refresh" content="1;url=<? echo "../linkpage.php"?>">
       </HEAD>
       <BODY BGCOLOR="white">
       <H1 ALIGN=CENTER> <? echo $_THANKYOU; ?></H1>
       <P> <? echo $_PROCESSING_MOVELINK; ?> </P>
<?     
  } #endif else
} #endif (!$doit)
?>
<BR>
<? include("$BASE/phpadmin/admin_footer.inc"); ?>
</font></small></small></p>
</BODY></HTML>
