<?
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
#########################################################################
# Name: easy_course.php
# Usage: called from web by main_course
# Steps: +easy_course.php
#          -check modify flag, make changes
#          -check update flag, make changes
#
# Update 08-22-02 Jerome - replaced text with variables for multilingual
# Update 07-20-00 mike - removed hard-coded vars
# Update 08-11-99 Adam Kaplan: added code to enable HTML tags inside form
# Update 07-09-99 Adam Kaplan: commented
#
# Status: production
# Purpose: makes changes to course information


  $DEBUG = 0;     # set to "1" for debugging
  $BASE="/home/classweb";      # get program directory from Apache Environment
  
  require "$BASE/customize.inc"; # load in customization info
  require "$BASE/functions.php"; # load in library of functions
  require "$BASE/dbopen.inc";    # connect to database
  require "$BASE/language.php";  # multilingual support

  $base = "$BASE/prof/models";

  # initialize arrays
  $classfields = array("title", "desc", "exam", "remarks");

  $noredirect = 0;

  # Class fields
  if ($DEBUG) echo "<br><b>----Class Fields----</b><br>";
   
  $modifyflag = 0;
  $updateflag = 0;

  for($i=0; $i < sizeof($classfields); $i++) {
    $v = "v$classfields[$i]";
    $h = "h$classfields[$i]";
     
    $text[$i]= ereg_replace("\x0d", "", ${$v});     # "\x0d" is the code for "^M"

    # if the newly input value is different from the old value got from database
    # insert the new value into database if it hasn't been updated from last 
    # read, otherwise display a warning and rollback; if there's no change,
    # don't take any action

    $newtext[$i] = stripslashes(ereg_replace("\n", "", $text[$i])); 

    # get rid of "\n" and 
    # strip any early slashes  8/11/99 Adam Kaplan

    if (strcmp(trim($text[$i]), trim(${$h}))) {
      $modifyflag = 1;    # set modified flag
    }
  } 
  
  if ($modifyflag == 0) {
    # no change
    if ($DEBUG) echo "<br><b>No change has been made.</b><br>\n";  

  } else {

    # get the most recent update timestamp
    $query = query ("select updated, updateruid from classloc where term='$hterm' && srs='$hsrs'");
    $array = walk($query);

    if (!$array || strcmp($array[updated], $hclassloctime) == 0) { 
      $updateflag = 1;     # set update ready flag       
    }

    if ($updateflag == 0) {

      $noredirect = 1;     # set flag for no redirecting

      # convert the timestamp got from database to readable format
      $stored = timestamptodate($array[updated]);

      # get the current time
      $current = date("M d Y H:i:s");

      # rollback 
      echo "<br><b>$_INFOCHANGE_NOTMADE_A $_COURSE_LC $_INFOCHANGE_NOTMADE_B $array[updateruid] $_INFOCHANGE_NOTMADE_C $stored $_INFOCHANGE_NOTMADE_D $current.</b><br>\n";

    } else {
      # update database records
      $query = query ("select coursetitle from REGclasses where term='$hterm' && srs='$hsrs'");
      $array = walk($query);

      if($array[coursetitle] == $newtext[0]){
        $newtext[0] = "";
      }
      for ($i = 0; $i < 4; $i++) { 
        $newtext[$i] = ereg_replace('"', '&quot;', $newtext[$i]);
        $newtext[$i] = ereg_replace("(<[^>]*)&quot;([^>]*)&quot;([^>]*>)", "\\1\"\\2\"\\3", $newtext[$i]);
        $newtext[$i] = addslashes($newtext[$i]);
      } 
      if (!query ("replace into classloc (term, srs, dept, coursenum, section, title, exam, description, updateruid, remarks) values ('$hterm', '$hsrs', '$hdept', '$hcoursenum', '$hsection', '$newtext[0]', '$newtext[2]', '$newtext[1]', '$hnewuid', '$newtext[3]')")) {
       echo mysql_errno().": ".mysql_error()."<BR>";
      } else {
        if ($DEBUG) echo "<br><b>Records updated successfully.</b><br>\n";
      }
    }
  }

  # redirect to index.php if no change has been made or updated successfully
  if ($DEBUG) echo "<br><b>noredirect = $noredirect</b><br>";

  if ($noredirect == 0 ) { 
    if ($DEBUG) echo "<br><b>term = $hterm srs=$hsrs</b><br>\n";
    Header("Location: ../"); 
  } else {
    # somebody else has updated the database records
    echo "<br><b>$_CLICK_CLASSWEBEDITOR_A <font size=+1><a href=\"?type=main_course&term=$hterm&srs=$hsrs\">$_CLICK_CLASSWEBEDITOR_B</a></font> $_CLICK_CLASSWEBEDITOR_C</b><br>\n";
  }
?>
