<?    
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
###############################################
# Name: easy_instructor.php
# Usage: called from web by main_instructor.php
# Steps: easy_instructor.php
#
# Update 08-22-02 Jerome - replaced text with variables for multilingual
# Update 07-20-00 mike - removed hard-coded vars
# Update 07-09-99 Adam Kaplan: commented
#
# Status: production
# Purpose: allows changes to instructor info


  $DEBUG = 0;     # set to "1" for debugging
  $BASE="/home/classweb";      # get program directory from Apache Environment
  
  require "$BASE/customize.inc"; # load in customization info
  require "$BASE/functions.php"; # load in library of functions
  require "$BASE/dbopen.inc";    # connect to database
  require "$BASE/language.php";  # multilingual support

  $base = "$BASE/prof/models";

  # initialize arrays
  $proffields = array("profname", "profphone", "profemail", "profhideemail", "profoffice", "profhour", "profurl");

  $noredirect = 0;

  if ($DEBUG) echo "<br><b>----Prof Fields----</b><br>";

  $j =  1; 
  while ($j <= $hnumprofs) {      # check for each prof
   
    $modifyflag = 0;
    $updateflag = 0;

    if ($DEBUG) echo "<br><b><i>Prof $j</i></b><br>\n";

    $profuid = "hprofuid$j";
    $profupdatetime = "hprofupdatetime$j";
    $profupdateuid = "hprofupdateuid$j";
    $profchecked = "hprofchecked$j";

    for($i=0; $i < sizeof($proffields); $i++) {
    
      $v = "v$proffields[$i]$j";
      $h = "h$proffields[$i]$j";
    
      # if the newly input value is different from the old value got from database 
      #   insert the new value into database if it hasn't been updated from last 
      #   read, otherwise display a warning and rollback; if there's no change,
      #   don't take any action

      if (strcmp(trim(${$v}), trim(${$h}))) {
        $modifyflag = $modifyflag + 1;
      } else {
        $modifyflag = $modifyflag;
      }

      $text[$i] = ${$v};     
      if ($DEBUG) echo "\$text[$i] = $text[$i]<br>";
    }  

    if ($modifyflag == 0) {
      # no change
      if ($DEBUG) echo "<br><b>No change has been made.</b><br>\n";  
    } else {

      # get the most recent update timestamp
      $query = query ("select * from profsloc where uid='${$profuid}'");
      $array = walk($query);

      if (!$array) { 
        $updateflag = $updateflag + 1;     # set update ready flag
        $array[notes] = "";
        $array[password] = "";
        $array[email2] = $text[2];
      } elseif (strcmp($array[updated], ${$profupdatetime}) == 0) {
        $updateflag = $updateflag + 1;     # set update ready flag      
      } else {
        $updateflag = $updateflag;
      }

      if ($updateflag == 0) {

        $noredirect = $noredirect + 1;     # set flag for no redirecting

        # convert the timestamp got from database to readable format
        $stored = timestamptodate($array[updated]);

        # get the current time
        $current = date("M d Y H:i:s");

        # rollback 
        echo "<br><b>$_INFOCHANGE_NOTMADE_A $_INSTRUCTOR_LC $_INFOCHANGE_NOTMADE_B $array[updateruid] $_INFOCHANGE_NOTMADE_C $stored $_INFOCHANGE_NOTMADE_D $current.</b><br>\n";
       
      } else {
        # update database records
        if ($DEBUG) echo "${$profuid}<br> $text[0]<br> $text[4]<br> $text[1]<br> $text[2]<br> $array[notes]<br> $text[3]<br> $array[password]<br> $array[email2]<br> $text[5]<br> $hnewuid<br>";
         
        # check if the office hour in profsloc table is applied to all
        #   courses the instructor taught this quarter

        for ($i = 0; $i < 6; $i++) {
          $text[$i] = addslashes($text[$i]);
        } #endfor 
        if (${$profchecked} == "No") {

          # select the office hour for the individual course from hours and
          $query_new_hour = query ("select office_hours from profsloc where uid='${$profuid}'");
          $array_new_hour = walk($query_new_hour);

          if(!$array_new_hour[office_hours]) $array_new_hour[office_hours]="";
          
          # update info in profsloc table except office hour
          if (!$newquery1 = query ("replace into profsloc (uid, fullname, office, phone, email, notes, hide_email, password, email2, office_hours, updateruid, appliedtoall) values ('${$profuid}', '$text[0]',  '$text[4]', '$text[1]', '$text[2]', '$array[notes]', '$text[3]', '$array[password]', '$array[email2]', '$array_new_hour[office_hours]', '$hnewuid', 'No')")) {
            echo mysql_errno().": ".mysql_error()."<BR>";
          } 
          
          # update office hour info in hours table
          if (!$newquery2 = query ("replace into hours (term, srs, uid, office_hours) values ('$hterm', '$hsrs', '${$profuid}', '$text[5]')")) {
            echo mysql_errno().": ".mysql_error()."<BR>";
          }

          # update url in profurl table
          if (!$newquery5 = query ("replace into profurl (uid, url) values ('${$profuid}', '$text[6]')")) {
            echo mysql_errno().": ".mysql_error()."<BR>";
          }

        } else {
          # update info in profsloc table
          if (!$newquery3 = query ("replace into profsloc (uid, fullname, office, phone, email, notes, hide_email, password, email2, updateruid) values ('${$profuid}', '$text[0]',  '$text[4]', '$text[1]', '$text[2]', '$array[notes]', '$text[3]', '$array[password]', '$array[email2]', '$hnewuid')")) {
            echo mysql_errno().": ".mysql_error()."<BR>";
          }

          if (!$newquery4 = query ("replace into hours (term, srs, uid, office_hours) values ('$hterm', '$hsrs', '${$profuid}', '$text[5]')")) {
            echo mysql_errno().": ".mysql_error()."<BR>";
          }

          # update url in profurl table
          if (!$newquery6 = query ("replace into profurl (uid, url) values ('${$profuid}', '$text[6]')")) {
            echo mysql_errno().": ".mysql_error()."<BR>";
          }

        }
      }
    }
    $j++;
  }

  # redirect to index.php if no change has been made or updated successfully
  if ($DEBUG) echo "<br><b>noredirect = $noredirect</b><br>";

  if ($noredirect == 0 ) { 
    if ($DEBUG) echo "<br><b>term = $hterm srs=$hsrs</b><br>\n";
    Header("Location: ../");
 
  } else {
    # somebody else has updated the database records
    echo "<br><b>$_CLICK_CLASSWEBEDITOR_A <font size=+1><a href=\"?type=main_instructor&term=$hterm&srs=$hsrs\">$_CLICK_CLASSWEBEDITOR_B</a></font> $_CLICK_CLASSWEBEDITOR_C</b><br>\n";
    
  }
?>
