<?
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: other_showroster.php 
# Purpose: shows the class roster
# Usage: called from web
# Steps: +other_showroster.php
#
# Update 08-22-02 Jerome - replaced text with variables for multilingual
# Update 07-20-00 Mike: removing hard-codes vars
# Update 01-11-00 Yelena: commenting out the code that assumes that if the 
#           original class has 0 people enrolled the crosslisted classes will
#           have 0 enrolled as well.  Now will show count for crosslisted 
#           classes even if main class has 0 enrolled. 
# Update 08-05-99  yelena: changing return to exit if no students found on 
#           roster.  Return was causing parse errors 
# Update 02-18-99 mike: added middle names at McFarland's request,
#           dropped centering
# Update 12-04-98 mike: changed $count to start at 0 because -1 
#           was giving us
#           and undercount of one, and skipping rosters with 
#           only 1 student. See 98F Soc 197E. 
# Update: Added code to display Dropped instead of N/A for enroll_status = D
#
# Status: production


  # initialize global variables, load functions and connect to database
  $BASE="/home/classweb";      # get program directory from Apache Environment
  require "$BASE/customize.inc"; # load in customization info
  require "$BASE/functions.php"; # load in library of functions
  require "$BASE/dbopen.inc";    # connect to database
  require "$BASE/language.php";  # multilingual support

  print "<html>\n";
  print "<head>\n";
  print "<title>\n";

  $combinednums = findnums($term,$srs);
  echo "$combinednums ";
  print "$_OTHERSHOWCLASSROSTER</title>\n";
  print "</head>\n";
  print "<body bgcolor=\"#FFFFFF\" leftmargin=\"0\" topmargin=\"0\" ";
  print "marginwidth=\"0\" marginheight=\"0\">\n";
  # location of classweb banner
  include "$BASE/phpadmin/adminbanner.inc";
  print "<font face=\"Arial,Helvetica\" color=\"#FFFFFF\" size=\"6\">$_OTHERADVANCEDEDIT_CAP</font>\n";
  print "</td>\n</tr>\n</table>\n";
  print "<p align=\"center\"><font color=red>$_NOTIFYREGISTRAR_INCORRECTEMAIL</font></p>";

  # check if this class is cross-listed
  $n = 1;
  $query=query("select * from REGxref where srs='$srs' && term='$term'");
  while($row = walk($query)){
    if($row[2]){   # if xsrs exists
      if($test == 1){
        print "<h3>$srs $_IS_CROSSREF $row[2]</h3>\n";
      }
      $cross_srs[$n++] = $row[2];  # add xsrs to this array
    }
  }

  ## collect rosters for crosslisted classes
  $j = 0;
  for($i = 1; $i < $n; $i++){
    $query = query ("select * from REGrosters where srs='$cross_srs[$i]' && term='$term'");
    $count[$i] = 0;
    while(($row = walk($query))){
      if(!$roster[$i][$row[4]]) {
        $j = 0;
      }

      $theuid[$i][$row[4]][$j] = $row[2];
      
      $row[4] = $row[4];
      # grabbing middle name as well, dropping suffix though
      $roster[$i][$row[4]][$j] = $row[5] . " " 
      . $row[6];
  
      if($row[8] == 'H') {
        $enrollment[$i][$row[4]][$j] = "$_RECORDHOLD";
      } else if($row[8] == 'E') {
        $enrollment[$i][$row[4]][$j] = "$_ENROLLED";
      } else if($row[8] == 'W'){
        $enrollment[$i][$row[4]][$j] = "$_WAITLISTED";
      } else {
        $enrollment[$i][$row[4]][$j] = "$_NA";
      }
  
      if($row[3]){
        $email[$i][$row[4]][$j] = strtolower($row[3]);
      } else if($spreadsheet != 1) {
        $email[$i][$row[4]][$j] = "&nbsp;"; 
      }

      $count[$i]++;
      $j++;
    }

    if($test == 1 && $count[$i] == 0){
      print "<h3>$cross_srs[$i] $_HASNOSTUDTS!</h3>\n";
    }

    # some classes are cross-listed outside of the social sciences, in which
    # case we won't be able to get the class roster
    if($count[$i] == 0){
      $roster[$i]["Unable to get class roster"] = "$_CLASS_CROSSLISTED.";
      $enrollment[$i]["Unable to get class roster"] = "&nbsp;";
      $email[$i]["Unable to get class roster"] = "&nbsp;";
      $query = query ("select xdept,xcoursenum from REGxref where xsrs='$cross_srs[$i]' && term='$term'");
      $row = walk($query);
      if($row[0]){
        $classtitles[$i] = "$row[0] $row[1]";
      } else {
        $classtitles[$i] = "$_UNKNOWNCLASS";
      } 
    } else {
      $query = query ("select dept,coursenum,activity,section from REGclasses where srs='$cross_srs[$i]' && term='$term'");
      $ct = walk($query);
      if($ct[0] && $ct[1]){
        $classtitles[$i] = "$ct[0] $ct[1] $ct[2] $ct[3]";
      } else {
        $query = query ("select xdept,xcoursenum from REGxref where xsrs='$cross_srs[$i]' && term='$term'");
        $row = walk($query);
        if($row[0]){
          $classtitles[$i] = "$row[0] $row[1]";
        } else {
          $classtitles[$i] = "$_UNKNOWNCLASS";
        } 
      }
    }
  } 

  ## collect roster for non-crosslisted class
  $query = query ("select * from REGrosters where srs='$srs' && term='$term'");
  $count[0] = 0;   # mike changed to stop undercounting
  $i = 0;
  while(($row = walk($query))){
    if(!$roster[0][$row[4]]) {
      $i = 0;
    } else {
      while($roster[0][$row[4]][$i]){
	$i++;
      }
    }
    $roster[0][$row[4]][$i] = $row[5] . " " . $row[6];
    if($row[8] == 'H') {
      $enrollment[0][$row[4]][$i] = "$_RECORDHOLD";
    } else if($row[8] == 'E') {
      $enrollment[0][$row[4]][$i] = "$_ENROLLED";
    } else if($row[8] == 'W'){
      $enrollment[0][$row[4]][$i] = "$_WAITLISTED";
    } else if($row[8] == 'D'){
      $enrollment[0][$row[4]][$i] = "$_DROPPED";
    } else {
      $enrollment[0][$row[4]][$i] = "$_NA";
    }

    $theuid[0][$row[4]][$i] = $row[2];
    #print "$row[0],$row[1],$row[2],$row[3],$row[4],$row[5],$row[6],$row[7],$row[8],$row[9],<P>";

    if($row[3]){
      $email[0][$row[4]][$i] = strtolower($row[3]);
    } else if($spreadsheet != 1) {
      $email[0][$row[4]][$i] = "&nbsp;"; 
    }
    $count[0]++;
    $i++;
  }

  if($test == 1 && $count[0] == 0){
    print "<h3>$srs ($_THEMAINCLASS) $_HASNOSTUDTS!</h3>\n";
  }

  $query = query ("select dept,coursenum,activity,section from REGclasses where srs='$srs' && term='$term'");
  $ct = walk($query);
  if($ct[0]){
    $classtitles[0] = "$ct[0] $ct[1] $ct[2] $ct[3]";
  } else { 
    $classtitles[0] = "$_UNKNOWNCLASS";
  }

  # if the main class has no students then we must be accessing a quarter
  # later than the current one.

  print "<!-- main table [$n rosters] -->\n";
  print "<table align=center>\n";

  for($i = 0; $i < $n; $i++){
    if(($i % 2) == 0){
      print "<tr valign=\"top\">\n";
    }
    print "<td>\n<!-- for roster #$i -->\n<table border>\n";
    print "<caption>$_CLASSROSTERFOR $classtitles[$i] [$count[$i] $_STUDENT_SING_OR_PLUR]<caption>\n<tr>";

    # if the class has a zero-length roster handle it gracefully 
    if($count[$i] == 0){
      print "<tr><td><i>$_NOSTUDTSIN $classtitles[$i]</i></td></tr></table>\n";
      continue;
    }

    print "<th bgcolor=yellow>$_UID</th><th bgcolor=yellow>$_NAME</th><th bgcolor=yellow>$_EMAIL_ADDRESS</th><th bgcolor=yellow>$_ENROLLMENTSTATUS</tr>\n";

    $buffer = "";
    ksort($roster[$i]);
    for(reset($roster[$i]); $key = key($roster[$i]); next($roster[$i])) {
      for($j = 0; $roster[$i][$key][$j];$j++){
        $bgcolor = "";
        if(strcmp($enrollment[$i][$key][$j], "$_RECORDHOLD") == 0){
          $bgcolor = "bgcolor=\"#FF5555\"";
        } else if(strcmp($enrollment[$i][$key][$j], "$_WAITLISTED") == 0){
          $bgcolor = "bgcolor=\"#CCCCFF\"";
        } else if(strcmp($enrollment[$i][$key][$j], "$_DROPPED") == 0){
          $bgcolor = "bgcolor=\"#FF5555\"";
        }
        print "<tr $bgcolor><td>".$theuid[$i][$key][$j]."</td><td>$key, ".$roster[$i][$key][$j]."</td><td>";
        print $email[$i][$key][$j] . "</td><td>".$enrollment[$i][$key][$j]."</td></tr>\n";
      }
    }

    print "</table>\n<!-- end table #$i -->\n</td>\n";
  }  

  print "</tr>\n<!-- end main table -->\n</table>\n";
  include("$BASE/phpadmin/admin_footer.inc");
?>
