<?
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: linkpage.php
# Usage: called from web
# Update: 08-23-02 Jerome - replaced text with variables for multilingual
# Update: 9-1-1999 Adam Kaplan - added new database driven display capability
#                    with include file
# Status: testing
# Purpose: to display class links from MySQL database

# initialize global variables, load functions and connect to database
  $BASE="/home/classweb";      # get program directory from Apache Environment
  require "$BASE/customize.inc"; # load in customization info
  require "$BASE/functions.php"; # load in library of functions
  require "$BASE/dbopen.inc";    # connect to database
  require "$BASE/language.php";  # multilingual support

  $mode = getcurrentlinkmode($term,$srs,"class");
  $base = "$BASE/prof/models";
  $linksdir = "$BASE/links";

  list ($announce, $linkpage, $wwwboard) = findlinks(".",$announce, $linkpage, $wwwboard);
 
  # get term and srs from input and below is given as default
  if (!$term) { $term = '98F'; }
  if (!$srs) { $srs = '104341200'; }

  # name tables in classweb DB
  $classes = "REGclasses";
  $meetings = "REGmeetings";
  $regprofs = "REGprof";
?>

<?
# determine if called from directory or classweb/models
  $termsrs = callmethod($term, $srs);
?>

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>
<head>
<title>
<?
  $class = write_classinfo ($term, $srs, "$_LISTOFLINKS");
?>
</title>
</head>

<!-- <body bgcolor="#FFFFFF" vlink="#000066">-->
<?
if ($body && file_exists($body)) {
  include ("$body");
} else {
  echo '<body bgcolor="#FFFFFF">';

}
?>

<center>
<!-- title table of the course -->
<?
if ("$transparent"){
  echo '<table border="0" cellpadding="0" cellspacing="0" width="100%">';
} else { 
  echo '<table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="',$SCHOOL_COLOR1,'">';
}
?>
  <tr>
    <!-- left banner -->
<?
if ($transparent) {
    echo '<td align="right" valign="top" width="75"></td>';
} else {
    echo '<td align="right" valign="top" bgcolor="#000066" width="75"><a href="',$LOGO_URL,'"><img src="',$LOGO,'" alt="',$_LOGO_ALT,'" border="0" WIDTH="',$LOGO_WIDTH,'" HEIGHT="',$LOGO_HEIGHT,'"></a>';
    echo "<br><font face=\"Arial,Helvetica\" color=\"$SCHOOL_COLOR2\" size=\"4\">$_LOGO_TITLE</font></td>";

}
?>
    <!-- course title -->
<?
if ($transparent && !$head_bg) {
  echo '<td valign="top" align="center" width="100%">';
} else {
  if (!$head_bg) {
    $head_bg = 'bgcolor="'.$SCHOOL_COLOR1.'"';
  }    
  echo '<td '.$head_bg.' valign="top" align="center" width="100%">';
}
list($allsrs,$numxref, $qxref) = write_allsrsinfo($term, $srs, $class,"List of Links"); 

?>
    </b></font>
    <br>
</td></tr></table>

<!-- course menu -->
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <!-- Help -->
<?
if ($transparent) {
    echo '<td align="center">';
} else {
    echo '<td align="center" bgcolor="',$SCHOOL_COLOR2,'">';
}
?>
      <a href="<?echo"$ENTRY";?>/help/linkpage_help.php"><font face="Arial,Helvetica"><strong><? echo $_HELP; ?></strong>
    </font></a></td>

    <!--Main Page -->
<?
if ($transparent) {
    echo '<td align="center">';
} else {
    echo '<td align="center" bgcolor="',$SCHOOL_COLOR2,'">';
}
?>
    <a href="index.php<? echo "$termsrs"; ?>"><font face="Arial,Helvetica"><strong><? echo $_MAINPAGE; ?></strong>         
	 </font></a></td>
<?
if($announce) {
?>
    <!--Announcements-->
<?
if ($transparent) {
    echo '<td align="center">';
} else {
  echo '<td align="center" bgcolor="',$SCHOOL_COLOR2,'">';
}
?>
    <a href="announce.php<? echo "$termsrs"; ?>"><font face="Arial,Helvetica"><strong>
<?
     # get file (announce.inc) last modified date
     # echo gmdate("M d", filemtime("announce.inc")); # fixed 7/16/99 Adam
     date_check("announce.inc", $install_date);
?>
     <? echo $_ANNOUNCEMENTS; ?></strong></font></a></td>
<? } ?>
<?
if($wwwboard) {
?> 
    <!-- Discussion Board -->
<?
if ($transparent) {
  echo '<td align="center">';
} else {
  echo '<td align="center" bgcolor="',$SCHOOL_COLOR2,'">';
}
?>
      <a href="wwwboard/<? echo "$termsrs"; ?>"><font face="Arial,Helvetica"><strong><? echo $_DISCUSSIONBOARD; ?></strong>
    </font></a></td>
<? } ?>
  </tr>
</table>

<TABLE border=0 width=100%>
<TR valign=top>
<TD width=33%>
<CENTER><H2><? echo $_CLASSLINKS; ?></H2></CENTER>
<?
  if ($mode == 1) {
    write_recursivelinks('',$term,$srs,'class');
  } #endif
?>
</TD>
<TD width=33%>
<?
  linkfinish($class, $qxref, $numxref, $linksdir);
?>  
</TD>
<TD width=33%>
<? include("$linksdir/division.htm"); ?>
</TD>
</TR>
</TABLE>
<?
  # display lists of all courses in Social Science taught in current quarter
  echo "<a href=\"$ENTRY/feedback_classweb.php\">$_CLASSWEB_FEEDBACK</a> /";
  echo "<a href=\"http://$SERVER_NAME$ENTRY/classlist.php?term=$term\"> $term $_CLASSWEBSITES</a> /";
?> 


<!-- <a href="<?echo"$DEPT_URL";?>"><?echo"$DEPT_NAME";?></a> /  -->
<!-- <a href="<?echo"$DIVISION_URL"?>"><?echo"$DIVISION_NAME";?></a> / -->
<a href="<?echo"$SCHOOL_URL";?>"><?echo"$SCHOOL_NAME";?></a><BR>
<?#<a href="/classes/ta/">ClassWeb for TAs</a> /?>
<a href="admin/"><? echo $_ADMINISTRATION; ?></a> /
<a href="admin/?type=links"><? echo $_LISTOFLINKS_PAGEEDIT; ?></a>
</font></p>
<!-- closing -->
<p align="center"><font size="1" face="Arial,Helvetica">
<? echo $_UPDATED; ?>
<?
      # last modified date  added by kenny 8-14-00
$query = query("select updated from links where term='$term' && srs='$srs' order by updated desc");
$array = walk($query);
$stored = timestamptodate($array[updated]);  
echo "$stored";
?>
</font></p>

</body>
</html>



