####################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: require.pm
# Usage: "required" by scripts when ran
# Update: 08-30-00 mike - removed admin.pm as it's obsolete
# Update 04-20-00 kenny: documenting
# Status: production
# Purpose: This central script lists all the admin function modules and new ones can be added here, to immediately be available to all classes. If one of these doesn't compile, however, none of the rest will work.

## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
$BASE = "/home/classweb"; # main classweb programs directory
require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here

# ----------------------------------------
# sub: includephpvars
# purpose: to include vars from a PHP file
# ----------------------------------------
require 'includephpvars.pm';

# --------------------------------------------
# sub: announce, areplace,
#      ainsert (used by rostermail.pl) 
# purpose: to edit Classweb announcements only
# --------------------------------------------
require 'announce.pm';

# -------------------------------------------------
# sub: linkpage, lreplace
# purpose: to edit Classweb list of links page with
#          in-place file-locking using flock and
#          reading file into an array
# -------------------------------------------------
# require 'linkpage.pm';

# ------------------------------------------------
# sub: upload, GetInput, Process_File, 
#      Exit_Not_A_Netscape_User, Exit_File_Exist
# purpose: uploads file and adds to homepage table
# ------------------------------------------------ 
require 'upload.pm';

# ------------------------------------
# sub: link
# purpose: adds link to homepage table
# ------------------------------------
require 'linkupload.pm';

#--------------------------------------
# sub: Place_link
# purpose: gets var link-name and tries 
#   to place it on the web page
#--------------------------------------
require 'placelink.pm';

#-------------------------------------
# sub: Redirect_User
# purpose: redirects user to given url
#-------------------------------------
require 'redirect.pm';

#----------------------------------------
# sub: error_message
# purpose: displays an error page/message
#----------------------------------------
require 'error_message.pm';

#-------------------------------------------
# sub: menudelete, show_link, put_link
# purpose: deletes links from home page menu
#-------------------------------------------
require 'linkdel.pm';

#------------------------------------------------------
# sub: password, enter_admin_pass, enter_wwwboard_pass,
#      change_pass, setwwwboardpass, set_private_pass
# purpose: module to change password on admin directory
#------------------------------------------------------
require 'password.pm';

#----------------------------------------
# sub: make_quiz, done_things
# purpose: multiple choice quiz generator
#----------------------------------------
require 'makequiz.pm'; 

#---------------------
# sub: list_files
# purpose: lists files
#---------------------
require 'list_files.pm'; 

#------------------------------------------------------
# sub: create_private, startpage, create_dir
# purpose: creates a private subdir for a classweb site
#------------------------------------------------------
require 'create_private.pm'; 

# ------------------------------------
# sub: fedit, getfiles, mainscreen,
#      editscreen, savefile, copyfile,
#      deletefile, deleteconfirm,
#      killfile, followupD, followupC,
#      readonlywarn
# purpose: file edit/copy/delete util.
# ------------------------------------ 
require 'fedit.pm';

# ------------------------------------
# sub: gradeedit, getfiles, mainscreen,
#      editscreen, savefile, copyfile,
#      deletefile, deleteconfirm,
#      killfile, followupD, followupC,
#      readonlywarn
# purpose: file edit/copy/delete util.
# ------------------------------------ 
require 'gradeedit.pm';

#--------------------------------------------------------
# sub: board_filter, display_filters, add_filters
# purpose: creates and edits filter file for the wwwboard
#--------------------------------------------------------
require 'board_filter.pm';

#-------------------------------------------------------
# sub: create_popup, pop_start, pop_create, pop_edit
# purpose: creates links to pages w/ instructor comments
#          which "pop up" when redirected to pages
#-------------------------------------------------------
require 'create_popup.pm';

#--------------------------------------------------
# sub: addboard, setup, write_page, error, template
# purpose: sets up classweb discussion board
#--------------------------------------------------
require 'addboard.pm';

#----------------------------------------------
# sub: authen_installer
# purpose: installs/toggles authentication in a
#          given board directory
#---------------------------------------------- 
require 'authen_installer.pm';

#-------------------------------------
# sub: grades
# purpose: allows profs to post grades
#-------------------------------------
# require 'grades.pm'; 
