#!/usr/local/bin/perl -w
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
####################################################################
# Name: rmadmin.pl
# Usage: command-line: "%rmadmin.pl <term> <srs> <uid>"
#        phpusage: "system("rmadmin.pl $term $srs $uid WWW");"
#
# Update 08-28-00 kenny: replaced hard refs with customized vars
# Update 01-15-99 jason: created
#
# Steps:
# 1) Remove the user from the addadmin table.
# 2) Remove uid from /info-data/security/<term>.group file for $srs.
#
# Status: production
# Purpose: backend for revoking admin privledges


## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
$BASE = "/home/classweb"; # main classweb programs directory

require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here
require "$BASE/dbopen.pl";
require "$BASE/dbfuncs.pm";

local($dir, @lines, $line, $found, $class, *FILE);
local($term, $srs, $uid, $mode) = @ARGV;
$mode = "" if(!defined($mode));

if(!$mode){
	print "term --> $term\n";
	print "srs--> $srs\n";
	print "uid--> $uid\n";
}

if(!($term && $srs && $uid)){
	if(!$mode){ #called from the command-line
		print STDERR "Wrong number of args! Exiting ...\n";
	}

	exit(1);	
}

$q = "select term from addadmin where term='$term' && srs='$srs' && uid='$uid'";
@data = &dbquery($dbh, $q);

## Step (1)
if(@data){
  #delete the db entry
  $q = "delete from addadmin where term='$term' && srs='$srs' && uid='$uid'";
  &dbquery($dbh, $q);
} else {
  if(!$mode){
    print "$uid is not in the database for $term $srs!\n";
  }
  exit(2); # bad user
}

$q = "select url from REGclasses where term='$term' && srs='$srs'";
@data = &dbquery($dbh, $q);
if(@data){
  $data[0] =~ /$SERVER_NAME$ENTRY\/$term\/(.*)\/$/;
  $dir = $1;
} else {
  if(!$mode){
    print "Couldn't find url for $term $srs!\n";
  }
  exit(3); # no/bad url
}

## Step (2)
if(open(FILE, "$PASSDIR/$term.group")){
  @lines = <FILE>;
  close(FILE);
  $found = 0;
  foreach $line (@lines){
    next unless($line =~ /^$dir:/);
    ($class, $uids) = split(/:/, $line);
    last unless($uids =~ /$uid /);
    $uids =~ s/$uid //;
    $line = "$class:$uids";
    $found = 1;
    last;
  }
  if($found){
    if(open(FILE,">$PASSDIR/$term.group")){
      print FILE @lines;
      close(FILE);
    } else {
      if(!$mode){
        print "Can't open $PASSDIR/$term.group for writing!\n";
      }
      exit(3);
    }
  }
} else {
  if(!$mode){
    print "Couldn't open $PASSDIR/$term.group for reading!\n";
  }
  exit(3); 
}
exit(0);
__END__
