#!/usr/local/bin/perl
##############################################################################
# statsdb.pl  - scans websites and updates stats mysql table
#             - stats web pages produced by another page, stats.php
# usage: statsdb.pl

#  NEED: check if null values are going in for History announce, menu, etc.
#        They should be.

# Update: 08-10-00 kenny - removed hardcoded vars; adapted for opensource
# Update: 1-27-2000 Mike fixed overcount of links. Now doesn't include headers
# Also, dropped limit to only class site for links, now includes TA sites.
#  10-12-99 - Gavin fixed for Bug 154
#  9-8-99  - Adam adds functionality for links in the database
#  1-29-99 - need to watch for other words with Syllabus to see what 
#            we're missing
#  1-25-99 - mike - adding counts of Previous, Preliminary and Archive
#          - moved $syllabus="No" into while loop from above
# 12-02-98 - mike changed history check to go on $dir instead of $dept so 
#            that crosslisted classes based in hist would work as well
# 11-30-98 - added new check for history syllabi
# 10-23-98 - Mike added ignore of Syllabus Archive in Econ websites
#  9-27-98 - Mike added check for History syllabi. 
#  9-26-98 - Mike moved it to /info-data/classweb3 and removed prints
#  9-25-98 - Artin finished it up and got it working
#  9-24-98 - Mike - continuing Artin's work on making this save to database
#  NEED: to use Jason's collection of wwwboard sites, to find out if > 1
#  PROBLEM: Will have problem if URL is an alias for class directory
#     Like: /De_Indis/

# has to be run as nobody because index.htm's aren't universal readable so it
# will usually be invoked from web page link /classes/fall97/listcheck.htm

# Sample Line from Class Lists
#<TR><TD><!--Aerospace-Z--><a href="http://www.sscnet.ucla.edu/classes/fall97/aerospacez/">Aerospace Z</A></TD><TD>Kimel A. Kimble</TD><TD><EM>Leadership Lab</EM></TD></TR>

# if statsdb.pl is run from a cronjob or the command line
# following code is necessary to determine the BASE prog. dir
unless ($BASE) { # If $BASE doesn't exist, use calling path or current directory
  use File::Basename;
  $BASE = dirname($0); # set $BASE to this program's calling path
  unless ($BASE) {
    # for programs called from this directory via telnet command with . on path
    $BASE=".";  # set to current directory if it still doesn't exist
  }
}

require "$BASE/customize.pl";  # important vars set here
require "$BASE/dbvars.pl";     # database vars set here
require("$BASE/dbopen.pl");
require "$BASE/placelink.pm";

$base = $DOCUMENT_ROOT;

#$TERM = $quarter = $ARGV[0];
$gquery = "select term from current2";
$gqh = $dbh->prepare($gquery) or &error("Can't prepare $gquery: $dbh->errstr\n");
$rv = $gqh->execute or &error("can't execute the query: $gqh->errstr\n");
while(($term) = $gqh->fetchrow_array) {
  $TERM = $quarter = $term;
  
  %menudefaults = ("Announcements","1","List of Links","1",
  	 "Discussion Board","1","Syllabus","1");
  # quick way to keep track of what we're getting
  open(SYLLABI,">$BASE/statsdb$TERM.syllabi") || &error("Couldn't open statsdb$TERM.syllabi");
  #######################################################
  
  #  Use same query as classlist.php/valid.php
  
  #$statement = "select REGurl.term,REGurl.srs,url,dept,coursenum,section,status from REGclasses,REGurl where REGclasses.term='$TERM' && status <> 'Cancelled' && REGclasses.term=REGurl.term && REGclasses.srs=REGurl.srs ";
  $statement = "select term,srs,url,dept,coursenum,section,status from REGclasses where term='$TERM' && status <> 'Cancelled'";
  #print $statement;
  $sth = $dbh->prepare($statement) or &error("Can't prepare $statement: $dbh->errstr\n");
  $rv = $sth->execute or &error("can't execute the query: $sth->errstr\n");
  #Is this same as check just above?
  unless ($sth) { &error("Nothing in sth. $DBI::errstr\n");}
  
  $nr_of_fields = $sth->{NUM_OF_FIELDS};
  #print "Number of Fields Returned: $nr_of_fields\n";
  
  #$syllabus = "No";   # default is syllabus doesn't exist
  
  # $cnt = 0;
  
  while(($term,$srs,$url,$dept,$coursenum,$sect,$status) = $sth->fetchrow_array) {
    #print qw($row[0]\t$row[1]\t$row[2]\n); 
  
  $syllabus = "No";   # default is syllabus doesn't exist
  
  
  # these will change to 0 in ClassWeb sites
  #$linkcnt = $announcecnt = $menucnt = "0";
  #$linkcnt = $announcecnt = $menucnt = "";  # need these nulled out for History
  #$linkcnt = $announcecnt = $menucnt = "\N";  # need these nulled out for History
  $linkcnt = $announcecnt = $menucnt = "NULL"; # need these nulled out for History
  
  # change this to retrieve fields from query
  #($dept,$num,$title,$prof,$srs,$term,$act,$sect,$days,$start,$stop,$bldg,$room,$rest,$enroll,$enrollcap,$waitinglist,$wlcap,$status,$url) = split(/~/);
  
  # $num =~ s/\s*$//g;
  # ($dept) = ($num =~ /(^\S+)\s/);
  
  #  Y2K compliant, handles, /98F, 99W, 00S terms 
  # if ($url =~ m#www.sscnet.ucla.edu/((0|9).*)/#i) {  ### ClassWeb site
    if ($url =~ m#$SERVER_NAME$CLASSES/((0|9).*)/#i) {  ### ClassWeb site
      # Gavin fixed for BUG 154
      ($dir) = ($url=~m#$SERVER_NAME/(.*)#);
        #check too see if the last character is a "/"; if it is, delete it
        if ($dir =~ /\/$/) {
          chop($dir);
        }
      # end of Gavin fix for BUG 154
  
  #########################
  # Check Announcements
      open(ANNOUNCE,"<$base/$dir/announce.inc") || &error("Couldn't open $base/%$dir%/announce.inc");
  #   print "$base/$dir\n";
      $announce_zone = 0;
      $announcecnt = 0;
      while(<ANNOUNCE>) {
  #     $announce_zone = 1 if (/<ul>/i);
  #     $announce_zone = 0 if (/<\/ul>/i);
        $announce_zone = 1 if (/<[UO]L>/i);  # <UL> or <OL> is start of list 
        $announce_zone = 0 if (/<\/[UO]L>/i);  #  </UL> or </OL> is end of list
  # count all announcements <LI> that aren't No announcements at this time.
        if ($announce_zone && /<li>(.*)/i) { 
  #       $announcecnt++ unless $1 =~ /No announcements at this time/; 
  #       $announcecnt++ unless $1 =~ /There are no announcements yet/; 
          $announcecnt++ unless $1 =~ /There are no announcements/; 
        }
      }
      close(ANNOUNCE);
  
  #########################
  # Check List of Links Page
  
      # 9-8-99 Adam Kaplan:
      # this works as long as the stats page doesn't account for TA entries
      #      in the links table
      # Noted: REGurl only contains main "class" pages
   
      # notice that this gets TOTAL number of links in BOTH database and file
  
  #   open(LINKS,"<$base/$dir/linkpage.inc") || &error("Couldn't open $base/$dir/linkpage.inc");
      $link_zone = 0;
      $linkcnt = 0;
      while(<LINKS>) {
  #     $link_zone = 1 if (/<H2>Class Links<\/H2>/i);
  #     $link_zone = 0 if (/<\/ul>/i);
        $link_zone = 1 if (/<[UO]L>/i);   # <UL> or <OL> is start of list 
        $link_zone = 0 if (/<\/[UO]L>/i);  #  </UL> or </OL> is end of list
  # count all links <LI>, there are no Class defaults
        $linkcnt++ if ($link_zone && /<li>/i); 
      }
  #   close(LINKS);
  
  # this was overcounting, drop headers (e.g. have no url entry)
  #   $linkcmd = "select * from links where term = '$term' && srs = '$srs' && site = 'class'";
      $linkcmd = "select * from links where term = '$term' && srs = '$srs' && url <> ''";
      $linksth = $dbh->prepare($linkcmd) || die "Couldn't prepare $linkcmd\n";
      $linksth->execute || die "Couldn't execute $linkcmd\n";
      $linkcnt += $linksth->rows;  
                  
  
  #########################
  # Check Home Page
  #
  #
  #    fixes econ coursemenu files
  #    if ($dir=~/econ/i) {
  #      undef $/;
  #      open (CLEANUP,"<$base/$dir/coursemenu.inc");
  #      open (BACKUP,">$base/$dir/coursemenu.bak2");
  #      $cleanup=<CLEANUP>;
  #      print BACKUP $cleanup;
  #      close(BACKUP);
  #      $cleanup=~s/\x0d//sig; 
  #      $cleanup=~s/Syllabus\s*Archive/Syllabus Archive/sig; 
  #      close(CLEANUP);
  #      open (CLEANUP,">$base/$dir/coursemenu.inc");
  #      print CLEANUP $cleanup;
  #      close(CLEANUP);
  #      $/="\n";
  #    }
      open(CLASS,"<$base/$dir/coursemenu.inc") || &error("Couldn't open $base/$dir/coursemenu.inc");
  
      $num2   = "";
      $menu_zone = 0;
      $menucnt = 0;
      $enroll = 0;
      while(<CLASS>) {
        $menu_zone = 1 if (/<!--menustart/);
        $menu_zone = 0 if (/<!--menuend-->/);
  # count ALL menu items that have href
        $menucnt++ if ($menu_zone && /<a href=/i); 
  
        # syllabus check, either "syllabus" or "course outline" equals yes 
        if ($dir=~/hist/i){   # handles crosslisted with history as well
          if (-s "$base/$dir/syllabus.html"){
            $syllabus="YesS";   #  Short for Yes, as determined by site Scan
          }
	} elsif (/(Pre-Enroll)/) {      # enroll check
	  $enroll=1;
        } else {
          if (/(syllabus|course outline)/i) {      # syllabus check
            $saveline = $_;
            $saveline =~ s/^\s*//;
            $saveline =~ s/<font face="Arial,Helvetica">//;
            $saveline =~ s/<strong>//;
            $saveline =~ s#</strong></font></A></TD>##;
            $saveline =~ s#<A HREF="[\w\.]*?">##;  # remove URLs
            $stats{"$saveline"}++;
  # quick kluge to track Syllabus text
            print SYLLABI "$dir $saveline" if ($saveline);  
            if (/Syllabus Archive/i) {
              $syllabus="Archive"; 
            } elsif (/Previous Syllabus/i) {
              $syllabus="YesPrev"; 
            } elsif (/Preliminary Syllabus/i) {
              $syllabus="YesPrelim"; 
            } else {
              $syllabus="YesS";   #  Short for Yes, as determined by site Scan
            }
          }
        }
      }
      close(CLASS);
      
      # if enroll link isn't in menu, check DB to see if it should be
      if (!$enroll){
	$statement=("select profcode,uid from REGprof where term='$TERM' && srs='$srs' && profcode='4'");
	$sthstat = $dbh->prepare($statement) || &error("Can't prepare $statement: $dbh->errstr\n");
	$rv = $sthstat->execute or &error("can't execute the query: $sthstat->errstr\n");
	if (@row = $sthstat->fetchrow_array){
	  ($profcode,$uid) = @row;
	  #print "$dir has $profcode,$uid\n";
	  $basedir = "$base/$dir";
	  &Place_link("pre-enroll.php","Pre-Enroll");
	}
      }
        
    } elsif ($url =~ m#http://$SERVER_NAME/(.*)/#i) {   # our server
    } else { # external server
    }  # end of if classweb site
   
  # Check if stats record exists for this term & srs
     
    $statement=("select * from stats where term='$TERM' && srs='$srs'");
  # $sthstat = $dbstat->prepare($statement) || &error("Can't prepare $statement: $dbh->errstr\n");
    $sthstat = $dbh->prepare($statement) || &error("Can't prepare $statement: $dbh->errstr\n");
    $rv = $sthstat->execute or &error("can't execute the query: $sthstat->errstr\n");
  #Is this same as check just above?
    unless ($sthstat) { &error("Nothing in sth. $DBI::errstr\n");}
  
    $nr_of_statfields = $sthstat->{NUM_OF_FIELDS};
    # print "STATS: Number of Fields Returned: $nr_of_statfields\n";
    $menucnt=0 if ($menucnt =~ /--/);
    $announcecnt=0 if ($announcecnt =~/--/);
    $linkcnt=0 if ($linkcnt=~/--/);
    if (@row = $sthstat->fetchrow_array) { 
    # Yes record, so update selected fields with UPDATE statement.
      ($xterm,$xsrs,$xsyllabus,$xhits,$xmenu,$xannounce,$xlinks) = @row;
  #   print "STATS: $xterm $xsrs $xsyllabus $xhits $xmenu $xannounce $xlinks\n";
      # Use UPDATE command, but first check whether syllabus can be overwritten
      if ($xsyllabus =~ /(YesU|YesH)/i) { # don't overwrite
        $syllabus=$xsyllabus;  # don't overwrite if Handchecked or Upload YES
      } elsif (($xsyllabus =~ /Refuse/i) && $syllabus eq "No") { # 
        $syllabus=$xsyllabus;  # don't overwrite Refused with No, OK otherwise
      }
  #   print "STATS: records found.\n";
  #   $updatestats="update stats set menu='$menucnt',announce='$announcecnt',links='$linkcnt',syllabus='$syllabus' where term='$TERM' and srs='$srs'";
  # removing quotes from menucnt, $announcecnt & $linkcnt because they'll either
  #  be NULL or a number. TESTING
      $updatestats="update stats set menu=$menucnt,announce=$announcecnt,links=$linkcnt,syllabus='$syllabus' where term='$TERM' and srs='$srs'";
    } else { # No records found
      $updatestats=" replace into stats (term,srs,syllabus,menu,announce,links) values ('$TERM','$srs','$syllabus',$menucnt,$announcecnt,$linkcnt) "; 
  #   print "STATS: No records found.\n";
    }
  # run command for either statement
    $ststat = $dbh->prepare($updatestats) or &error("Can't prepare $updatestats: $dbh->errstr\n");
  
    $rv = $ststat->execute or &error("can't execute the query $updatestats : $ststat->errstr\n");
    $syllabus = "No";
  } # end of query loop
  
  close(SYLLABI);
  
  open(STATS,">$BASE/statsdb$TERM.sylstats") || &error("Couldn't open statsdb$TERM.sylstats");
  foreach $key (sort(keys(%stats))) {
    print STATS "$key = $stats{$key}\n";
  }
  
  close(STATS);
  
  # The following line, should create 0 byte files with the time this routine 
  # last ran.
  system("touch $BASE/statsdb$TERM.ran");
}

##########################################################
# Name: error
# Usage: &error($message);
# Update: 7/19/1999 Adam Kaplan - created
# Status: writing
# Purpose: die with error and notify contact

sub error {
  my($message) = @_;
  my $contact = $EMAIL_OF_CLASSWEB_ADMIN;
  open (MAIL, "$SEND_MAIL_CMD");
  print MAIL "To: $contact\n";
  print MAIL "From: $DEFAULT_SENDER\n";
  print MAIL "Subject: statsdb.pl failure\n\n";
  print MAIL "statsdb.pl failed...here is the error message:\n";
  print MAIL "$message\n\n";
  print MAIL "                          -Nobody";
  close (MAIL);
  die "$message";
} 

