##############################################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: upload.pm 
# Usage: called by file.php via stub 
# Steps: +upload.pm
#          +upload()
#            -GetInput()
#            -Process_File()
#            -Exit_Not_A_Netscape_User()
#            -Exit_File_Exist()
#
#   09-04-02 Jerome - added require for contenttype.inc
#   08-22-02: Nick and Jerome - Substituting out language-dependent text
#     strings with variables to allow multilingual support.
# Update: Artin Rebekale, Mike Franks, Kenny Fong
#   07-31-00 kenny - set/change password utility and necessary script added
#   06-09-00 mike & kenny - editing errors and double checking before production
#   03-13-00 kenny - checks if "Filename to save as on server" contains a "#" char
#              displays error if a "#" exist in filename
#   04-28-99 Adam - throws in functionality to check for a file extension
#   	       error if not there
#   12-07-98 mike - dropped chgrp classweb because it messes up history
#   08-19-98 mike changed to do minimum form for PHP
#   06-05-98 mike changed to allow overwrites everywhere
#   03-24-98 added reset button
#   03-12-98 Artin added file upload to any directory except admin
#   12-08-97 chmod's set to 660 for files and 770 for dirs, group=classweb
#   10-29-97 added check to see if link name is given
#   10-08-97 Artin added test for pswd protected wwwboard directory upload there
#            Mike added default to home directory, and no overwrite allowed
#   10-07-97 added MS Internet Explorer warning and file extension .dl note
#   09-22-97 changed chmod to 666 from 644 on uploaded files, so easier to edit
#   09-19-97 added notice about .htm on end of HTML filenames
#   07-29-97 working with stub.pl
#          - now gives error message about blanks in filenames  
#          - error_message and Place_link subs now in external files
#          - and redirect_user sub in external file
#   03-19-97 Mike subbed $table for ../demo/demo in all file refs for table
#              and added link to class page on Thank You.
#   03-18-97 Mike added error_message subroutine to try and figure out why this
#              doesn't work after moving it out of Artin's directory.
#   03-17-97 Artin got it working 
#              writes to demo.htm in demo directory
#   03-13-97 Artin added Label field
#
# QUESTION: does this script start up in directory it was called from? 
# ANSWER: It starts up from the directory in which it resides.
#
# Status: production
# Purpose: uploads files and adds to homepage table



# based on:
# Syllabus Upload Script        Version 5.01
# Created by Jeff Carnahan  jeffc@terminalp.com
# Created on: 4/8/95        Last Modified on: 02/09/97 12:41 
# Scripts Archive:          http://www.terminalp.com/scripts/
#
# Copyright (C) 1996 - Jeffrey D. Carnahan
#   Copyright Information Can Be found in the attacted README file.
#
# ---------------------------------------------------------------------
# Program Specific Quickie Notes:
#   * Make Sure The First Line Is Pointing To The Correct Location Of Perl 5.
#   * Make Sure This Program is chmodded with the permissions '755'.
#
# ---------------------------------------------------------------------

sub upload {
  ## $BASE is set in Apache Environment with SetEnv and PassEnv in httpd.conf
  $BASE = "/home/classweb"; # main classweb programs directory
  require "$BASE/customize.pl";  # important vars set here  
  require "$BASE/language.pl";  ###Multilingual support

  # addition 4/27/99 Adam Kaplan
  # checks save-as-filename for valid extension
  if ( (param('save-as-filename') !~ /^.+\..+$/ )
    && (param('sub') ) ) {

    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print <<ENDCODE;

<HTML> <HEAD> <TITLE> $_NOFILEEXT_ERROR</TITLE> </HEAD>
<BODY BGCOLOR=#FFFFFF> <font face=arial,helvetica><H1 ALIGN=CENTER> $_ERROR!</H1> 
<P> $_NOFILEEXT_BODY</P>
<p> 
$_NOFILEEXT_SOLUTION
</font>
</BODY></HTML>
ENDCODE
    exit;
  } #end of error message

  # addition 3/13/00 Kenny Fong 
  # checks for '#' symbol in save-as-filename
  if ((param('save-as-filename') =~ /\#/) && (param('sub'))) {
    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print <<ENDCODE;
<HTML> <HEAD> <TITLE> $_POUNDSIGN_ERROR </TITLE> </HEAD>
<BODY BGCOLOR=#FFFFFF> <font face=arial,helvetica><H1 ALIGN=CENTER> $_ERROR! </H1> 
<P> $_POUNDSIGN_BODY</P>
<p> <font color=red>
$_POUNDSIGN_SOLUTION
</font></BODY></HTML>
ENDCODE
    exit;
  } #end of error message

  if (!param('sub')){
    $boardpass='';
    $privatedir='';
    $boardinfo='';
    if($basedir eq ".") {$basedir = ".."}
    if( -d "$basedir/private") { $privatedir='yes'; }
    @dir_files=`ls -1 $basedir`;
    foreach $entry (@dir_files) {
      chop($entry);
      if (-d "$basedir/$entry") {
        @isadir=(@isadir,$entry);
      }
    }
    foreach $isadir (@isadir) {
      @dir_files=`ls -1 $basedir/$isadir`;
      foreach $entry (@dir_files) {
        chop($entry);
        if (-d "$basedir/$isadir/$entry") {
          @moredir=(@moredir,"$isadir/$entry");
        }
      }
    }
    
    
    if( -s "$basedir/wwwboard/.htaccess"){
      open (IN,"<$basedir/wwwboard/.htaccess");
      @boardstuff=<IN>;
      close(IN);
      foreach $whatever (@boardstuff) {
        if ($whatever =~ /Limit Get/ ){
          $boardpass='yes';
        }
      }
    }
    if ($boardpass|$privatedir eq 'yes') {
      $boardinfo="<p>$_CHOOSEDIRTOSAVEIN:<br><input checked type=\"radio\" name=\"whichdir\" value=\"\"> $_CLASSWEBDIR<br> \n";
      $boardinfo=$boardinfo."<input type=\"radio\" name=\"whichdir\" value=\"wwwboard/\">$_DISCUSSBOARDDIR<br>" if ($boardpass);

      # set/change password utility and below script added by kenny 7-31-00
      $username = $ENV{CLASSDIR}; $username =~ s/$ENTRY\///g;
      $username =~ s/admin//g; $username =~ s/\///g;
      $flagger = `grep $username $PASSFILE`; 
      
      if(($flagger =~ /$username/)){
        $boardinfo=$boardinfo."<input type=\"radio\" name=\"whichdir\" value=\"private/\">$_PRIVATEDIR<br><a href=\"./?type=changepw\">$_CHANGEPASSWORD_PRIVATEDIR</a><P>" if ($privatedir);
      } else {
        $boardinfo=$boardinfo."<input type=\"radio\" name=\"whichdir\" value=\"private/\">$_PRIVATEDIR<br><a href=\"./?type=changepw\">$_SETPASSWORD_PRIVATEDIR</a><P>" if ($privatedir);
      }

    }
    if (@isadir) {
      $alternate_dir= "<input type=\"radio\" name=\"whichdir\" value=\"altdir\">$_ALTDIRS: <select name=altdir>\n";
      foreach $isadir (@isadir) {
        if ($isadir=~/admin|wwwboard|private/) {next;}
        $alternate_dir .= "<option>$isadir\n";
      }
      $alternate_dir.="</select>\n";
    }
    if ($alternate_dir!~/<option>/) {$alternate_dir='';}
    if (param('php') == 1) {  # abbreviated form for PHP
      print << "END_OF_PHP";
$boardinfo
<br>
$alternate_dir
END_OF_PHP
    } else {  # normal form
      # print "Content-type: text/html\n\n";
      require "$BASE/contenttype.inc"; # enable charset
      print << "END_OF_HTML";
<html>
<head>
<title>$_SYL_UPLOADUTILITY</title>
</head>
<body bgcolor="#FFFFFF">
<h1><tt><b>$_SYL_UPLOADUTILITY</b></tt>
</h1>$_SYL_UPLOAD_VERSION<br>$_SYL_UPLOAD_DIRECTIONS<font color="#FF0000"><i><B>$_NOTE_UC:</B>
$_SYL_UPLOAD_REQS
</I></font>
<FORM ENCTYPE="multipart/form-data" ACTION="$cgi_url" METHOD=POST>

$_FILENAMEONCOMP: <INPUT NAME="upload-file" TYPE="file" size=50>
<p>
$_FILENAMESAVEDONSERVER: <input name="save-as-filename" size=35>
<B>($_BLANKSNOTALLOWED)</B>
 <font color="#FF0000"><I><B>$_NOTE_UC:</B> $_DOWNLOADONLY_DIRECTIONS</I></font>
$boardinfo
<br>
$alternate_dir
<p>
$_FILELINKEDTOCLASSPAGE<br>
<input checked type="radio" name="addlinkname" value="yes">$_YES<br>
<input type="radio" name="addlinkname" value="no">$_NO<br>
$_GIVENAMEFORLINK:
<input name="link-name" size=35>
<p>
<input type="hidden" value="upload" name="stubsection">
<input type="hidden" value="upload" name="sub">
<INPUT TYPE="submit" VALUE="$_SENDFILE"> 
<INPUT TYPE="reset" VALUE="$_RESET"> 
</FORM>  <hr size=1><center>
</body></html>
END_OF_HTML
    }
  }

if (param('sub') =~ /upload/) {
$userid        = "44";
$groupid       = "72";
$path          =  $basedir;
$url           = $baseurl;
$tablefile     = "index";    # prefix for file with table to update - Mike
$table         = $basedir . "/" . $tablefile;
$overwrite     = "1";      # allow overwriting of files
$success_url   = $url;


#   $userid = 2301;           # --> This Number is the specific ID
                              # --> ID number assigned to you on your
                              # --> Unix System.

#   $groupid = 1000;          # --> This Number is the specific Group
                              # --> ID number assigned to people with
                              # --> your access level on your Unix
                              # --> system.

                              #
                              # --> You can gain your $userid and
                              # --> $groupid by typing 'id' at your
                              # --> UNIX prompt.  (GID = Group Id,
                              # --> UID = User Id).

#   $path = "/usr/www/users/terminal/scripts/upload2";
                              #
                              # --> The $path variable should contain the
                              # --> directory that this script will place
                              # --> uploaded files into.  It should NOT have
                              # --> a trailing forward slash.

#   $url = "http://www.terminalp.com/scripts/upload2";
                              #
                              # --> $url should be the URL which corresponds
                              # --> to the $path defined above.  And same
                              # --> as the $path variable, it SHOULD NOT
                              # --> have a trailing forward slash.

#   $overwrite = 1;           # --> Set this value to '1' to allow
                              # --> overwriting of existing files.
                              # --> Set this value to '0' to dis-allow
                              # --> the overwriting of existing files.
                              # -->
                              # --> NOTE:
                              # -->   Existing files WILL NOT be over-
                              # -->   written unless they are given the
                              # -->   permissions 'a+rw'.  An error message
                              # -->   will return to users who try to over-
                              # -->   write files which are protected.

#   $success_url = "";
                              #
                              # --> This contains the URL people should be
                              # --> redirected to once they have completed
                              # --> a successful upload.  If empty, a page
                              # --> will be generated, which includes
                              # --> statistics.

    $exclusive_lock = 2;      # --> DO NOT CHANGE THIS VALUE - It should
                              # --> be set to '2'

    $unlock_lock = 8;         # --> DO NOT CHANGE THIS VALUE - It should
                              # --> be set to '8'
#}
#
# End of Configurable Options.
# ---------------------------------------------------------------------
# ---------------------------------------------------------------------
# -->           Do Not Change Anything Below This Line.           <-- #
# ---------------------------------------------------------------------
# ---------------------------------------------------------------------

$| = 1;


&GetInput;
&Process_File;
$addlink = param('addlinkname');
if ($addlink eq 'yes') {
  if (!param('link-name')) {&error_message("$_MUSTSUPPLYLINKNAME");}
  if ($boardpass eq 'no') {
    $savedfilename = param('save-as-filename');
  }else{ 
    $savedfilename= "$boardpassdir". param('save-as-filename');
  }
  $link = param('link-name');
  &Place_link($savedfilename,$link); #  external in placelink.pm
  &Redirect_User($baseurl);
  exit;
} else {
  # print "Content-type: text/html\n\n";
  require "$BASE/contenttype.inc"; # enable charset
  $boardpassdir="$boardpassdir" if ($boardpassdir);
  print <<END_OF_HTML_CODE;
<HTML>
<HEAD>
<TITLE>$_THANKYOU</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<H1><TT><B>$_THANKYOU</B></TT></H1><br>
END_OF_HTML_CODE

  print "$_THANKSFORUPLOAD_A $totalbytes $_THANKSFORUPLOAD_B\n";
  print "$_HASBEENSAVED: <a href=\"$url/$boardpassdir$real_name\">$url/$boardpassdir$real_name</a>\n";
  print "$_ORACCESSCLASSPAGE: <a href=\"$url/\">$url/</a>\n";
  print "</BODY></HTML>\n";
  exit;
}


# ---------------------------------------------------------------------

sub GetInput {
    #
    # --> Sub:  &GetInput();
    #
    # --> Return:  
    #
    # --> Summary:
    #              Loads CGI module, assigns $filename the filename the
    #              file should be saved as.
    #

#   if (param('save-as-filename') !~ /^[ \t]*$/) {
    if (param('save-as-filename')) {
        $filename = param('save-as-filename');
    } else {
#       $filename = param('upload-file');
      &error_message("$_FILENAMETOSAVEAS_REQUIRED"); 
    }
    #
    #  END OF SUB
    #
}

# ---------------------------------------------------------------------

sub Process_File {
    #
    # --> Sub:  &Process_File();
    #
    # --> Return:  
    #
    # --> Summary:
    #              Takes all the input, determines if the user is using
    #              the appropiate browser, then extracts the filename,
    #              and saves the file.  Uploaded files are chmodded to 644,
    #              and given ownership to the user defined in $userid and
    #              $groupid.
    #

    &Exit_Not_A_Netscape_User if ($ENV{'HTTP_USER_AGENT'} !~ /^Mozilla\/[432]/);

    if ($filename =~ /[ \t\/]/) { 
      &error_message("$_NO_BLANKSTABSSLASHES"); 
    }

    if ($filename =~ /\//) {
        @array = split(/\//, $filename);
        $real_name = pop(@array);
    } elsif ($filename =~ /\\/) {
        @array = split(/\\/, $filename);
        $real_name = pop(@array);
    } else {
        $real_name = "$filename";
    }

    if (!param('whichdir') ) {
      $outfile = "$basedir" . "/" . "$real_name";
    } else {   # writing to wwwboard directory
      $boardpassdir=param('whichdir') if (param('whichdir') ne 'altdir');
      $boardpassdir=param('altdir') . "/" if (param('whichdir') eq 'altdir');
      $outfile = "$basedir" . "/" . "$boardpassdir" . "$real_name"; 
      # $overwrite = 0;   # turn off overwriting, to protect files
    }
    $filename = param('upload-file');
    &Exit_File_Exists if ((-e "$outfile") && (!$overwrite));

    if (!open(OUTFILE, ">$outfile")) {
        # print "Content-type: text/plain\n\n";
        require "$BASE/contenttype.inc"; # enable charset
        print "-------------------------\n";
        print "$_ERROR:\n";
        print "-------------------------\n";
        print "$_FILE: $outfile\n";
        print "-------------------------\n";
        print "$basedir\n";
        print "$path\n";
        print "$baseurl\n";
        print "$table\n";
        print "$_OUTPUTFILE_ERROR_A $path $_OUTPUTFILE_ERROR_B\n"; 
        print "$_ERROR: $!\n";
        exit;
    }

    while ($bytesread = read($filename,$buffer,1024)) {
        $totalbytes += $bytesread;
        print OUTFILE $buffer;               
    }

    close($filename);
    close(OUTFILE);

    chmod (0660, "$outfile");
#   system "chgrp classweb $outfile";  # mike - should be inherited from dir
    chown ($userid, $groupid, "$outfile");

    #
    #  END OF SUB
    #
}

# ---------------------------------------------------------------------

sub Exit_Not_A_Netscape_User {
    #
    # --> Sub:  &Exit_Not_A_Netscape_User();
    #
    # --> Return:  
    #
    # --> Summary:
    #              This user is not using a version of Netscape claiming
    #              to be above version 2.0...
    #

    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print <<END_OF_HTML_CODE;

<HTML>
<HEAD>
<TITLE>$_ERROR!</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<H1><TT><B>$_ERROR! - $_INVALIDBROWSER</B></TT></H1><br>
$_INVALIDBROWSER_MSG
</BODY>
</HTML>
END_OF_HTML_CODE

    exit;

    #
    #  END OF SUB
    #
}

# ---------------------------------------------------------------------

sub Exit_File_Exists {
    #
    # --> Sub:  &Exit_File_Exists();
    #
    # --> Return:  
    #
    # --> Summary:
    #              This user is trying to upload a file with a filename
    #              that is already in use, and this script is set not to
    #              overwrite existing files.
    #

    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print <<END_OF_HTML_CODE;
<HTML>
<HEAD>
<TITLE>$_ERROR!</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<H1><TT><B>$_ERROR! - $_FILEEXISTS </B></TT></H1><br>
$_FILEEXISTS_MSG
</BODY>
</HTML>
END_OF_HTML_CODE

    exit;

    #
    #  END OF SUB
    #
}
}
}
1
