###########################################
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################
# Name: post
# Usage: &post();
# Update: 09-04-02 Jerome - added require for contenttype.inc
#         08-27-02 Jerome - replaced text with variables for multilingual
#         7-9-99   Adam Kaplan - commmented
#         10-23-98 mike - added "Root Certificate Rollover" Link
#         10-22-98 mike - adding email to authenticated, and dropping
#                  initials option
#         7-31-98  art  - modified to work for auth or non auth boards
#         6-26-98  mike - script calls wwwboard.pl not auth-wwwboard.pl,
#                  for compatib.
#         5-20-98 mike - allowed larger box for PIN to allow for Prof pswd
#                      - made Full Name default option
#         5-16-98 mike - changed textarea from 55 x 10 to 80 x 20
# Status: writing
# Purpose: post a message to a discussion board

sub post {

if(param('action') eq "Rank Posting"){            #ranking the post
  require "$BASE/wwwboard/rank.pm";
  &rank_entry();
  exit(0);
}


$basedir=`pwd`;   #  main directory is your present working directory
($base) = ($basedir =~ /\$DOCUMENT_ROOT\/(.*)/i);
$basedir= "$DOCUMENT_ROOT/$base";     # should end in wwwboard
$baseurl="http://$SERVER_NAME/$base";    
$cgi_url = "$SERVER_NAME/$base/post.pl"; # calls post.pl
$authenticated=param('authenticated'); 
open(IN,"<auth.inc");   # read auth.inc
$oldline=$/;
undef $/;
$checkauth=<IN>;  # feed auth.inc into variable $checkauth
close(IN);
($authvalue)=($checkauth=~/authenticated='(.)'/sig);
if ($authvalue!=$authenticated) {   # authenticating
  if ($authvalue==1) {
    # print "Content-type: text/html\n\n";
    require "$BASE/contenttype.inc"; # enable charset
    print "<html><title>$_AUTHENTICATIONCHECK</title>\n";
    print "<form method=post action=http://$cgi_url >";
    print "<input type=hidden name=origemail value=",param('origemail'),"  >\n";
    print "<input type=hidden name=origname value=',param('origname'),'  >\n";
    print "<input type=hidden name=origsubject value=\"",param('origsubject'),"\"  >\n";
    print "<input type=hidden name=origdate value=\"",param('origdate'),"\"  >\n";
    print "<input type=hidden name=followup value=",param('followup'),"  >\n";
    print "<input type=hidden name=authenticated value=1 >\n";
    print "<input type=hidden name=term value=",param('term'),"  >\n";
    print "<input type=hidden name=srs value=",param('srs'),"  >\n";
    print "$_BOARD_CHANGEDTOAUTHENTICATED\n";
    print "<br><input type=submit value='$_SWITCHTOAUTHENTICATED'>";
    print "</form>";
    print "</html>";
    exit;
#    print "Location: https://$cgi_url?followup=",param('followup'),"\&origemail=",param('origemail'),"\&origname=",param('origname'),"\&authenticated=1\&origsubject=",param('origsubject'),"\&origdate=",param('origdate'),"\&term=",param('term'),"\&srs=",param('srs'),"\n\n";
  } else {
    $authenticated='0';   # reseting variable to 0
  }
}
if (param('followup')) {   # the post is a followup to another posting
  $type="Followup";
  # 5-27-98 jason - origname needs to be handled differently than the rest
  # because of the double quotes it may contain (surrouding an image anchor).
  foreach $item ('followup','origemail','origsubject','origdate') {
    $temp="<input type=hidden name=$item value=\"".param("$item")."\">\n";
    push(@hidden_val,$temp);
  }
  $temp = "<input type=hidden name=origname value='".param("origname")."'>\n";
  push(@hidden_val,$temp);

  $regarding=param('origsubject');
  $regarding=" value=\"Re: $regarding\""; # reply to original subject
} else {            # if not a followup
  $type="Message";
  $regarding='';    # it is just a message with no Re:
}

foreach $item ('term','srs') {    # class term  class srs number
  $temp="<input type=hidden name=$item value=\"".param("$item")."\">\n";
  push(@hidden_val,$temp);
}
push(@hidden_val,"<input type=hidden name=authenticated value=$authenticated >");

if ($authenticated == 1) {
  $uid=$ENV{'REMOTE_USER'};
  # see if this is a prof - prefer their email entry
  $cmd = "select email,fullname from profsloc  
          where uid='" . $uid . "'";
  $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
  $sth->execute || die "Can't execute query: $sth->errstr\n";
  ($email, $name) = ($sth->fetchrow_array);
  $poster="prof";
  if(! $email) { # their email was blank  - use master record
    # see if this is a prof
    $cmd = "select email,fullname from REGfaculty  
            where uid='" . $uid . "'";
    $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    ($email, $name) = ($sth->fetchrow_array);
  }
  
  if(! $email && ! $name) {
    # see if this is a TA
    $cmd = "select email,fullname from REGta 
            where uid='" . $uid . "' && term='" . param('term') . "' && srs='" . param('srs') . "'";
    $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    ($email, $name) = ($sth->fetchrow_array);
    $poster="ta";
  }

  if(! $email && ! $name) {
    # see if this is a student
    $cmd = "select email,concat(firstname,' ',lastname) from REGrosters 
            where uid='" . $uid . "' && term='" . param('term') . "' && srs='" . param('srs') . "'";
    $sth = $dbh->prepare($cmd) || die "Can't prepare $cmd: $dbh->errstr\n";
    $sth->execute || die "Can't execute query: $sth->errstr\n";
    ($email, $name) = ($sth->fetchrow_array);
    $poster="student";
  }

  $name_area="$_NAME: $name<br><input type=hidden name=poster value=$poster><input type=hidden name=uid value=$uid><input type=hidden name=name value=\"$name\"> $_EMAIL: <input type=text name=email size=50 value=\"$email\"><br>";
} else {
  $name_area="$_NAME: <input type=text name=\"name\" size=50> <FONT Size=2>[$_REQUIRED]</FONT><br> $_EMAIL: <input type=text name=\"email\" size=50><br>";
} 

#name,email,subject,body,url_title,url,img # values belong to all and are already there
#followup,origname,origemail,origsubject,origdate # only in followup
# <input type=radio name=initials value=handle>Handle <input type=text name=handle><br>
# print "Content-type: text/html\n\n";
require "$BASE/contenttype.inc"; # enable charset
print <<END;
<html><head><title>$_POSTAMESSAGE</title></head>
<BODY BGCOLOR=#FFFFFF>
<center><h2>$_POSTA $type!</h2></center>
<form method=POST action="wwwboard.pl">   
$name_area
$_SUBJECT: <input type=text name="subject" size=50 $regarding>
 <FONT Size=2>[$_REQUIRED]</FONT><br>
$_MESSAGE: <FONT Size=2>[$_REQUIRED]</FONT> - <font color=red>$_HTMLALLOWED</font><br>
<textarea COLS=80 ROWS=20 wrap="virtual" name="body"></textarea><p>

$_OPTIONALLINKURL: <input type=text name="url" size=45><br>
$_LINKTITLE: <input type=text name="url_title" size=50><br>
$_OPTIONALIMAGEURL: <input type=text name="img" size=45><p>
<input type=submit value="$_POSTMESSAGE"> <input type=reset value="$_RESET">
@hidden_val
</form>
</body></html>

END




}
1
