use DBD::mysql;        # using mysql DataBase Driver
####################################################################
# ClassWeb - Copyright (C) 2000 UC Regents & UCLA Social Sciences  #
# Computing. See http://classweb.ucla.edu/license.htm for license. #
####################################################################

# Update: 09-04-02 Jerome - added require for contenttype.inc
# Update: 08-27-02 Jerome - replaced text with variables for multilingual
# took out.  unauthenticated board, for now
# require "/info-data/classweb4/wwwboard/SSCAuthenticate.pm";

##################################################
# Name: rank_entry
# Usage: &rank_entry()
# Update: 3-09-99 jason - created
# Status: not sure
# Purpose: pick an entry point into the script

sub rank_entry{
  if(param('doit') eq "yes"){
    &rank();
  } else {
    &send_rank_page();
  }
}

##################################################
# Name: rank
# Usage: &rank (called with web parameters)
# Update: 3-09-99 jason - created
# Status: not sure
# Purpose: inserts ranking into database
sub rank
{
  require "$BASE/dbvars.pl";     # database vars set here
  require "$BASE/dbopen.pl";
  require "$BASE/dbfuncs.pm";

  my ($sth, $cmd) = ("","");
  # print "Content-type: text/html\r\n\r\n";
  require "$BASE/contenttype.inc"; # enable charset

  my $term = param('term');
  my $srs = param('srs');
  my $uid = param('uid');
  my $pin = param('pin'); 
  my $rank = param('rvalue');
  my $comment = param('comments');
  my $poster = param('poster');
  my $subject = param('subject');
  my $url = param('url');
  my $time = time();
  my $num;

  # if the poster was a prof or a TA $poster will have
  # an <img> tag in it
  if($poster =~ /<img/){
    $poster =~ s/^<img src="(.*)" alt="(.*)">(.*)$/$3/;
    $poster =~ s/^\s+//;
  }

  # cleanup $comment
  $comment =~ s/'/''/g;
  $comment =~ s/"/\\"/g;

  # extract the "article #" from the url
  $url =~ /\/(\d+).php$/;
  $num = $1;

  if(&SSCAuthenticate($term, $srs, $uid, $pin, "", undef)){
    $cmd = "insert into ranking values ('$term', '$srs', $num, $rank, '$comment', NOW(), '$url', '$subject', '$poster')";

    unless ($sth = $dbh->prepare($cmd)) {
      print "$_CANTPREPARE $cmd: " . $dbh->errstr . "!\n";
      exit(0);
    }

    unless ($sth->execute) {
      print "$_CANTEXECUTEQUERY: " . $sth->errstr ."\n";
      exit(0);
    }
    print "$_RANKINGACCEPTED\n";
  } else {
    print "$_AUTHENTICATIONFAILED: $!\n";
  }

  exit(0);
}

##################################################
# Name: send_rank_page
# Usage: &send_rank_page 
# Update: 3-09-99 jason - created
# Status: not sure
# Purpose: allows ranking of postings
sub send_rank_page
{
  my($basedir, $base, $baseurl, $cgi_url);

  $basedir=`pwd`;
  ($base) = ($basedir =~ /\$DOCUMENT_ROOT\/(.*)/i);
  $basedir= "$DOCUMENT_ROOT/$base";     # should end in wwwboard
  $baseurl="http://$SERVER_NAME/$base";
  #We can assume that the connection will be secure for rankings
  $cgi_url = "http://$SERVER_NAME/$base/post.pl"; # calls post.pl

  # print "Content-type: text/html\r\n\r\n";
  require "$BASE/contenttype.inc"; # enable charset
  $followup = param('followup');
  $poster = param('origname');
  $subject = param('origsubject');
  $term = param('term');
  $srs = param('srs');
  print << "EOF";
<html>
<head>
<title>$_RANKAPOSTING</title>
</head>
<body bgcolor="#FFFFFF">
<form method="post" action="$cgi_url">
<input type='hidden' name='url' value='$baseurl/messages/$followup.php'>
<input type='hidden' name='poster' value='$poster'>
<input type='hidden' name='subject' value='$subject'>
<input type='hidden' name='doit' value='yes'>
<input type='hidden' name='term' value='$term'>
<input type='hidden' name='srs' value='$srs'>

$_UID: <input type=text name="uid" size=9>
$_PINCODE: <input type=password name="pin" size="10" maxlength="10"><br>
<p>
$_RANKING_1_100: <input name="rvalue"><br>
$_COMMENTS: <textarea name="comments" rows="5" cols="72">
</textarea>
<p>
<input type="submit" name="action" value="$_RANKPOSTING">
<input type="reset" value="$_CLEARVALUES">
</form>
</body>
</html>
EOF
}
1
